  //var placeSearch, autocomplete;
  var autoCompleteSettings = {types: ['(cities)']};

  const ADDRESSES_SEPARATOR = '^^';
  const DATA_SEPARATOR = '!!';
  const CITY = 'CITY';
  const GEO_LOCATION_MARKER_TEMPLATE = '';
  const GEO_INPUT_TEMPLATE = '<span class="specific-location">{LOCATION}</span>';
  const GEO_INPUT_REMOVE_FIELD_TEMPLATE = '<button class="remove-autocomplete" data-pos="{DATA_POS}"><i class="fa fa-times-circle-o" aria-hidden="true"></i></button>';
  const GEO_INPUT_TEMPLATE_CONTAINER = '<div class="locationField">'+GEO_LOCATION_MARKER_TEMPLATE+GEO_INPUT_TEMPLATE+GEO_INPUT_REMOVE_FIELD_TEMPLATE+'</div>';

  // Page Visit HTML Templates
  const PAGE_VISIT_OPERATOR_TEMPLATE = '<span class="ifso-page-visit-operator-field">{OPERATOR}: </span>'
  const PAGE_VISIT_INPUT_TEMPLATE_CONTAINER = '<div class="locationField">'+PAGE_VISIT_OPERATOR_TEMPLATE+"</br>"+GEO_INPUT_TEMPLATE+GEO_INPUT_REMOVE_FIELD_TEMPLATE+'</div>';

  // data
  const continents =  [{"name" : "Africa", "code" : "AF"}, {"name" : "Antarctica", "code" : "AN"}, {"name" : "Asia", "code" : "AS"}, {"name" : "Europe", "code" : "EU"}, {"name" : "North America", "code" : "NA"}, {"name" : "Oceania", "code" : "OC"}, {"name" : "South America", "code" : "SA"} ];

  const states = [{"code": "AF-BDS", "name": "Badakhshān"}, {"code": "AF-BDG", "name": "Bādghīs"}, {"code": "AF-BGL", "name": "Baghlān"}, {"code": "AF-BAL", "name": "Balkh"}, {"code": "AF-BAM", "name": "Bāmīān"}, {"code": "AF-FRA", "name": "Farāh"}, {"code": "AF-FYB", "name": "Fāryāb"}, {"code": "AF-GHA", "name": "Ghaznī"}, {"code": "AF-GHO", "name": "Ghowr"}, {"code": "AF-HEL", "name": "Helmand"}, {"code": "AF-HER", "name": "Herāt"}, {"code": "AF-JOW", "name": "Jowzjān"}, {"code": "AF-KAB", "name": "Kabul (Kābol)"}, {"code": "AF-KAN", "name": "Kandahār"}, {"code": "AF-KAP", "name": "Kāpīsā"}, {"code": "AF-KNR", "name": "Konar (Kunar)"}, {"code": "AF-KDZ", "name": "Kondoz (Kunduz)"}, {"code": "AF-LAG", "name": "Laghmān"}, {"code": "AF-LOW", "name": "Lowgar"}, {"code": "AF-NAN", "name": "Nangrahār (Nangarhār)"}, {"code": "AF-NIM", "name": "Nīmrūz"}, {"code": "AF-ORU", "name": "Orūzgān (Urūzgā"}, {"code": "AF-PIA", "name": "Paktīā"}, {"code": "AF-PKA", "name": "Paktīkā"}, {"code": "AF-PAR", "name": "Parwān"}, {"code": "AF-SAM", "name": "Samangān"}, {"code": "AF-SAR", "name": "Sar-e Pol"}, {"code": "AF-TAK", "name": "Takhār"}, {"code": "AF-WAR", "name": "Wardak (Wardag)"}, {"code": "AF-ZAB", "name": "Zābol (Zābul)"}, {"code": "AL-BR", "name": "Berat"}, {"code": "AL-BU", "name": "Bulqizë"}, {"code": "AL-DL", "name": "Delvinë"}, {"code": "AL-DV", "name": "Devoll"}, {"code": "AL-DI", "name": "Dibër"}, {"code": "AL-DR", "name": "Durrës"}, {"code": "AL-EL", "name": "Elbasan"}, {"code": "AL-FR", "name": "Fier"}, {"code": "AL-GR", "name": "Gramsh"}, {"code": "AL-GJ", "name": "Gjirokastër"}, {"code": "AL-HA", "name": "Has"}, {"code": "AL-KA", "name": "Kavajë"}, {"code": "AL-ER", "name": "Kolonjë"}, {"code": "AL-KO", "name": "Korcë"}, {"code": "AL-KR", "name": "Krujë"}, {"code": "AL-KC", "name": "Kucovë"}, {"code": "AL-KU", "name": "Kukës"}, {"code": "AL-LA", "name": "Laç"}, {"code": "AL-LE", "name": "Lezhë"}, {"code": "AL-LB", "name": "Librazhd"}, {"code": "AL-LU", "name": "Lushnjë"}, {"code": "AL-MM", "name": "Malësia e Madhe"}, {"code": "AL-MK", "name": "Mallakastër"}, {"code": "AL-MT", "name": "Mat"}, {"code": "AL-MR", "name": "Mirditë"}, {"code": "AL-PQ", "name": "Peqin"}, {"code": "AL-PR", "name": "Përmet"}, {"code": "AL-PG", "name": "Pogradec"}, {"code": "AL-PU", "name": "Pukë"}, {"code": "AL-SR", "name": "Sarandë"}, {"code": "AL-SK", "name": "Skrapar"}, {"code": "AL-SH", "name": "Shkodër"}, {"code": "AL-TE", "name": "Tepelenë"}, {"code": "AL-TR", "name": "Tiranë"}, {"code": "AL-TP", "name": "Tropojë"}, {"code": "AL-VL", "name": "Vlorë"}, {"code": "DZ-01", "name": "Adrar (Algeria)"}, {"code": "DZ-44", "name": "Aïn Defla"}, {"code": "DZ-46", "name": "Aïn Témouchent"}, {"code": "DZ-16", "name": "Alger"}, {"code": "DZ-05", "name": "Batna"}, {"code": "DZ-08", "name": "Béchar"}, {"code": "DZ-06", "name": "Béjaïa"}, {"code": "DZ-07", "name": "Biskra"}, {"code": "DZ-09", "name": "Blida"}, {"code": "DZ-34", "name": "Bordj Bou Arréridj"}, {"code": "DZ-10", "name": "Bouira"}, {"code": "DZ-35", "name": "Boumerdès"}, {"code": "DZ-02", "name": "Chlef"}, {"code": "DZ-25", "name": "Constantine"}, {"code": "DZ-17", "name": "Djelfa"}, {"code": "DZ-32", "name": "El Bayadh"}, {"code": "DZ-39", "name": "El Oued"}, {"code": "DZ-36", "name": "El Tarf"}, {"code": "DZ-47", "name": "Ghardaïa"}, {"code": "DZ-24", "name": "Guelma"}, {"code": "DZ-33", "name": "Illizi"}, {"code": "DZ-18", "name": "Jijel"}, {"code": "DZ-40", "name": "Khenchela"}, {"code": "DZ-03", "name": "Laghouat"}, {"code": "DZ-29", "name": "Mascara"}, {"code": "DZ-26", "name": "Médéa"}, {"code": "DZ-43", "name": "Mila"}, {"code": "DZ-27", "name": "Mostaganem"}, {"code": "DZ-28", "name": "Msila"}, {"code": "DZ-45", "name": "Naama"}, {"code": "DZ-31", "name": "Oran"}, {"code": "DZ-30", "name": "Ouargla"}, {"code": "DZ-04", "name": "Oum el Bouaghi"}, {"code": "DZ-48", "name": "Relizane"}, {"code": "DZ-20", "name": "Saïda"}, {"code": "DZ-19", "name": "Sétif"}, {"code": "DZ-22", "name": "Sidi Bel Abbès"}, {"code": "DZ-21", "name": "Skikda"}, {"code": "DZ-41", "name": "Souk Ahras"}, {"code": "DZ-11", "name": "Tamanghasset"}, {"code": "DZ-12", "name": "Tébessa"}, {"code": "DZ-14", "name": "Tiaret"}, {"code": "DZ-37", "name": "Tindouf"}, {"code": "DZ-42", "name": "Tipaza"}, {"code": "DZ-38", "name": "Tissemsilt"}, {"code": "DZ-15", "name": "Tizi Ouzou"}, {"code": "DZ-13", "name": "Tlemcen"}, {"code": "AS-AS", "name": "American Samoa (American Samoa)"}, {"code": "AD-AD", "name": "Andorra"}, {"code": "AO-BGO", "name": "Bengo"}, {"code": "AO-BGU", "name": "Benguela"}, {"code": "AO-BIE", "name": "Bié"}, {"code": "AO-CAB", "name": "Cabinda"}, {"code": "AO-CCU", "name": "Cuando-Cubango"}, {"code": "AO-CNO", "name": "Cuanza Norte"}, {"code": "AO-CUS", "name": "Cuanza Sul"}, {"code": "AO-CNN", "name": "Cunene"}, {"code": "AO-HUA", "name": "Huambo"}, {"code": "AO-HUI", "name": "Huíla"}, {"code": "AO-LUA", "name": "Luanda"}, {"code": "AO-LNO", "name": "Lunda Norte"}, {"code": "AO-LSU", "name": "Lunda Sul"}, {"code": "AO-MAL", "name": "Malange"}, {"code": "AO-MOX", "name": "Moxico"}, {"code": "AO-NAM", "name": "Namibe"}, {"code": "AO-UIG", "name": "Uíge"}, {"code": "AO-ZAI", "name": "Zaïre"}, {"code": "AI-AI", "name": "Anguilla"}, {"code": "AQ-AQ", "name": "Antarctica"}, {"code": "AG-AG", "name": "Antigua & Barbuda"}, {"code": "AR-C", "name": "Capital federal"}, {"code": "AR-B", "name": "Buenos Aires"}, {"code": "AR-K", "name": "Catamarca"}, {"code": "AR-X", "name": "Córdoba (Argentina)"}, {"code": "AR-W", "name": "Corrientes"}, {"code": "AR-H", "name": "Chaco"}, {"code": "AR-U", "name": "Chubut"}, {"code": "AR-E", "name": "Entre Ríos"}, {"code": "AR-P", "name": "Formosa"}, {"code": "AR-Y", "name": "Jujuy"}, {"code": "AR-L", "name": "La Pampa"}, {"code": "AR-F", "name": "La Rioja (Argentina)"}, {"code": "AR-M", "name": "Mendoza"}, {"code": "AR-N", "name": "Misiones (Argentina)"}, {"code": "AR-Q", "name": "Neuquén"}, {"code": "AR-R", "name": "Río Negro (Argentina)"}, {"code": "AR-A", "name": "Salta"}, {"code": "AR-J", "name": "San Juan (Argentina)"}, {"code": "AR-D", "name": "San Luis"}, {"code": "AR-Z", "name": "Santa Cruz (Argentina)"}, {"code": "AR-S", "name": "Santa Fe"}, {"code": "AR-G", "name": "Santiago del Estero"}, {"code": "AR-V", "name": "Tierra del Fuego"}, {"code": "AR-T", "name": "Tucumán"}, {"code": "AM-ER", "name": "Erevan"}, {"code": "AM-AG", "name": "Aragacotn"}, {"code": "AM-AR", "name": "Ararat"}, {"code": "AM-AV", "name": "Armavir"}, {"code": "AM-GR", "name": "Geģark'unik'"}, {"code": "AM-KT", "name": "Kotayk'"}, {"code": "AM-LO", "name": "Loŕy"}, {"code": "AM-SH", "name": "Širak"}, {"code": "AM-SU", "name": "Syunik'"}, {"code": "AM-TV", "name": "Tavuš"}, {"code": "AM-VD", "name": "Vayoc Jor"}, {"code": "AW-AW", "name": "Aruba"}, {"code": "AU-NSW", "name": "New South Wales"}, {"code": "AU-QLD", "name": "Queensland"}, {"code": "AU-SA", "name": "South Australia"}, {"code": "AU-TAS", "name": "Tasmania"}, {"code": "AU-VIC", "name": "Victoria"}, {"code": "AU-WA", "name": "Western Australia"}, {"code": "AU-ACT", "name": "Australian Capital Territory"}, {"code": "AU-NT", "name": "Northern Territory"}, {"code": "AT-1", "name": "Burgenland"}, {"code": "AT-2", "name": "Kärnten"}, {"code": "AT-3", "name": "Niederösterreich"}, {"code": "AT-4", "name": "Oberösterreich"}, {"code": "AT-5", "name": "Salzburg"}, {"code": "AT-6", "name": "Steiermark"}, {"code": "AT-7", "name": "Tirol"}, {"code": "AT-8", "name": "Vorarlberg"}, {"code": "AT-9", "name": "Wien"}, {"code": "AZ-MM", "name": "Naxçivan"}, {"code": "AZ-AB", "name": "Äli Bayramli"}, {"code": "AZ-BA", "name": "Baki"}, {"code": "AZ-GA", "name": "Gäncä"}, {"code": "AZ-LA", "name": "Länkäran (Azerbaijan)"}, {"code": "AZ-MI", "name": "Mingäçevir"}, {"code": "AZ-NA", "name": "Naftalan"}, {"code": "AZ-SA", "name": "Şäki (Azerbaijan)"}, {"code": "AZ-SM", "name": "Sumqayit"}, {"code": "AZ-SS", "name": "Şuşa (Azerbaijan)"}, {"code": "AZ-XA", "name": "Xankändi"}, {"code": "AZ-YE", "name": "Yevlax (Azerbaijan)"}, {"code": "AZ-ABS", "name": "Abşeron"}, {"code": "AZ-AGC", "name": "Ağcabädi"}, {"code": "AZ-AGM", "name": "Ağdam"}, {"code": "AZ-AGS", "name": "Ağdas"}, {"code": "AZ-AGA", "name": "Ağstafa"}, {"code": "AZ-AGU", "name": "Ağsu"}, {"code": "AZ-AST", "name": "Astara"}, {"code": "AZ-BAB", "name": "Babäk"}, {"code": "AZ-BAL", "name": "Balakän"}, {"code": "AZ-BAR", "name": "Bärdä"}, {"code": "AZ-BEY", "name": "Beyläqan"}, {"code": "AZ-BIL", "name": "Biläsuvar"}, {"code": "AZ-CAB", "name": "Cäbrayil"}, {"code": "AZ-CAL", "name": "Cälilabad"}, {"code": "AZ-CUL", "name": "Culfa"}, {"code": "AZ-DAS", "name": "Daşkäsän"}, {"code": "AZ-DAV", "name": "Däväçi"}, {"code": "AZ-FUZ", "name": "Füzuli"}, {"code": "AZ-GAD", "name": "Gädäbäy"}, {"code": "AZ-GOR", "name": "Goranboy"}, {"code": "AZ-GOY", "name": "Göyçay"}, {"code": "AZ-HAC", "name": "Haciqabul"}, {"code": "AZ-IMI", "name": "Imişli"}, {"code": "AZ-ISM", "name": "Ismayilli"}, {"code": "AZ-KAL", "name": "Kälbäcär"}, {"code": "AZ-KUR", "name": "Kürdämir"}, {"code": "AZ-LAC", "name": "Laçin"}, {"code": "AZ-LAN", "name": "Länkäran (Azerbaijan)"}, {"code": "AZ-LER", "name": "Lerik"}, {"code": "AZ-MAS", "name": "Masalli"}, {"code": "AZ-NEF", "name": "Neftçala"}, {"code": "AZ-OGU", "name": "Oğuz"}, {"code": "AZ-ORD", "name": "Ordubad"}, {"code": "AZ-QAB", "name": "Qäbälä"}, {"code": "AZ-QAX", "name": "Qax"}, {"code": "AZ-QAZ", "name": "Qazax"}, {"code": "AZ-QOB", "name": "Qobustan"}, {"code": "AZ-QBA", "name": "Quba"}, {"code": "AZ-QBI", "name": "Qubadlı"}, {"code": "AZ-QUS", "name": "Qusar"}, {"code": "AZ-SAT", "name": "Saatli"}, {"code": "AZ-SAB", "name": "Sabirabad"}, {"code": "AZ-SAD", "name": "Sädäräk"}, {"code": "AZ-SAH", "name": "Şahbuz"}, {"code": "AZ-SAK", "name": "Şäki (Azerbaijan)"}, {"code": "AZ-SAL", "name": "Salyan"}, {"code": "AZ-SMI", "name": "Şamaxı"}, {"code": "AZ-SKR", "name": "Şämkir"}, {"code": "AZ-SMX", "name": "Samux"}, {"code": "AZ-SAR", "name": "Şärur"}, {"code": "AZ-SIY", "name": "Siyäzän"}, {"code": "AZ-SUS", "name": "Şuşa (Azerbaijan)"}, {"code": "AZ-TAR", "name": "Tärtär"}, {"code": "AZ-TOV", "name": "Tovuz"}, {"code": "AZ-UCA", "name": "Ucar"}, {"code": "AZ-XAC", "name": "Xaçmaz"}, {"code": "AZ-XAN", "name": "Xanlar"}, {"code": "AZ-XIZ", "name": "Xizi"}, {"code": "AZ-XCI", "name": "Xocalı"}, {"code": "AZ-XVD", "name": "Xocavänd"}, {"code": "AZ-YAR", "name": "Yardimli"}, {"code": "AZ-YEV", "name": "Yevlax (Azerbaijan)"}, {"code": "AZ-ZAN", "name": "Zängılan"}, {"code": "AZ-ZAQ", "name": "Zaqatala"}, {"code": "AZ-ZAR", "name": "Zärdab"}, {"code": "BS-AC", "name": "Acklins and Crooked Islands"}, {"code": "BS-BI", "name": "Bimini"}, {"code": "BS-CI", "name": "Cat Island"}, {"code": "BS-EX", "name": "Exuma"}, {"code": "BS-FP", "name": "Freeport"}, {"code": "BS-FC", "name": "Fresh Creek"}, {"code": "BS-GH", "name": "Governor's Harbour"}, {"code": "BS-GT", "name": "Green Turtle Cay"}, {"code": "BS-HI", "name": "Harbour Island"}, {"code": "BS-HR", "name": "High Rock"}, {"code": "BS-IN", "name": "Inagua"}, {"code": "BS-KB", "name": "Kemps Bay"}, {"code": "BS-LI", "name": "Long Island"}, {"code": "BS-MH", "name": "Marsh Harbour"}, {"code": "BS-MG", "name": "Mayaguana"}, {"code": "BS-NP", "name": "New Providence"}, {"code": "BS-NB", "name": "Nicholls Town and Berry Islands"}, {"code": "BS-RI", "name": "Ragged Island"}, {"code": "BS-RS", "name": "Rock Sound"}, {"code": "BS-SP", "name": "Sandy Point"}, {"code": "BS-SR", "name": "San Salvador and Rum Cay"}, {"code": "BH-01", "name": "Al Ḩadd"}, {"code": "BH-03", "name": "Al Manāmah"}, {"code": "BH-10", "name": "Al Minţaqah al Gharbīyah"}, {"code": "BH-07", "name": "Al Minţaqah al Wusţa"}, {"code": "BH-05", "name": "Al Minţaqah ash Shamālīyah"}, {"code": "BH-02", "name": "Al Muḩarraq"}, {"code": "BH-09", "name": "Ar Rifā‘"}, {"code": "BH-04", "name": "Jidd Ḩafş"}, {"code": "BH-12", "name": "Madīnat Ḩamad"}, {"code": "BH-08", "name": "Madīnat ‘Īsá"}, {"code": "BH-11", "name": "Minţaqat Juzur Ḩawār"}, {"code": "BH-06", "name": "Sitrah"}, {"code": "BD-1", "name": "Barisal bibhag"}, {"code": "BD-1B", "name": "Barisal anchal"}, {"code": "BD-1Q", "name": "Patuakhali anchal"}, {"code": "BD-2", "name": "Chittagong bibhag"}, {"code": "BD-2A", "name": "Bandarban anchal"}, {"code": "BD-2D", "name": "Chittagong anchal"}, {"code": "BD-2E", "name": "Chittagong Hill Tracts"}, {"code": "BD-2F", "name": "Comilla anchal"}, {"code": "BD-2O", "name": "Noakhali anchal"}, {"code": "BD-2T", "name": "Sylhet anchal"}, {"code": "BD-3", "name": "Dhaka bibhag"}, {"code": "BD-3G", "name": "Dhaka anchal"}, {"code": "BD-3I", "name": "Faridpur anchal"}, {"code": "BD-3J", "name": "Jamalpur anchal"}, {"code": "BD-3N", "name": "Mymensingh anchal"}, {"code": "BD-3U", "name": "Tangail anchal"}, {"code": "BD-4", "name": "Khulna bibhag"}, {"code": "BD-4K", "name": "Jessore anchal"}, {"code": "BD-4L", "name": "Khulna anchal"}, {"code": "BD-4M", "name": "Khustia anchal"}, {"code": "BD-5", "name": "Rajshahi bibhag"}, {"code": "BD-5C", "name": "Bogra anchal"}, {"code": "BD-5H", "name": "Dinajpur anchal"}, {"code": "BD-5P", "name": "Pabna anchal"}, {"code": "BD-5R", "name": "Rajshahi anchal"}, {"code": "BD-5S", "name": "Rangpur anchal"}, {"code": "BB-BB", "name": "Barbados"}, {"code": "BY-BR", "name": "Brestskaya voblasts'"}, {"code": "BY-HO", "name": "Homyel'skaya voblasts’"}, {"code": "BY-HR", "name": "Hrodnenskaya voblasts'"}, {"code": "BY-MA", "name": "Mahilyowskaya voblasts'"}, {"code": "BY-MI", "name": "Minskaya voblasts'"}, {"code": "BY-VI", "name": "Vitsyebskaya voblasts'"}, {"code": "BE-BRU", "name": "Bruxelles-Capitale, Region de (fr), Brussels Hoofdstedelijk Gewest (nl)"}, {"code": "BE-VLG", "name": "Vlaamse Gewest (nl)"}, {"code": "BE-VAN", "name": "Antwerpen (nl)"}, {"code": "BE-VLI", "name": "Limburg (nl)"}, {"code": "BE-VOV", "name": "Oost-Vlaanderen (nl)"}, {"code": "BE-VBR", "name": "Vlaams Brabant (nl)"}, {"code": "BE-VWV", "name": "West-Vlaanderen (nl)"}, {"code": "BE-WAL", "name": "Wallonne, Region (fr)"}, {"code": "BE-WBR", "name": "Brabant Wallon (fr)"}, {"code": "BE-WHT", "name": "Hainaut (fr)"}, {"code": "BE-WLG", "name": "Liège (fr)"}, {"code": "BE-WLX", "name": "Luxembourg (fr)"}, {"code": "BE-WNA", "name": "Namur (fr)"}, {"code": "BZ-BZ", "name": "Belize"}, {"code": "BZ-CY", "name": "Cayo"}, {"code": "BZ-CZL", "name": "Corozal"}, {"code": "BZ-OW", "name": "Orange Walk"}, {"code": "BZ-SC", "name": "Stann Creek"}, {"code": "BZ-TOL", "name": "Toledo (Belize)"}, {"code": "BJ-AK", "name": "Atakora"}, {"code": "BJ-AQ", "name": "Atlantique"}, {"code": "BJ-BO", "name": "Borgou"}, {"code": "BJ-MO", "name": "Mono"}, {"code": "BJ-OU", "name": "Ouémé"}, {"code": "BJ-ZO", "name": "Zou"}, {"code": "BM-BM", "name": "Bermuda"}, {"code": "BT-33", "name": "Bumthang"}, {"code": "BT-12", "name": "Chhukha"}, {"code": "BT-22", "name": "Dagana"}, {"code": "BT-GA", "name": "Gasa"}, {"code": "BT-13", "name": "Ha"}, {"code": "BT-44", "name": "Lhuentse"}, {"code": "BT-42", "name": "Monggar"}, {"code": "BT-11", "name": "Paro"}, {"code": "BT-43", "name": "Pemagatshel"}, {"code": "BT-23", "name": "Punakha"}, {"code": "BT-45", "name": "Samdrup Jongkha"}, {"code": "BT-14", "name": "Samtse"}, {"code": "BT-31", "name": "Sarpang"}, {"code": "BT-15", "name": "Thimphu"}, {"code": "BT-41", "name": "Trashigang"}, {"code": "BT-TY", "name": "Trashi Yangtse"}, {"code": "BT-32", "name": "Trongsa"}, {"code": "BT-21", "name": "Tsirang"}, {"code": "BT-24", "name": "Wangdue Phodrang"}, {"code": "BT-34", "name": "Zhemgang"}, {"code": "BO-C", "name": "Cochabamba"}, {"code": "BO-H", "name": "Chuquisaca"}, {"code": "BO-B", "name": "El Beni"}, {"code": "BO-L", "name": "La Paz (Bolivia)"}, {"code": "BO-O", "name": "Oruro"}, {"code": "BO-N", "name": "Pando"}, {"code": "BO-P", "name": "Potosi"}, {"code": "BO-S", "name": "Santa Cruz (Bolivia)"}, {"code": "BO-T", "name": "Tarija"}, {"code": "BA-BIH", "name": "Federacija Bosna i Hercegovina"}, {"code": "BA-SRP", "name": "Republika Srpska"}, {"code": "BW-CE", "name": "Central [Serowe-Palapye]"}, {"code": "BW-CH", "name": "Chobe"}, {"code": "BW-GH", "name": "Ghanzi"}, {"code": "BW-KG", "name": "Kgalagadi"}, {"code": "BW-KL", "name": "Kgatleng"}, {"code": "BW-KW", "name": "Kweneng"}, {"code": "BW-NG", "name": "Ngamiland [North-West]"}, {"code": "BW-NE", "name": "North-East"}, {"code": "BW-SE", "name": "South-East"}, {"code": "BW-SO", "name": "Southern [Ngwaketse]"}, {"code": "BV-BV", "name": "Bouvet Island"}, {"code": "BR-DF", "name": "Distrito Federal (Brazil)"}, {"code": "BR-AC", "name": "Acre"}, {"code": "BR-AL", "name": "Alagoas"}, {"code": "BR-AP", "name": "Amapá"}, {"code": "BR-AM", "name": "Amazonas (Brazil)"}, {"code": "BR-BA", "name": "Bahia"}, {"code": "BR-CE", "name": "Ceará"}, {"code": "BR-ES", "name": "Espírito Santo"}, {"code": "BR-GO", "name": "Goiás"}, {"code": "BR-MA", "name": "Maranhāo"}, {"code": "BR-MT", "name": "Mato Grosso"}, {"code": "BR-MS", "name": "Mato Grosso do Sul"}, {"code": "BR-MG", "name": "Minas Gerais"}, {"code": "BR-PA", "name": "Pará"}, {"code": "BR-PB", "name": "Paraíba"}, {"code": "BR-PR", "name": "Paraná"}, {"code": "BR-PE", "name": "Pernambuco"}, {"code": "BR-PI", "name": "Piauí"}, {"code": "BR-RJ", "name": "Rio de Janeiro"}, {"code": "BR-RN", "name": "Rio Grande do Norte"}, {"code": "BR-RS", "name": "Rio Grande do Sul"}, {"code": "BR-R0", "name": "Rondônia"}, {"code": "BR-RR", "name": "Roraima"}, {"code": "BR-SC", "name": "Santa Catarina (Brazil)"}, {"code": "BR-SP", "name": "São Paulo"}, {"code": "BR-SE", "name": "Sergipe"}, {"code": "BR-TO", "name": "Tocantins"}, {"code": "IO-IO", "name": "British Indian Ocean Territory"}, {"code": "BN-BE", "name": "Belait"}, {"code": "BN-BM", "name": "Brunei-Muara"}, {"code": "BN-TE", "name": "Temburong"}, {"code": "BN-TU", "name": "Tutong"}, {"code": "BG-02", "name": "Burgas"}, {"code": "BG-09", "name": "Haskovo"}, {"code": "BG-04", "name": "Loveč"}, {"code": "BG-05", "name": "Montana (Bulgaria)"}, {"code": "BG-06", "name": "Plovdiv"}, {"code": "BG-07", "name": "Ruse"}, {"code": "BG-08", "name": "Sofija"}, {"code": "BG-01", "name": "Sofija-Grad"}, {"code": "BG-03", "name": "Varna"}, {"code": "BF-BAL", "name": "Balé"}, {"code": "BF-BAM", "name": "Bam"}, {"code": "BF-BAN", "name": "Banwa"}, {"code": "BF-BAZ", "name": "Bazèga"}, {"code": "BF-BGR", "name": "Bougouriba"}, {"code": "BF-BLG", "name": "Boulgou"}, {"code": "BF-BLK", "name": "Boulkiemdé"}, {"code": "BF-COM", "name": "Comoé"}, {"code": "BF-GAN", "name": "Ganzourgou"}, {"code": "BF-GNA", "name": "Gnagna"}, {"code": "BF-GOU", "name": "Gourma"}, {"code": "BF-HOU", "name": "Houet"}, {"code": "BF-IOB", "name": "Ioba"}, {"code": "BF-KAD", "name": "Kadiogo"}, {"code": "BF-KEN", "name": "Kénédougou"}, {"code": "BF-KMD", "name": "Komondjari"}, {"code": "BF-KMP", "name": "Kompienga"}, {"code": "BF-KOS", "name": "Kossi"}, {"code": "BF-KOP", "name": "Koulpélogo"}, {"code": "BF-KOT", "name": "Kouritenga"}, {"code": "BF-KOW", "name": "Kourwéogo"}, {"code": "BF-LER", "name": "Léraba"}, {"code": "BF-LOR", "name": "Loroum"}, {"code": "BF-MOU", "name": "Mouhoun"}, {"code": "BF-NAO", "name": "Nahouri"}, {"code": "BF-NAM", "name": "Namentenga"}, {"code": "BF-NAY", "name": "Nayala"}, {"code": "BF-NOU", "name": "Noumbiel"}, {"code": "BF-OUB", "name": "Oubritenga"}, {"code": "BF-OUD", "name": "Oudalan"}, {"code": "BF-PAS", "name": "Passoré"}, {"code": "BF-PON", "name": "Poni"}, {"code": "BF-SNG", "name": "Sanguié"}, {"code": "BF-SMT", "name": "Sanmatenga"}, {"code": "BF-SEN", "name": "Séno"}, {"code": "BF-SIS", "name": "Sissili"}, {"code": "BF-SOM", "name": "Soum"}, {"code": "BF-SOR", "name": "Sourou"}, {"code": "BF-TAP", "name": "Tapoa"}, {"code": "BF-TUI", "name": "Tui"}, {"code": "BF-YAG", "name": "Yagha"}, {"code": "BF-YAT", "name": "Yatenga"}, {"code": "BF-ZIR", "name": "Ziro"}, {"code": "BF-ZON", "name": "Zondoma"}, {"code": "BF-ZOU", "name": "Zoundwéogo"}, {"code": "BI-BB", "name": "Bubanza"}, {"code": "BI-BJ", "name": "Bujumbura"}, {"code": "BI-BR", "name": "Bururi"}, {"code": "BI-CA", "name": "Cankuzo"}, {"code": "BI-CI", "name": "Cibitoke"}, {"code": "BI-GI", "name": "Gitega"}, {"code": "BI-KR", "name": "Karuzi"}, {"code": "BI-KY", "name": "Kayanza"}, {"code": "BI-KI", "name": "Kirundo"}, {"code": "BI-MA", "name": "Makamba"}, {"code": "BI-MU", "name": "Muramvya"}, {"code": "BI-MY", "name": "Muyinga"}, {"code": "BI-NG", "name": "Ngozi"}, {"code": "BI-RT", "name": "Rutana"}, {"code": "BI-RY", "name": "Ruyigi"}, {"code": "KH-23", "name": "Krong Kaeb [Krŏng Kêb]"}, {"code": "KH-18", "name": "Krong Preah Sihanouk [Krŏng Preăh Sihanouk]"}, {"code": "KH-12", "name": "Phnom Penh [Phnum Pénh]"}, {"code": "KH-2", "name": "Baat Dambang [Bătdâmbâng]"}, {"code": "KH-1", "name": "Banteay Mean Chey [Bântéay Méanchey]"}, {"code": "KH-3", "name": "Kampong Chaam [Kâmpóng Cham]"}, {"code": "KH-4", "name": "Kampong Chhnang [Kâmpóng Chhnăng]"}, {"code": "KH-5", "name": "Kampong Spueu [Kâmpóng Spœ]"}, {"code": "KH-6", "name": "Kampong Thum [Kâmpóng Thum]"}, {"code": "KH-7", "name": "Kampot [Kâmpôt]"}, {"code": "KH-8", "name": "Kandaal [Kândal]"}, {"code": "KH-10", "name": "Kracheh [Krâchéh]"}, {"code": "KH-11", "name": "Mond01 Kiri [Môndól Kiri]"}, {"code": "KH-22", "name": "Otdar Mean Chey [Ŏtdâr Méanchey]"}, {"code": "KH-15", "name": "Pousaat [Poŭthĭsăt]"}, {"code": "KH-13", "name": "Preah Vihear [Preăh Vihéar]"}, {"code": "KH-14", "name": "Prey Veaeng [Prey Vêng]"}, {"code": "KH-16", "name": "Rotanak Kiri [Rôtânôkiri]"}, {"code": "KH-17", "name": "Siem Reab [Siĕmréab]"}, {"code": "KH-19", "name": "Stueng Traeng [Stœng Trêng]"}, {"code": "KH-20", "name": "Svaay Rieng [Svay Riĕng]"}, {"code": "KH-21", "name": "Taakaev [Takêv]"}, {"code": "CM-AD", "name": "Adamaoua"}, {"code": "CM-CE", "name": "Centre (Cameroon)"}, {"code": "CM-ES", "name": "Est (Cameroon)"}, {"code": "CM-EN", "name": "Far North"}, {"code": "CM-LT", "name": "Littoral"}, {"code": "CM-NO", "name": "North"}, {"code": "CM-NW", "name": "North-West"}, {"code": "CM-SU", "name": "South"}, {"code": "CM-SW", "name": "South-West"}, {"code": "CM-OU", "name": "West"}, {"code": "CA-AB", "name": "Alberta"}, {"code": "CA-BC", "name": "British Columbia (Colombie-Britannique)"}, {"code": "CA-MB", "name": "Manitoba"}, {"code": "CA-NB", "name": "New Brunswick (Nouveau-Brunswick)"}, {"code": "CA-NL", "name": "Newfoundland and Labrador (Terre-Neuve)"}, {"code": "CA-NS", "name": "Nova Scotia (Nouvelle-Écosse)"}, {"code": "CA-ON", "name": "Ontario"}, {"code": "CA-PE", "name": "Prince Edward Island (Île-du-Prince-Édouard)"}, {"code": "CA-QC", "name": "Quebec (Québec)"}, {"code": "CA-SK", "name": "Saskatchewan"}, {"code": "CA-NT", "name": "Northwest Territories (Territoires du Nord-Ouest)"}, {"code": "CA-NU", "name": "Nunavut"}, {"code": "CA-YT", "name": "Yukon Territory (Teritoire du Yukon)"}, {"code": "CV-B", "name": "Ilhas de Barlavento"}, {"code": "CV-BV", "name": "Boa Vista"}, {"code": "CV-PA", "name": "Paul"}, {"code": "CV-PN", "name": "Porto Novo"}, {"code": "CV-RG", "name": "Ribeira Grande"}, {"code": "CV-SL", "name": "Sal"}, {"code": "CV-SN", "name": "Sāo Nicolau"}, {"code": "CV-SV", "name": "Sāo Vicente"}, {"code": "CV-S", "name": "Ilhas de Sotavento"}, {"code": "CV-BR", "name": "Brava"}, {"code": "CV-FO", "name": "Fogo"}, {"code": "CV-MA", "name": "Maio"}, {"code": "CV-PR", "name": "Praia"}, {"code": "CV-CA", "name": "Santa Catarina (Cape Verde)"}, {"code": "CV-CR", "name": "Santa Cruz (Cape Verde)"}, {"code": "CV-TA", "name": "Tarrafal"}, {"code": "KY-KY", "name": "Cayman Islands"}, {"code": "CF-BGF", "name": "Bangui"}, {"code": "CF-BB", "name": "Bamingui-Bangoran"}, {"code": "CF-BK", "name": "Basse-Kotto"}, {"code": "CF-HK", "name": "Haute-Kotto"}, {"code": "CF-HM", "name": "Haut-Mbomou"}, {"code": "CF-KG", "name": "Kémo"}, {"code": "CF-LB", "name": "Lobaye"}, {"code": "CF-HS", "name": "Mambéré-Kadéï"}, {"code": "CF-MB", "name": "Mbomou"}, {"code": "CF-KB", "name": "Nana-Grébizi"}, {"code": "CF-NM", "name": "Nana-Mambéré"}, {"code": "CF-MP", "name": "Ombella-Mpoko"}, {"code": "CF-UK", "name": "Ouaka"}, {"code": "CF-AC", "name": "Ouham"}, {"code": "CF-OP", "name": "Ouham-Pendé"}, {"code": "CF-SE", "name": "Sangha-Mbaéré"}, {"code": "CF-VK", "name": "Vakaga"}, {"code": "TD-BA", "name": "Batha"}, {"code": "TD-BI", "name": "Biltine"}, {"code": "TD-BET", "name": "Borkou-Ennedi-Tibesti"}, {"code": "TD-CB", "name": "Chari-Baguirmi"}, {"code": "TD-GR", "name": "Guéra"}, {"code": "TD-KA", "name": "Kanem"}, {"code": "TD-LC", "name": "Lac"}, {"code": "TD-LO", "name": "Logone-Occidental"}, {"code": "TD-LR", "name": "Logone-Oriental"}, {"code": "TD-MK", "name": "Mayo-Kébbi"}, {"code": "TD-MC", "name": "Moyen-Chari"}, {"code": "TD-OD", "name": "Ouaddaï"}, {"code": "TD-SA", "name": "Salamat"}, {"code": "TD-TA", "name": "Tandjilé"}, {"code": "CL-AI", "name": "Aisén del General Carlos Ibáñiez del Campo"}, {"code": "CL-AN", "name": "Antofagasta"}, {"code": "CL-AR", "name": "Araucanía"}, {"code": "CL-AT", "name": "Atacama"}, {"code": "CL-BI", "name": "Bío-Bío"}, {"code": "CL-CO", "name": "Coquimbo"}, {"code": "CL-LI", "name": "Libertador General Bernardo O'Higgins"}, {"code": "CL-LL", "name": "Los Lagos"}, {"code": "CL-MA", "name": "Magallanes"}, {"code": "CL-ML", "name": "Maule"}, {"code": "CL-RM", "name": "Regíon Metropolitana de Santiago"}, {"code": "CL-TA", "name": "Tarapacá"}, {"code": "CL-VS", "name": "Valparaiso"}, {"code": "CN-11", "name": "Beijing"}, {"code": "CN-50", "name": "Chongqing"}, {"code": "CN-31", "name": "Shanghai"}, {"code": "CN-12", "name": "Tianjin"}, {"code": "CN-34", "name": "Anhui"}, {"code": "CN-35", "name": "Fujian"}, {"code": "CN-62", "name": "Gansu"}, {"code": "CN-44", "name": "Guangdong"}, {"code": "CN-52", "name": "Guizhou"}, {"code": "CN-46", "name": "Hainan"}, {"code": "CN-13", "name": "Hebei"}, {"code": "CN-23", "name": "Heilongjiang"}, {"code": "CN-41", "name": "Henan"}, {"code": "CN-42", "name": "Hubei"}, {"code": "CN-43", "name": "Hunan"}, {"code": "CN-32", "name": "Jiangsu"}, {"code": "CN-36", "name": "Jiangxi"}, {"code": "CN-22", "name": "Jilin"}, {"code": "CN-21", "name": "Liaoning"}, {"code": "CN-63", "name": "Qinghai"}, {"code": "CN-61", "name": "Shaanxi"}, {"code": "CN-37", "name": "Shandong"}, {"code": "CN-14", "name": "Shanxi"}, {"code": "CN-51", "name": "Sichuan"}, {"code": "CN-71", "name": "Taiwan"}, {"code": "CN-53", "name": "Yunnan"}, {"code": "CN-33", "name": "Zhejiang"}, {"code": "CN-45", "name": "Guangxi"}, {"code": "CN-15", "name": "Nei Monggol"}, {"code": "CN-64", "name": "Ningxia"}, {"code": "CN-65", "name": "Xinjiang"}, {"code": "CN-54", "name": "Xizang"}, {"code": "CN-91", "name": "Hong Kong (China)"}, {"code": "CX-CX", "name": "Christmas Island"}, {"code": "CC-CC", "name": "Cocos (Keeling) Islands"}, {"code": "CO-DC", "name": "Distrito Capital de Santa Fe de Bogota"}, {"code": "CO-AMA", "name": "Amazonas (Colombia)"}, {"code": "CO-ANT", "name": "Antioguia"}, {"code": "CO-ARA", "name": "Arauca"}, {"code": "CO-ATL", "name": "Atlántico"}, {"code": "CO-BOL", "name": "Bolívar (Colombia)"}, {"code": "CO-BOY", "name": "Boyacá"}, {"code": "CO-CAL", "name": "Caldas"}, {"code": "CO-CAQ", "name": "Caquetá"}, {"code": "CO-CAS", "name": "Casanare"}, {"code": "CO-CAU", "name": "Cauca"}, {"code": "CO-CES", "name": "Cesar"}, {"code": "CO-COR", "name": "Córdoba (Colombia)"}, {"code": "CO-CUN", "name": "Cundinamarca"}, {"code": "CO-CHO", "name": "Chocó"}, {"code": "CO-GUA", "name": "Guainía"}, {"code": "CO-GUV", "name": "Guaviare"}, {"code": "CO-HUI", "name": "Huila"}, {"code": "CO-LAG", "name": "La Guajira"}, {"code": "CO-MAG", "name": "Magdalena"}, {"code": "CO-MET", "name": "Meta"}, {"code": "CO-NAR", "name": "Nariño"}, {"code": "CO-NSA", "name": "Norte de Santander"}, {"code": "CO-PUT", "name": "Putumayo"}, {"code": "CO-QUI", "name": "Quindío"}, {"code": "CO-RIS", "name": "Risaralda"}, {"code": "CO-SAP", "name": "San Andrés, Providencia y Santa Catalina"}, {"code": "CO-SAN", "name": "Santander"}, {"code": "CO-SUC", "name": "Sucre (Colombia)"}, {"code": "CO-TOL", "name": "Tolima"}, {"code": "CO-VAC", "name": "Valle del Cauca"}, {"code": "CO-VAU", "name": "Vaupés"}, {"code": "CO-VID", "name": "Vichada"}, {"code": "KM-A", "name": "Anjouan (Ndzouani)"}, {"code": "KM-G", "name": "Grande Comore (Ngazidja)"}, {"code": "KM-M", "name": "Mohéli (Moili)"}, {"code": "CG-BZV", "name": "Brazzaville"}, {"code": "CG-11", "name": "Bouenza"}, {"code": "CG-8", "name": "Cuvette"}, {"code": "CG-15", "name": "Cuvette-Ouest"}, {"code": "CG-5", "name": "Kouilou"}, {"code": "CG-2", "name": "Lékoumou"}, {"code": "CG-7", "name": "Likouala"}, {"code": "CG-9", "name": "Niari"}, {"code": "CG-14", "name": "Plateaux (Congo)"}, {"code": "CG-12", "name": "Pool"}, {"code": "CG-13", "name": "Sangha"}, {"code": "CD-KN", "name": "Kinshasa"}, {"code": "CD-BN", "name": "Bandundu"}, {"code": "CD-BC", "name": "Bas-Congo"}, {"code": "CD-EQ", "name": "Équateur"}, {"code": "CD-HC", "name": "Haut-Congo"}, {"code": "CD-KW", "name": "Kasai-Occidental"}, {"code": "CD-KE", "name": "Kasai-Oriental"}, {"code": "CD-KA", "name": "Katanga"}, {"code": "CD-MA", "name": "Maniema"}, {"code": "CD-NK", "name": "Nord-Kivu"}, {"code": "CD-SK", "name": "Sud-Kivu"}, {"code": "CK-CK", "name": "Cook Islands"}, {"code": "CR-A", "name": "Alajuela"}, {"code": "CR-C", "name": "Cartago"}, {"code": "CR-G", "name": "Guanacaste"}, {"code": "CR-H", "name": "Heredia"}, {"code": "CR-L", "name": "Limón"}, {"code": "CR-P", "name": "Puntarenas"}, {"code": "CR-SJ", "name": "San José (Costa Rica)"}, {"code": "CI-06", "name": "18 Montagnes (Région des)"}, {"code": "CI-16", "name": "Agnébi (Région de l')"}, {"code": "CI-09", "name": "Bas-Sassandra (Région du)"}, {"code": "CI-10", "name": "Denguélé (Région du)"}, {"code": "CI-02", "name": "Haut-Sassandra (Région du)"}, {"code": "CI-07", "name": "Lacs (Région des)"}, {"code": "CI-01", "name": "Lagunes (Région des)"}, {"code": "CI-12", "name": "Marahoué (Région de la)"}, {"code": "CI-05", "name": "Moyen-Comoé (Région du)"}, {"code": "CI-11", "name": "Nzi-Comoé (Région)"}, {"code": "CI-03", "name": "Savanes (Région des)"}, {"code": "CI-15", "name": "Sud-Bandama (Région du)"}, {"code": "CI-13", "name": "Sud-Comoé (Région du)"}, {"code": "CI-04", "name": "Vallée du Bandama (Région de la)"}, {"code": "CI-14", "name": "Worodougou (Région du)"}, {"code": "CI-08", "name": "Zanzan (Région du)"}, {"code": "HR-07", "name": "Bjelovarsko-bilogorska županija"}, {"code": "HR-12", "name": "Brodsko-posavska županija"}, {"code": "HR-19", "name": "Dubrovačko-neretvanska županija"}, {"code": "HR-18", "name": "Istarska županija"}, {"code": "HR-04", "name": "Karlovačka županija"}, {"code": "HR-06", "name": "Koprivničkco-križevačka županija"}, {"code": "HR-02", "name": "Krapinsko-zagorska županija"}, {"code": "HR-09", "name": "Ličko-senjska županija"}, {"code": "HR-20", "name": "Medjimurska županija"}, {"code": "HR-14", "name": "Osječko-baranjska županija"}, {"code": "HR-11", "name": "Požeško-slavonska županija"}, {"code": "HR-08", "name": "Primorsko-goranska županija"}, {"code": "HR-03", "name": "Sisaško-moslavačka županija"}, {"code": "HR-17", "name": "Splitsko-dalmatinska županija"}, {"code": "HR-15", "name": "Šibensko-kninska županija"}, {"code": "HR-05", "name": "Varaždinska županija"}, {"code": "HR-10", "name": "Virovitičko-podravska županija"}, {"code": "HR-16", "name": "Vukovarsko-srijemska županija"}, {"code": "HR-13", "name": "Zadarska županija"}, {"code": "HR-01", "name": "Zagrebačka županija"}, {"code": "CU-09", "name": "Camagüey"}, {"code": "CU-03", "name": "Ciudad de La Habana"}, {"code": "CU-12", "name": "Granma"}, {"code": "CU-14", "name": "Guantánamo"}, {"code": "CU-11", "name": "Holguín"}, {"code": "CU-02", "name": "La Habana"}, {"code": "CU-10", "name": "Las Tunas"}, {"code": "CU-04", "name": "Matanzas"}, {"code": "CU-01", "name": "Pinar del Río"}, {"code": "CU-07", "name": "Sancti Spíritus"}, {"code": "CU-13", "name": "Santiago de Cuba"}, {"code": "CU-05", "name": "Villa Clara"}, {"code": "CU-99", "name": "Isla de la Juventud"}, {"code": "CY-04", "name": "Ammochostos (Mağusa)"}, {"code": "CY-06", "name": "Keryneia (Girne)"}, {"code": "CY-03", "name": "Larnaka"}, {"code": "CY-01", "name": "Lefkosia (Lefkoşa)"}, {"code": "CY-02", "name": "Lemesos (Leymosun)"}, {"code": "CY-05", "name": "Pafos (Baf)"}, {"code": "CZ-PRG", "name": "Praha"}, {"code": "CZ-CJC", "name": "Jihočeský kraj"}, {"code": "CZ-CJM", "name": "Jihomoravský kraj"}, {"code": "CZ-CSC", "name": "Severočeský kraj"}, {"code": "CZ-CSM", "name": "Severomoravský kraj"}, {"code": "CZ-CST", "name": "Středočeský kraj"}, {"code": "CZ-CVC", "name": "Východočeský kraj"}, {"code": "CZ-CZC", "name": "Západočeský kraj"}, {"code": "DK-147", "name": "Frederiksberg"}, {"code": "DK-101", "name": "Kǿbenhavn (Denmark)"}, {"code": "DK-040", "name": "Bornholm"}, {"code": "DK-020", "name": "Frederiksborg"}, {"code": "DK-042", "name": "Fyn"}, {"code": "DK-015", "name": "Kǿbenhavn (Denmark)"}, {"code": "DK-080", "name": "Nordjylland"}, {"code": "DK-055", "name": "Ribe"}, {"code": "DK-065", "name": "Ringkǿbing"}, {"code": "DK-025", "name": "Roskilde"}, {"code": "DK-035", "name": "Storstrǿm"}, {"code": "DK-050", "name": "Sǿnderjylland"}, {"code": "DK-060", "name": "Vejle"}, {"code": "DK-030", "name": "Vestsjælland"}, {"code": "DK-076", "name": "Viborg"}, {"code": "DK-070", "name": "Århus"}, {"code": "DJ-AS", "name": "Ali Sabieh"}, {"code": "DJ-DI", "name": "Dikhil"}, {"code": "DJ-DJ", "name": "Djibouti"}, {"code": "DJ-OB", "name": "Obock"}, {"code": "DJ-TA", "name": "Tadjoura"}, {"code": "DM-DM", "name": "Dominica"}, {"code": "DO-DN", "name": "Distrito National (Santo Domingo)"}, {"code": "DO-AZ", "name": "Azua"}, {"code": "DO-BR", "name": "Bahoruco"}, {"code": "DO-BH", "name": "Barahona"}, {"code": "DO-DA", "name": "Dajabón"}, {"code": "DO-DU", "name": "Duarte"}, {"code": "DO-SE", "name": "El Seibo"}, {"code": "DO-EP", "name": "La Estrelleta [Elías Piña]"}, {"code": "DO-HM", "name": "Hato Mayor"}, {"code": "DO-IN", "name": "Independencia"}, {"code": "DO-AL", "name": "La Altagracia"}, {"code": "DO-RO", "name": "La Romana"}, {"code": "DO-VE", "name": "La Vega"}, {"code": "DO-MT", "name": "María Trinidad Sánchez"}, {"code": "DO-MN", "name": "Monseñor Nouel"}, {"code": "DO-MC", "name": "Monte Cristi"}, {"code": "DO-MP", "name": "Monte Plata"}, {"code": "DO-PN", "name": "Pedernales"}, {"code": "DO-PR", "name": "Peravia"}, {"code": "DO-PP", "name": "Puerto Plata"}, {"code": "DO-SC", "name": "Salcedo"}, {"code": "DO-SM", "name": "Samaná"}, {"code": "DO-SZ", "name": "Sanchez Ramírez"}, {"code": "DO-CR", "name": "San Cristóbal"}, {"code": "DO-JU", "name": "San Juan (Dominican Republic)"}, {"code": "DO-PM", "name": "San Pedro de Macorís"}, {"code": "DO-ST", "name": "Santiago"}, {"code": "DO-SR", "name": "Santiago Rodríguez"}, {"code": "DO-VA", "name": "Valverde"}, {"code": "TP-TP", "name": "East Timor"}, {"code": "EC-A", "name": "Azuay"}, {"code": "EC-B", "name": "Bolívar (Ecuador)"}, {"code": "EC-F", "name": "Cañar"}, {"code": "EC-C", "name": "Carchi"}, {"code": "EC-X", "name": "Cotopaxi"}, {"code": "EC-H", "name": "Chimborazo"}, {"code": "EC-O", "name": "El Oro"}, {"code": "EC-E", "name": "Esmeraldas"}, {"code": "EC-W", "name": "Galápagos"}, {"code": "EC-G", "name": "Guayas"}, {"code": "EC-I", "name": "Imbabura"}, {"code": "EC-L", "name": "Loja"}, {"code": "EC-R", "name": "Los Ríos"}, {"code": "EC-M", "name": "Manabí"}, {"code": "EC-S", "name": "Morona-Santiago"}, {"code": "EC-N", "name": "Napo"}, {"code": "EC-Y", "name": "Pastaza"}, {"code": "EC-P", "name": "Pichincha"}, {"code": "EC-U", "name": "Sucumbíos"}, {"code": "EC-T", "name": "Tungurahua"}, {"code": "EC-Z", "name": "Zarnora-Chinchipe"}, {"code": "EG-DK", "name": "Ad Daqahlīyah"}, {"code": "EG-BA", "name": "Al Baḩr al Aḩmar (Egypt)"}, {"code": "EG-BH", "name": "Al Buḩayrah"}, {"code": "EG-FYM", "name": "Al Fayyūm"}, {"code": "EG-GH", "name": "Al Gharbīyah"}, {"code": "EG-ALX", "name": "Al Iskandarīyah"}, {"code": "EG-IS", "name": "Al Ismā‘īlīyah"}, {"code": "EG-GZ", "name": "Al Jīzah"}, {"code": "EG-MNF", "name": "Al Minūfīyah"}, {"code": "EG-MN", "name": "Al Minyā"}, {"code": "EG-C", "name": "Al Qāhirah"}, {"code": "EG-KB", "name": "Al Qalyūbīyah"}, {"code": "EG-WAD", "name": "Al Wādī al Jadīd"}, {"code": "EG-SHR", "name": "Ash Sharqīyah (Egypt)"}, {"code": "EG-SUZ", "name": "As Suways"}, {"code": "EG-ASN", "name": "Aswān"}, {"code": "EG-AST", "name": "Asyūţ"}, {"code": "EG-BNS", "name": "Banī Suwayf"}, {"code": "EG-PTS", "name": "Būr Sa‘īd"}, {"code": "EG-DT", "name": "Dumyāţ"}, {"code": "EG-JS", "name": "Janūb Sīnā'"}, {"code": "EG-KFS", "name": "Kafr ash Shaykh"}, {"code": "EG-MT", "name": "Maţrūḩ"}, {"code": "EG-KN", "name": "Qinā"}, {"code": "EG-SIN", "name": "Shamāl Sīnā'"}, {"code": "EG-SHG", "name": "Sūhāj"}, {"code": "SV-AH", "name": "Ahuachapán"}, {"code": "SV-CA", "name": "Cabañas"}, {"code": "SV-CU", "name": "Cuscatlán"}, {"code": "SV-CH", "name": "Chalatenango"}, {"code": "SV-LI", "name": "La Libertad (El Salvador)"}, {"code": "SV-PA", "name": "La Paz (El Salvador)"}, {"code": "SV-UN", "name": "La Unión"}, {"code": "SV-MO", "name": "Morazán"}, {"code": "SV-SM", "name": "San Miguel"}, {"code": "SV-SS", "name": "San Salvador"}, {"code": "SV-SA", "name": "Santa Ana"}, {"code": "SV-SV", "name": "San Vicente"}, {"code": "SV-SO", "name": "Sonsonate"}, {"code": "SV-SU", "name": "Usulután"}, {"code": "GQ-C", "name": "Región Continental"}, {"code": "GQ-CS", "name": "Centro Sur"}, {"code": "GQ-KN", "name": "Kie-Ntem"}, {"code": "GQ-LI", "name": "Litoral"}, {"code": "GQ-WN", "name": "Wele-Nzás"}, {"code": "GQ-I", "name": "Región Insular"}, {"code": "GQ-AN", "name": "Annobón"}, {"code": "GQ-BN", "name": "Bioko Norte"}, {"code": "GQ-BS", "name": "Bioko Sur"}, {"code": "ER-AG", "name": "Akele Guzai [Akalä Guzay]"}, {"code": "ER-AS", "name": "Asmara [Asmära]"}, {"code": "ER-BA", "name": "Barka"}, {"code": "ER-DE", "name": "Denkalia [Dänkali]"}, {"code": "ER-GS", "name": "Gash-Setit [Gaš enna Sätit]"}, {"code": "ER-HA", "name": "Hamasien [Hamasén]"}, {"code": "ER-SA", "name": "Sahel"}, {"code": "ER-SM", "name": "Semhar [Sämhar]"}, {"code": "ER-SN", "name": "Senhit [Sänhet]"}, {"code": "ER-SR", "name": "Seraye [Särayé]"}, {"code": "EE-37", "name": "Harjumaa"}, {"code": "EE-39", "name": "Hiiumaa"}, {"code": "EE-44", "name": "Ida-Virumaa"}, {"code": "EE-49", "name": "Jōgevamaa"}, {"code": "EE-51", "name": "Järvamaa"}, {"code": "EE-57", "name": "Läänemaa"}, {"code": "EE-59", "name": "Lääne-Virumaa"}, {"code": "EE-65", "name": "Pōlvamaa"}, {"code": "EE-67", "name": "Pärnumaa"}, {"code": "EE-70", "name": "Raplamaa"}, {"code": "EE-74", "name": "Saaremaa"}, {"code": "EE-78", "name": "Tartumaa"}, {"code": "EE-82", "name": "Valgamaa"}, {"code": "EE-84", "name": "Viljandimaa"}, {"code": "EE-86", "name": "Vōrumaa"}, {"code": "ET-AA", "name": "Addis Ababa [Addis Abeba]"}, {"code": "ET-AF", "name": "Afar"}, {"code": "ET-AM", "name": "Amara [Amhara]"}, {"code": "ET-BE", "name": "Benshangul-Gumaz [Bénishangul]"}, {"code": "ET-GA", "name": "Gambela Peoples [Gambéla]"}, {"code": "ET-HA", "name": "Harari People [Harer]"}, {"code": "ET-OR", "name": "Oromia [Oromo]"}, {"code": "ET-SO", "name": "Somali"}, {"code": "ET-SN", "name": "Southern Nations, Nationalities and Peoples"}, {"code": "ET-TI", "name": "Tigrai [Tegré]"}, {"code": "FK-FK", "name": "Falkland Islands (Malvinas)"}, {"code": "FO-FO", "name": "Faroe Islands"}, {"code": "FJ-C", "name": "Central (Fiji)"}, {"code": "FJ-E", "name": "Eastern (Fiji)"}, {"code": "FJ-N", "name": "Northern (Fiji)"}, {"code": "FJ-W", "name": "Western (Fiji)"}, {"code": "FJ-R", "name": "Rotuma"}, {"code": "FI-AL", "name": "Ahvenanmaan lääni"}, {"code": "FI-ES", "name": "Etelä-Suomen lääni"}, {"code": "FI-IS", "name": "Itä-Suomen lääni"}, {"code": "FI-LL", "name": "Lapin lääni"}, {"code": "FI-LS", "name": "Länsi-Suomen lääni"}, {"code": "FI-OL", "name": "Oulun lääni"}, {"code": "FR-A", "name": "Alsace"}, {"code": "FR-67", "name": "Bas-Rhin"}, {"code": "FR-68", "name": "Haut-Rhin"}, {"code": "FR-B", "name": "Aquitaine"}, {"code": "FR-79", "name": "Deux-Sèvres"}, {"code": "FR-24", "name": "Dordogne"}, {"code": "FR-33", "name": "Gironde"}, {"code": "FR-40", "name": "Landes"}, {"code": "FR-47", "name": "Lot-et-Garonne"}, {"code": "FR-64", "name": "Pyrénées-Atlantiques"}, {"code": "FR-C", "name": "Auvergne"}, {"code": "FR-03", "name": "Allier"}, {"code": "FR-15", "name": "Cantal"}, {"code": "FR-43", "name": "Haute-Loire"}, {"code": "FR-63", "name": "Puy-de-Dôme"}, {"code": "FR-P", "name": "Basse-Normandie"}, {"code": "FR-14", "name": "Calvados"}, {"code": "FR-50", "name": "Manche"}, {"code": "FR-61", "name": "Orne"}, {"code": "FR-D", "name": "Bourgogne"}, {"code": "FR-21", "name": "Côte-d'Or"}, {"code": "FR-58", "name": "Nièvre"}, {"code": "FR-71", "name": "Saône-et-Loire"}, {"code": "FR-89", "name": "Yonne"}, {"code": "FR-E", "name": "Bretagne"}, {"code": "FR-22", "name": "Cotes-d'Armor"}, {"code": "FR-29", "name": "Finistère"}, {"code": "FR-35", "name": "Ille-et-Vilaine"}, {"code": "FR-56", "name": "Morbihan"}, {"code": "FR-F", "name": "Centre (France)"}, {"code": "FR-18", "name": "Cher"}, {"code": "FR-28", "name": "Eure-et-Loir"}, {"code": "FR-36", "name": "Indre"}, {"code": "FR-37", "name": "Indre-et-Loire"}, {"code": "FR-41", "name": "Loir-et-Cher"}, {"code": "FR-45", "name": "Loiret"}, {"code": "FR-G", "name": "Champagne-Ardenne"}, {"code": "FR-08", "name": "Ardennes"}, {"code": "FR-10", "name": "Aube"}, {"code": "FR-52", "name": "Haute-Marne"}, {"code": "FR-51", "name": "Marne"}, {"code": "FR-H", "name": "Corse"}, {"code": "FR-2A", "name": "Corse-du-Sud"}, {"code": "FR-2B", "name": "Haute-Corse"}, {"code": "FR-I", "name": "Franche-Comté"}, {"code": "FR-25", "name": "Doubs"}, {"code": "FR-70", "name": "Haute-Saône"}, {"code": "FR-39", "name": "Jura (France)"}, {"code": "FR-90", "name": "Territoire de Belfort"}, {"code": "FR-Q", "name": "Haute-Normandie"}, {"code": "FR-27", "name": "Eure"}, {"code": "FR-76", "name": "Seine-Maritime"}, {"code": "FR-J", "name": "Île-de-France"}, {"code": "FR-91", "name": "Essonne"}, {"code": "FR-92", "name": "Hauts-de-Seine"}, {"code": "FR-75", "name": "Paris"}, {"code": "FR-77", "name": "Seine-et-Marne"}, {"code": "FR-93", "name": "Seine-Saint-Denis"}, {"code": "FR-94", "name": "Val-de-Marne"}, {"code": "FR-95", "name": "Val-d'Oise"}, {"code": "FR-78", "name": "Yvelines"}, {"code": "FR-K", "name": "Languedoc-Roussillon"}, {"code": "FR-11", "name": "Aude"}, {"code": "FR-30", "name": "Gard"}, {"code": "FR-34", "name": "Hérault"}, {"code": "FR-48", "name": "Lozère"}, {"code": "FR-66", "name": "Pyrénées-Orientales"}, {"code": "FR-L", "name": "Limousin"}, {"code": "FR-19", "name": "Corrèze"}, {"code": "FR-23", "name": "Creuse"}, {"code": "FR-87", "name": "Haute-Vienne"}, {"code": "FR-M", "name": "Lorraine"}, {"code": "FR-54", "name": "Meurthe-et-Moselle"}, {"code": "FR-55", "name": "Meuse"}, {"code": "FR-57", "name": "Moselle"}, {"code": "FR-88", "name": "Vosges"}, {"code": "FR-N", "name": "Midi-Pyrénées"}, {"code": "FR-09", "name": "Ariège"}, {"code": "FR-12", "name": "Aveyron"}, {"code": "FR-32", "name": "Gers"}, {"code": "FR-31", "name": "Haute-Garonne"}, {"code": "FR-65", "name": "Hautes-Pyrénées"}, {"code": "FR-46", "name": "Lot"}, {"code": "FR-81", "name": "Tarn"}, {"code": "FR-82", "name": "Tarn-et-Garonne"}, {"code": "FR-O", "name": "Nord-Pas-de-Calais"}, {"code": "FR-59", "name": "Nord (France)"}, {"code": "FR-62", "name": "Pas-de-Calais"}, {"code": "FR-R", "name": "Pays de la Loire"}, {"code": "FR-44", "name": "Loire-Atlantique"}, {"code": "FR-49", "name": "Maine-et-Loire"}, {"code": "FR-53", "name": "Mayenne"}, {"code": "FR-72", "name": "Sarthe"}, {"code": "FR-85", "name": "Vendée"}, {"code": "FR-S", "name": "Picardie"}, {"code": "FR-02", "name": "Aisne"}, {"code": "FR-60", "name": "Oise"}, {"code": "FR-80", "name": "Somme"}, {"code": "FR-T", "name": "Poitou-Charentes"}, {"code": "FR-16", "name": "Charente"}, {"code": "FR-17", "name": "Charente-Maritime"}, {"code": "FR-86", "name": "Vienne"}, {"code": "FR-U", "name": "Provence-Alpes-Côte d'Azur"}, {"code": "FR-04", "name": "Alpes-de-Haute-Provence"}, {"code": "FR-06", "name": "Alpes-Maritimes"}, {"code": "FR-13", "name": "Bauches-du-Rhône"}, {"code": "FR-05", "name": "Hautes-Alpes"}, {"code": "FR-83", "name": "Var"}, {"code": "FR-84", "name": "Vaucluse"}, {"code": "FR-V", "name": "Rhône-Alpes"}, {"code": "FR-01", "name": "Ain"}, {"code": "FR-07", "name": "Ardèche"}, {"code": "FR-26", "name": "Drôme"}, {"code": "FR-74", "name": "Haute-Savoie"}, {"code": "FR-38", "name": "Isère"}, {"code": "FR-42", "name": "Loire"}, {"code": "FR-69", "name": "Rhône"}, {"code": "FR-73", "name": "Savoie"}, {"code": "FR-GP", "name": "Guadeloupe (France)"}, {"code": "FR-GF", "name": "Guyane (francaise)"}, {"code": "FR-MQ", "name": "Martinique (France)"}, {"code": "FR-RE", "name": "Réunion"}, {"code": "FR-YT", "name": "Mayotte (France)"}, {"code": "FR-PM", "name": "Saint-Pierre-et-Miquelon"}, {"code": "FR-NC", "name": "Nouvelle-Calédonie"}, {"code": "FR-PF", "name": "Polynésie française"}, {"code": "FR-TF", "name": "Terres Australes"}, {"code": "FR-WF", "name": "Wallis et Futuna"}, {"code": "GF-GF", "name": "French Guiana"}, {"code": "PF-PF", "name": "French Polynesia"}, {"code": "TF-TF", "name": "French Southern Territories"}, {"code": "GA-1", "name": "Estuaire"}, {"code": "GA-2", "name": "Haut-Ogooué"}, {"code": "GA-3", "name": "Moyen-Ogooué"}, {"code": "GA-4", "name": "Ngounié"}, {"code": "GA-5", "name": "Nyanga"}, {"code": "GA-6", "name": "Ogooué-Ivindo"}, {"code": "GA-7", "name": "Ogooué-Lolo"}, {"code": "GA-8", "name": "Ogooué-Maritime"}, {"code": "GA-9", "name": "Woleu-Ntem"}, {"code": "GM-B", "name": "Banjul"}, {"code": "GM-L", "name": "Lower River"}, {"code": "GM-M", "name": "MacCarthy Island"}, {"code": "GM-N", "name": "North Bank"}, {"code": "GM-U", "name": "Upper River"}, {"code": "GM-W", "name": "Western (Gambia)"}, {"code": "GE-AB", "name": "Ap'khazet'is Avtonomiuri Respublika [Abkhazia]"}, {"code": "GE-AJ", "name": "Acharis Avtonomiuri Respublika [Ajaria]"}, {"code": "GE-BUS", "name": "Bat'umi"}, {"code": "GE-CHI", "name": "Chiat'ura"}, {"code": "GE-GAG", "name": "Gagra"}, {"code": "GE-GOR", "name": "Gori"}, {"code": "GE-KUT", "name": "K'ut'aisi"}, {"code": "GE-PTI", "name": "P'ot'i"}, {"code": "GE-RUS", "name": "Rust'avi"}, {"code": "GE-SUI", "name": "Sokhumi"}, {"code": "GE-TBS", "name": "T'bilisi"}, {"code": "GE-TQI", "name": "Tqibuli"}, {"code": "GE-TQV", "name": "Tqvarch'eli"}, {"code": "GE-TSQ", "name": "Tsqalmbo"}, {"code": "GE-ZUG", "name": "Zugdidi"}, {"code": "GE-01", "name": "Abashis Raioni"}, {"code": "GE-02", "name": "Adigenis Raioni"}, {"code": "GE-03", "name": "Akhalgoris Raioni"}, {"code": "GE-04", "name": "Akhalk'alak'is Raioni"}, {"code": "GE-05", "name": "Akhalts'ikhis Raioni"}, {"code": "GE-06", "name": "Akhmetis Raioni"}, {"code": "GE-07", "name": "Ambrolauris Raioni"}, {"code": "GE-08", "name": "Aspindzis Raioni"}, {"code": "GE-09", "name": "Baghdat'is Raioni"}, {"code": "GE-10", "name": "Bolnisis Raioni"}, {"code": "GE-11", "name": "Borjomis Raioni"}, {"code": "GE-12", "name": "Ch'khorotsqus Raioni"}, {"code": "GE-13", "name": "Ch'okhatauris Raioni"}, {"code": "GE-14", "name": "Dedop'listsqaros Raioni"}, {"code": "GE-15", "name": "Dmanisis Raioni"}, {"code": "GE-16", "name": "Dushet'is Raioni"}, {"code": "GE-17", "name": "Galis Raioni"}, {"code": "GE-18", "name": "Gardabnis Raioni"}, {"code": "GE-19", "name": "Goris Raioni"}, {"code": "GE-20", "name": "Gudaut'is Raioni"}, {"code": "GE-21", "name": "Gulrip'shis Raioni"}, {"code": "GE-22", "name": "Gurjaanis Raioni"}, {"code": "GE-23", "name": "Javis Raioni"}, {"code": "GE-24", "name": "K'arelis Raioni"}, {"code": "GE-25", "name": "Kaspis Raioni"}, {"code": "GE-26", "name": "K'edis Raioni"}, {"code": "GE-27", "name": "Kharagaulis Raioni"}, {"code": "GE-28", "name": "Khashuris Raioni"}, {"code": "GE-29", "name": "Khelvach'auris Raioni"}, {"code": "GE-30", "name": "Khobis Raioni"}, {"code": "GE-31", "name": "Khonis Raioni"}, {"code": "GE-32", "name": "Khulos Raioni"}, {"code": "GE-33", "name": "K'obuletis Raioni"}, {"code": "GE-34", "name": "Lagodekhis Raioni"}, {"code": "GE-35", "name": "Lanch'khut'is Raioni"}, {"code": "GE-36", "name": "Lentekhis Raioni"}, {"code": "GE-37", "name": "Marneulis Raioni"}, {"code": "GE-38", "name": "Martvilis Raioni"}, {"code": "GE-39", "name": "Mestiis Raioni"}, {"code": "GE-40", "name": "Mts'khet'is Raioni"}, {"code": "GE-41", "name": "Ninotsmindis Raioni"}, {"code": "GE-42", "name": "Och'amch'iris Raioni"}, {"code": "GE-43", "name": "Onis Raioni"}, {"code": "GE-44", "name": "Ozurget'is Raioni"}, {"code": "GE-45", "name": "Qazbegis Raioni"}, {"code": "GE-46", "name": "Qvarlis Raioni"}, {"code": "GE-47", "name": "Sach'kheris Raioni"}, {"code": "GE-48", "name": "Sagarejos Raioni"}, {"code": "GE-49", "name": "Samtrediis Raioni"}, {"code": "GE-50", "name": "Senakis Raioni"}, {"code": "GE-51", "name": "Shuakhevis Raioni"}, {"code": "GE-52", "name": "Sighnaghis Raioni"}, {"code": "GE-53", "name": "Sokhumis Raioni"}, {"code": "GE-54", "name": "T'elavis Raioni"}, {"code": "GE-55", "name": "T'erjolis Raioni"}, {"code": "GE-56", "name": "T'et'ritsqaros Raioni"}, {"code": "GE-57", "name": "T'ianet'is Raioni"}, {"code": "GE-58", "name": "Ts'ageris Raioni"}, {"code": "GE-59", "name": "Tsalenjikhis Raioni"}, {"code": "GE-60", "name": "Tsalkis Raioni"}, {"code": "GE-61", "name": "Vanis Raioni"}, {"code": "GE-62", "name": "Zestap'onis Raioni"}, {"code": "GE-63", "name": "Zugdidis Raioni"}, {"code": "DE-BW", "name": "Baden-Württemberg"}, {"code": "DE-BY", "name": "Bayern"}, {"code": "DE-BE", "name": "Berlin"}, {"code": "DE-BB", "name": "Brandenburg"}, {"code": "DE-HB", "name": "Bremen"}, {"code": "DE-HH", "name": "Hamburg"}, {"code": "DE-HE", "name": "Hessen"}, {"code": "DE-MV", "name": "Mecklenburg-Vorpommern"}, {"code": "DE-NI", "name": "Niedersachsen"}, {"code": "DE-NW", "name": "Nordrhein-Westfalen"}, {"code": "DE-RP", "name": "Rheinland-Pfalz"}, {"code": "DE-SL", "name": "Saarland"}, {"code": "DE-SN", "name": "Sachsen"}, {"code": "DE-ST", "name": "Sachsen-Anhalt"}, {"code": "DE-SH", "name": "Schleswig-Holstein"}, {"code": "DE-TH", "name": "Thüringen"}, {"code": "GH-AH", "name": "Ashanti"}, {"code": "GH-BA", "name": "Brong-Ahafo"}, {"code": "GH-CP", "name": "Central (Ghana)"}, {"code": "GH-EP", "name": "Eastern (Ghana)"}, {"code": "GH-AA", "name": "Greater Accra"}, {"code": "GH-NP", "name": "Northern (Ghana)"}, {"code": "GH-UE", "name": "Upper East"}, {"code": "GH-UW", "name": "Upper West"}, {"code": "GH-TV", "name": "Volta"}, {"code": "GH-WP", "name": "Western (Ghana)"}, {"code": "GI-GI", "name": "Gibraltar"}, {"code": "GB-CHA", "name": "Channel Islands"}, {"code": "GB-GSY", "name": "Guernsey [Guernesey]"}, {"code": "GB-JSY", "name": "Jersey"}, {"code": "GB-ENG", "name": "England"}, {"code": "GB-BDG", "name": "Barking and Dagenham"}, {"code": "GB-BNE", "name": "Barnet"}, {"code": "GB-BNS", "name": "Barnsley"}, {"code": "GB-BAS", "name": "Bath and North East Somerset"}, {"code": "GB-BDF", "name": "Bedfordshire"}, {"code": "GB-BEX", "name": "Bexley"}, {"code": "GB-BIR", "name": "Birmingham (City of)"}, {"code": "GB-BBD", "name": "Blackburn with Darwen"}, {"code": "GB-BPL", "name": "Blackpool"}, {"code": "GB-BOL", "name": "Bolton"}, {"code": "GB-BMH", "name": "Bournemouth"}, {"code": "GB-BRC", "name": "Bracknell Forest"}, {"code": "GB-BRD", "name": "Bradford (City of)"}, {"code": "GB-BEN", "name": "Brent"}, {"code": "GB-BNH", "name": "Brighton and Hove"}, {"code": "GB-BST", "name": "Bristol, City of"}, {"code": "GB-BRY", "name": "Bromley"}, {"code": "GB-BKM", "name": "Buckinghamshire"}, {"code": "GB-BUR", "name": "Bury"}, {"code": "GB-CLD", "name": "Calderdale"}, {"code": "GB-CAM", "name": "Cambridgeshire"}, {"code": "GB-CMD", "name": "Camden"}, {"code": "GB-CHS", "name": "Cheshire"}, {"code": "GB-CON", "name": "Cornwall"}, {"code": "GB-COV", "name": "Coventry (City of)"}, {"code": "GB-CRY", "name": "Croydon"}, {"code": "GB-CMA", "name": "Cumbria"}, {"code": "GB-DAL", "name": "Darlington"}, {"code": "GB-DER", "name": "Derby (City of)"}, {"code": "GB-DBY", "name": "Derbyshire"}, {"code": "GB-DEV", "name": "Devon"}, {"code": "GB-DNC", "name": "Doncaster"}, {"code": "GB-DOR", "name": "Dorset"}, {"code": "GB-DUD", "name": "Dudley"}, {"code": "GB-DUR", "name": "Durharn"}, {"code": "GB-EAL", "name": "Ealing"}, {"code": "GB-ERY", "name": "East Riding of Yorkshire"}, {"code": "GB-ESX", "name": "East Sussex"}, {"code": "GB-ENF", "name": "Enfield"}, {"code": "GB-ESS", "name": "Essex"}, {"code": "GB-GAT", "name": "Gateshead"}, {"code": "GB-GLS", "name": "Gloucestershire"}, {"code": "GB-GRE", "name": "Greenwich"}, {"code": "GB-HCK", "name": "Hackney"}, {"code": "GB-HAL", "name": "Haiton"}, {"code": "GB-HMF", "name": "Hammersmith and Fulham"}, {"code": "GB-HAM", "name": "Hampshire"}, {"code": "GB-HRY", "name": "Haringey"}, {"code": "GB-HRW", "name": "Harrow"}, {"code": "GB-HPL", "name": "Hartlepool"}, {"code": "GB-HAV", "name": "Havering"}, {"code": "GB-HEF", "name": "Herefordshire, County of"}, {"code": "GB-HRT", "name": "Hertfordshire"}, {"code": "GB-HIL", "name": "Hillingdon"}, {"code": "GB-HNS", "name": "Hounslow"}, {"code": "GB-IOW", "name": "Isle of Wight"}, {"code": "GB-IOS", "name": "Isles of Scilly"}, {"code": "GB-ISL", "name": "Islington"}, {"code": "GB-KEC", "name": "Kensington and Chelsea"}, {"code": "GB-KEN", "name": "Kent"}, {"code": "GB-KHL", "name": "Kingston upon Hull, City of"}, {"code": "GB-KTT", "name": "Kingston upon Thames"}, {"code": "GB-KIR", "name": "Kirklees"}, {"code": "GB-KWL", "name": "Knowsley"}, {"code": "GB-LBH", "name": "Lambeth"}, {"code": "GB-LAN", "name": "Lancashire"}, {"code": "GB-LDS", "name": "Leeds (City of)"}, {"code": "GB-LCE", "name": "Leitester (City of)"}, {"code": "GB-LEC", "name": "Leicestershire"}, {"code": "GB-LEW", "name": "Lewisham"}, {"code": "GB-LIN", "name": "Lincolnshire"}, {"code": "GB-LIV", "name": "Liverpool (City of)"}, {"code": "GB-LND", "name": "London, City of"}, {"code": "GB-LUT", "name": "Luton"}, {"code": "GB-MAN", "name": "Manchester (City of)"}, {"code": "GB-MDW", "name": "Medway"}, {"code": "GB-MRT", "name": "Merton"}, {"code": "GB-MDB", "name": "Middlesbrough"}, {"code": "GB-MIK", "name": "Milton Keynes"}, {"code": "GB-NET", "name": "Newcastle upon Tyne (City of)"}, {"code": "GB-NWM", "name": "Newham"}, {"code": "GB-NFK", "name": "Norfolk"}, {"code": "GB-NEL", "name": "North East Lincolnshire"}, {"code": "GB-NLN", "name": "North Lincolnshire"}, {"code": "GB-NSM", "name": "North Somerset"}, {"code": "GB-NTY", "name": "North Tyneside"}, {"code": "GB-NYK", "name": "North Yorkshire"}, {"code": "GB-NTH", "name": "Northamptonshire"}, {"code": "GB-NBL", "name": "Northumberland"}, {"code": "GB-NGM", "name": "Nottingham (City of)"}, {"code": "GB-NTT", "name": "Nottinghamshire"}, {"code": "GB-OLD", "name": "Oldham"}, {"code": "GB-OXF", "name": "Oxfordshire"}, {"code": "GB-PTE", "name": "Peterborough"}, {"code": "GB-PLY", "name": "Plymouth (City of)"}, {"code": "GB-POL", "name": "Poole"}, {"code": "GB-POR", "name": "Portsmouth (City of)"}, {"code": "GB-RDG", "name": "Reading"}, {"code": "GB-RDB", "name": "Redbridge"}, {"code": "GB-RCC", "name": "Redcar and Cleveland"}, {"code": "GB-RIC", "name": "Richmond upon Thames"}, {"code": "GB-RCH", "name": "Rochdale"}, {"code": "GB-ROT", "name": "Rotherharn"}, {"code": "GB-RUT", "name": "Rutland"}, {"code": "GB-SHN", "name": "St. Helens"}, {"code": "GB-SLF", "name": "Salford (City of)"}, {"code": "GB-SAW", "name": "Sandweil"}, {"code": "GB-SFT", "name": "Sefton"}, {"code": "GB-SHF", "name": "Sheffield (City of)"}, {"code": "GB-SHR", "name": "Shropshire"}, {"code": "GB-SLG", "name": "Slough"}, {"code": "GB-SOL", "name": "Solihull"}, {"code": "GB-SOM", "name": "Somerset"}, {"code": "GB-SGC", "name": "South Gloucestershire"}, {"code": "GB-STY", "name": "South Tyneside"}, {"code": "GB-STH", "name": "Southampton (City of)"}, {"code": "GB-SOS", "name": "Southend-on-Sea"}, {"code": "GB-SWK", "name": "Southwark"}, {"code": "GB-STS", "name": "Staffordshire"}, {"code": "GB-SKP", "name": "Stockport"}, {"code": "GB-STT", "name": "Stockton-On-Tees"}, {"code": "GB-STE", "name": "Stoke-on-Trent (City of)"}, {"code": "GB-SFK", "name": "Suffolk"}, {"code": "GB-SND", "name": "Sunderland (City of)"}, {"code": "GB-SRY", "name": "Surrey"}, {"code": "GB-STN", "name": "Sutton"}, {"code": "GB-SWD", "name": "Swindon"}, {"code": "GB-TAM", "name": "Tameside"}, {"code": "GB-TFW", "name": "Telford and Wrekin"}, {"code": "GB-THR", "name": "Thurrock"}, {"code": "GB-TOB", "name": "Torbay"}, {"code": "GB-TWH", "name": "Tower Hamlets"}, {"code": "GB-TRF", "name": "Trafford"}, {"code": "GB-WKF", "name": "Wakefield (City of)"}, {"code": "GB-WLL", "name": "Walsall"}, {"code": "GB-WFT", "name": "Waltham Forest"}, {"code": "GB-WND", "name": "Wandsworth"}, {"code": "GB-WRT", "name": "Warrington"}, {"code": "GB-WAR", "name": "Warwickshire"}, {"code": "GB-WBK", "name": "West Berkshire"}, {"code": "GB-WSX", "name": "West Sussex"}, {"code": "GB-WSM", "name": "Westminster (City of)"}, {"code": "GB-WGN", "name": "Wigan"}, {"code": "GB-WIL", "name": "Wiltshire"}, {"code": "GB-WNM", "name": "Windsor and Maidenhead"}, {"code": "GB-WRL", "name": "Wirral"}, {"code": "GB-WOK", "name": "Wokingham"}, {"code": "GB-WLV", "name": "Wolverhampton"}, {"code": "GB-WOR", "name": "Worcestershire"}, {"code": "GB-YOR", "name": "York (City of)"}, {"code": "GB-IOM", "name": "Isle of Man"}, {"code": "GB-NIR", "name": "Northern Ireland"}, {"code": "GB-ANT", "name": "Antrim"}, {"code": "GB-ARD", "name": "Ards"}, {"code": "GB-ARM", "name": "Armagh"}, {"code": "GB-BLA", "name": "Ballymena"}, {"code": "GB-BLY", "name": "Ballymoney"}, {"code": "GB-BNB", "name": "Banbridge"}, {"code": "GB-BFS", "name": "Belfast (City of)"}, {"code": "GB-CKF", "name": "Carrickfergus"}, {"code": "GB-CSR", "name": "Castlereagh"}, {"code": "GB-CLR", "name": "Coleraine"}, {"code": "GB-CKT", "name": "Cookstown"}, {"code": "GB-CGV", "name": "Craigavon"}, {"code": "GB-DRY", "name": "Derry (City of)"}, {"code": "GB-DOW", "name": "Down"}, {"code": "GB-DGN", "name": "Dungannon"}, {"code": "GB-FER", "name": "Fermanagh"}, {"code": "GB-LRN", "name": "Larne"}, {"code": "GB-LMV", "name": "Limavady"}, {"code": "GB-LSB", "name": "Lisburn"}, {"code": "GB-MFT", "name": "Magherafelt"}, {"code": "GB-MYL", "name": "Moyle"}, {"code": "GB-NYM", "name": "Newry and Mourne"}, {"code": "GB-NTA", "name": "Newtownabbey"}, {"code": "GB-NDN", "name": "North Down"}, {"code": "GB-OMH", "name": "Omagh"}, {"code": "GB-STB", "name": "Strabane"}, {"code": "GB-SCT", "name": "Scotland"}, {"code": "GB-ABE", "name": "Aberdeen City"}, {"code": "GB-ABD", "name": "Aberdeenshire"}, {"code": "GB-ANS", "name": "Angus"}, {"code": "GB-AGB", "name": "Argyll and Bute"}, {"code": "GB-CLK", "name": "Clackmannanshire"}, {"code": "GB-DGY", "name": "Dumfries and Galloway"}, {"code": "GB-DND", "name": "Dundee City"}, {"code": "GB-EAY", "name": "East Ayrshire"}, {"code": "GB-EDU", "name": "East Dunbartonshire"}, {"code": "GB-ELN", "name": "East Lothian"}, {"code": "GB-ERW", "name": "East Renfrewshire"}, {"code": "GB-EDH", "name": "Edinburgh, City of"}, {"code": "GB-ELS", "name": "Eilean Siar"}, {"code": "GB-FAL", "name": "Falkirk"}, {"code": "GB-FIF", "name": "Fife"}, {"code": "GB-GLG", "name": "Glasgow City"}, {"code": "GB-HLD", "name": "Highland"}, {"code": "GB-IVC", "name": "Inverclyde"}, {"code": "GB-MLN", "name": "Midlothian"}, {"code": "GB-MRY", "name": "Moray"}, {"code": "GB-NAY", "name": "North Ayrshire"}, {"code": "GB-NLK", "name": "North Lanarkshire"}, {"code": "GB-ORK", "name": "Orkney Islands"}, {"code": "GB-PKN", "name": "Perth and Kinross"}, {"code": "GB-RFW", "name": "Renfrewshire"}, {"code": "GB-SCB", "name": "Scottish Borders, The"}, {"code": "GB-ZET", "name": "Shetland Islands"}, {"code": "GB-SAY", "name": "South Ayrshire"}, {"code": "GB-SLK", "name": "South Lanarkshire"}, {"code": "GB-STG", "name": "Stirling"}, {"code": "GB-WDU", "name": "West Dunbartonshire"}, {"code": "GB-WLN", "name": "West Lothian"}, {"code": "GB-WLS", "name": "Wales [Cymru]"}, {"code": "GB-BGW", "name": "Blaenau Gwent"}, {"code": "GB-BGE", "name": "Bridgend [Pen-y-bont ar Ogwr GB-POG]"}, {"code": "GB-CAY", "name": "Caerphilly [Caerffili GB-CAF]"}, {"code": "GB-CRF", "name": "Cardiff (City of) [Caerdydd GB-CRD]"}, {"code": "GB-CMN", "name": "Carmarthenshire [Sir Gaerfyrddin GB-GFY]"}, {"code": "GB-CGN", "name": "Ceredigion [Sir Ceredigion]"}, {"code": "GB-CWY", "name": "Conwy"}, {"code": "GB-DEN", "name": "Denbighshire [Sir Ddinbych GB-DDB]"}, {"code": "GB-FLN", "name": "Flintshire [Sir y Fflint GB-FFL]"}, {"code": "GB-GWN", "name": "Gwynedd"}, {"code": "GB-AGY", "name": "Isle of Anglesey [Sir Ynys Man GB-YNM]"}, {"code": "GB-MTY", "name": "Merthyr Tydfil [Merthyr Tudful GB-MTU]"}, {"code": "GB-MON", "name": "Monmouthshire [Sir Fynwy GB-FYN]"}, {"code": "GB-NTL", "name": "Neath Port Talbot [Castell-nedd Port Talbot GB-CTL]"}, {"code": "GB-NWP", "name": "Newport [Casnewydd GB-CNW]"}, {"code": "GB-PEM", "name": "Pembrokeshire [Sir Benfro CB-BNF]"}, {"code": "GB-POW", "name": "Powys"}, {"code": "GB-RCT", "name": "Rhondda, Cynon, Taff [Rhondda, Cynon, Taf]"}, {"code": "GB-SWA", "name": "Swansea (City of) [Abertawe GB-ATA]"}, {"code": "GB-TOF", "name": "Torfaen [Tor-faen]"}, {"code": "GB-VGL", "name": "Vale of Glamorgan, The [Bro Morgannwg GB-BMG]"}, {"code": "GB-WRX", "name": "Wrexham [Wrecsam GB-WRC]"}, {"code": "GR-I", "name": "Anatoliki Makedonia kai Thraki"}, {"code": "GR-52", "name": "Drama"}, {"code": "GR-71", "name": "Evros"}, {"code": "GR-55", "name": "Kavalla"}, {"code": "GR-73", "name": "Rodopi"}, {"code": "GR-72", "name": "Xanthi"}, {"code": "GR-IX", "name": "Attiki (Greece)"}, {"code": "GR-A1", "name": "Attiki (Greece)"}, {"code": "GR-VII", "name": "Dytiki Ellada"}, {"code": "GR-13", "name": "Achaïa"}, {"code": "GR-01", "name": "Aitolia-Akarnania"}, {"code": "GR-14", "name": "Ileia"}, {"code": "GR-III", "name": "Dytiki Makedonia"}, {"code": "GR-63", "name": "Florina"}, {"code": "GR-51", "name": "Grevena"}, {"code": "GR-56", "name": "Kastoria"}, {"code": "GR-58", "name": "Kozani"}, {"code": "GR-VI", "name": "Ionioi Nisoi"}, {"code": "GR-23", "name": "Kefallinia"}, {"code": "GR-22", "name": "Kerkyra"}, {"code": "GR-24", "name": "Lefkas"}, {"code": "GR-21", "name": "Zakynthos"}, {"code": "GR-IV", "name": "Ipeiros"}, {"code": "GR-31", "name": "Arta"}, {"code": "GR-33", "name": "Ioannina"}, {"code": "GR-34", "name": "Preveza"}, {"code": "GR-32", "name": "Thesprotia"}, {"code": "GR-II", "name": "Kentriki Makedonia"}, {"code": "GR-64", "name": "Chalkidiki"}, {"code": "GR-53", "name": "Imathia"}, {"code": "GR-57", "name": "Kilkis"}, {"code": "GR-59", "name": "Pella"}, {"code": "GR-61", "name": "Pieria"}, {"code": "GR-62", "name": "Serrai"}, {"code": "GR-54", "name": "Thessaloniki"}, {"code": "GR-XIII", "name": "Kriti"}, {"code": "GR-94", "name": "Chania"}, {"code": "GR-91", "name": "Irakleion"}, {"code": "GR-92", "name": "Lasithion"}, {"code": "GR-93", "name": "Rethymnon"}, {"code": "GR-XII", "name": "Notio Aigaio"}, {"code": "GR-81", "name": "Dodekanisos"}, {"code": "GR-82", "name": "Kyklades"}, {"code": "GR-X", "name": "Peloponnisos"}, {"code": "GR-11", "name": "Argolis"}, {"code": "GR-12", "name": "Arkadia"}, {"code": "GR-15", "name": "Korinthia"}, {"code": "GR-16", "name": "Lakonia"}, {"code": "GR-17", "name": "Messinia"}, {"code": "GR-VIII", "name": "Sterea Ellada"}, {"code": "GR-05", "name": "Evrytania"}, {"code": "GR-04", "name": "Evvoia"}, {"code": "GR-07", "name": "Fokis"}, {"code": "GR-06", "name": "Fthiotis"}, {"code": "GR-03", "name": "Voiotia"}, {"code": "GR-V", "name": "Thessalia"}, {"code": "GR-41", "name": "Karditsa"}, {"code": "GR-42", "name": "Larisa"}, {"code": "GR-43", "name": "Magnisia"}, {"code": "GR-44", "name": "Trikala"}, {"code": "GR-XI", "name": "Voreio Aigaio"}, {"code": "GR-85", "name": "Chios"}, {"code": "GR-83", "name": "Lesvos"}, {"code": "GR-84", "name": "Samos"}, {"code": "GL-GL", "name": "Greenland"}, {"code": "GD-GD", "name": "Grenada"}, {"code": "GP-GP", "name": "Guadeloupe (Guadeloupe)"}, {"code": "GU-GU", "name": "Guam (Guam)"}, {"code": "GT-AV", "name": "Alta Verapaz"}, {"code": "GT-BV", "name": "Baja Verapaz"}, {"code": "GT-CM", "name": "Chimaltenango"}, {"code": "GT-CQ", "name": "Chiquimula"}, {"code": "GT-PR", "name": "El Progreso"}, {"code": "GT-ES", "name": "Escuintla"}, {"code": "GT-GU", "name": "Guatemala"}, {"code": "GT-HU", "name": "Huehuetenango"}, {"code": "GT-IZ", "name": "Izabal"}, {"code": "GT-JA", "name": "Jalapa"}, {"code": "GT-JU", "name": "Jutiapa"}, {"code": "GT-PE", "name": "Petén"}, {"code": "GT-QZ", "name": "Quezaltenango"}, {"code": "GT-QC", "name": "Quiché"}, {"code": "GT-RE", "name": "Retalhuleu"}, {"code": "GT-SA", "name": "Sacatepéquez"}, {"code": "GT-SM", "name": "San Marcos"}, {"code": "GT-SR", "name": "Santa Rosa"}, {"code": "GT-SO", "name": "Sololá"}, {"code": "GT-SU", "name": "Suchitepéquez"}, {"code": "GT-TO", "name": "Totonicapán"}, {"code": "GT-ZA", "name": "Zacapa"}, {"code": "GN-B", "name": "Bake, Gouvernorat de"}, {"code": "GN-BF", "name": "Boffa"}, {"code": "GN-BK", "name": "Boké"}, {"code": "GN-FR", "name": "Fria"}, {"code": "GN-GA", "name": "Gaoual"}, {"code": "GN-KD", "name": "Kindia"}, {"code": "GN-C", "name": "Conakry, Gouvernorat de"}, {"code": "GN-F", "name": "Faranah, Gouvernorat de"}, {"code": "GN-DB", "name": "Dabola"}, {"code": "GN-DI", "name": "Dinguiraye"}, {"code": "GN-FA", "name": "Faranah"}, {"code": "GN-KS", "name": "Kissidougou"}, {"code": "GN-K", "name": "Kankan, Gouvernorat de"}, {"code": "GN-KA", "name": "Kankan"}, {"code": "GN-KE", "name": "Kérouané"}, {"code": "GN-KO", "name": "Kouroussa"}, {"code": "GN-MD", "name": "Mandiana"}, {"code": "GN-SI", "name": "Siguiri"}, {"code": "GN-D", "name": "Kindia, Gouvernorat de"}, {"code": "GN-CO", "name": "Coyah"}, {"code": "GN-DU", "name": "Dubréka"}, {"code": "GN-FO", "name": "Forécariah"}, {"code": "GN-TE", "name": "Télimélé"}, {"code": "GN-L", "name": "Labé, Gouvernorat de"}, {"code": "GN-KB", "name": "Koubia"}, {"code": "GN-LA", "name": "Labé"}, {"code": "GN-LE", "name": "Lélouma"}, {"code": "GN-ML", "name": "Mali"}, {"code": "GN-TO", "name": "Tougué"}, {"code": "GN-M", "name": "Mamou, Gouvernorat de"}, {"code": "GN-DL", "name": "Dalaba"}, {"code": "GN-MM", "name": "Mamou"}, {"code": "GN-PI", "name": "Pita"}, {"code": "GN-N", "name": "Nzérékoré, Gouvernorat de"}, {"code": "GN-BE", "name": "Beyla"}, {"code": "GN-GU", "name": "Guékédou"}, {"code": "GN-LO", "name": "Lola"}, {"code": "GN-MC", "name": "Macenta"}, {"code": "GN-NZ", "name": "Nzérékoré"}, {"code": "GN-YO", "name": "Yomou"}, {"code": "GW-BS", "name": "Bissau"}, {"code": "GW-BA", "name": "Bafatá"}, {"code": "GW-BM", "name": "Biombo"}, {"code": "GW-BL", "name": "Bolama"}, {"code": "GW-CA", "name": "Cacheu"}, {"code": "GW-GA", "name": "Gabú"}, {"code": "GW-OI", "name": "Oio"}, {"code": "GW-QU", "name": "Quinara"}, {"code": "GY-BA", "name": "Barima-Waini"}, {"code": "GY-CU", "name": "Cuyuni-Mazaruni"}, {"code": "GY-DE", "name": "Demerara-Mahaica"}, {"code": "GY-EB", "name": "East Berbice-Corentyne"}, {"code": "GY-ES", "name": "Essequibo Islands-West Demerara"}, {"code": "GY-MA", "name": "Mahaica-Berbice"}, {"code": "GY-PM", "name": "Pomeroon-Supenaam"}, {"code": "GY-PT", "name": "Potaro-Siparuni"}, {"code": "GY-UD", "name": "Upper Demerara-Berbice"}, {"code": "GY-UT", "name": "Upper Takutu-Upper Essequibo"}, {"code": "HT-AR", "name": "Artibonite"}, {"code": "HT-CE", "name": "Centre (Haiti)"}, {"code": "HT-GA", "name": "Grande-Anse"}, {"code": "HT-ND", "name": "Nord (Haiti)"}, {"code": "HT-NE", "name": "Nord-Est"}, {"code": "HT-NO", "name": "Nord-Ouest (Haiti)"}, {"code": "HT-OU", "name": "Ouest"}, {"code": "HT-SD", "name": "Sud (Haiti)"}, {"code": "HT-SE", "name": "Sud-Est"}, {"code": "HM-HM", "name": "Heard & McDonald Islands"}, {"code": "VA-VA", "name": "Vatican City (Holy See)"}, {"code": "HN-AT", "name": "Atlántida"}, {"code": "HN-CL", "name": "Colón (Honduras)"}, {"code": "HN-CM", "name": "Comayagua"}, {"code": "HN-CP", "name": "Copán"}, {"code": "HN-CR", "name": "Cortés"}, {"code": "HN-CH", "name": "Choluteca"}, {"code": "HN-EP", "name": "El Paraíso"}, {"code": "HN-FM", "name": "Francisco Morazán"}, {"code": "HN-GD", "name": "Gracias a Dios"}, {"code": "HN-IN", "name": "Intibucá"}, {"code": "HN-IB", "name": "Islas de la Bahía"}, {"code": "HN-LP", "name": "La Paz (Honduras)"}, {"code": "HN-LE", "name": "Lempira"}, {"code": "HN-OC", "name": "Ocotepeque"}, {"code": "HN-OL", "name": "Olancho"}, {"code": "HN-SB", "name": "Santa Bárbara"}, {"code": "HN-VA", "name": "Valle"}, {"code": "HN-YO", "name": "Yoro"}, {"code": "HK-HK", "name": "Hong Kong (Hong Kong)"}, {"code": "HU-BU", "name": "Budapest"}, {"code": "HU-BK", "name": "Bács-Kiskun"}, {"code": "HU-BA", "name": "Baranya"}, {"code": "HU-BE", "name": "Békés"}, {"code": "HU-BZ", "name": "Borsod-Abaúj-Zemplén"}, {"code": "HU-CS", "name": "Csongrád"}, {"code": "HU-FE", "name": "Fejér"}, {"code": "HU-GS", "name": "Gyór-Moson-Sopron"}, {"code": "HU-HB", "name": "Hajdú-Bihar"}, {"code": "HU-HE", "name": "Heves"}, {"code": "HU-JN", "name": "Jasz-Nagykun-Szolnok"}, {"code": "HU-KE", "name": "Komárom-Esztergom"}, {"code": "HU-NO", "name": "Nógrád"}, {"code": "HU-PE", "name": "Pest"}, {"code": "HU-SO", "name": "Somogy"}, {"code": "HU-SZ", "name": "Szabolcs-Szatmár-Bereg"}, {"code": "HU-TO", "name": "Tolna"}, {"code": "HU-VA", "name": "Vas"}, {"code": "HU-VE", "name": "Veszprém (Hungary)"}, {"code": "HU-ZA", "name": "Zala"}, {"code": "HU-BC", "name": "Békéscsaba"}, {"code": "HU-DE", "name": "Debrecen"}, {"code": "HU-DU", "name": "Dunaújváros"}, {"code": "HU-EG", "name": "Eger"}, {"code": "HU-GY", "name": "Gyór"}, {"code": "HU-HV", "name": "Hódmezóvásárhely"}, {"code": "HU-KV", "name": "Kaposvár"}, {"code": "HU-KM", "name": "Kecskemét"}, {"code": "HU-MI", "name": "Miskolc"}, {"code": "HU-NK", "name": "Nagykanizsa"}, {"code": "HU-NY", "name": "Nyíregyháza"}, {"code": "HU-PS", "name": "Pécs"}, {"code": "HU-ST", "name": "Salgótarján"}, {"code": "HU-SN", "name": "Sopron"}, {"code": "HU-SD", "name": "Szeged"}, {"code": "HU-SF", "name": "Székesfehérvár"}, {"code": "HU-SS", "name": "Szekszárd"}, {"code": "HU-SK", "name": "Szolnok"}, {"code": "HU-SH", "name": "Szombathely"}, {"code": "HU-TB", "name": "Tatabánya"}, {"code": "HU-VM", "name": "Veszprém (Hungary)"}, {"code": "HU-ZE", "name": "Zalaegerszeg"}, {"code": "IS-7", "name": "Austurland"}, {"code": "IS-1", "name": "Höfudborgarsvædi utan Reykjavíkur"}, {"code": "IS-6", "name": "Nordurland eystra"}, {"code": "IS-5", "name": "Nordurland vestra"}, {"code": "IS-0", "name": "Reykjavīk"}, {"code": "IS-8", "name": "Sudurland"}, {"code": "IS-2", "name": "Sudurnes"}, {"code": "IS-4", "name": "Vestfirdir"}, {"code": "IS-3", "name": "Vesturland"}, {"code": "IN-AP", "name": "Andhra Pradesh"}, {"code": "IN-AR", "name": "Arunachal Pradesh"}, {"code": "IN-AS", "name": "Assam"}, {"code": "IN-BR", "name": "Bihar"}, {"code": "IN-GA", "name": "Goa"}, {"code": "IN-GJ", "name": "Gujarat"}, {"code": "IN-HR", "name": "Haryana"}, {"code": "IN-HP", "name": "Himachal Pradesh"}, {"code": "IN-JK", "name": "Jammu and Kashmir"}, {"code": "IN-KA", "name": "Karnataka"}, {"code": "IN-KL", "name": "Kerala"}, {"code": "IN-MP", "name": "Madhya Pradesh"}, {"code": "IN-MH", "name": "Maharashtra"}, {"code": "IN-MN", "name": "Manipur"}, {"code": "IN-ML", "name": "Meghalaya"}, {"code": "IN-MZ", "name": "Mizoram"}, {"code": "IN-NL", "name": "Nagaland"}, {"code": "IN-OR", "name": "Orissa"}, {"code": "IN-PB", "name": "Punjab (India)"}, {"code": "IN-RJ", "name": "Rajasthan"}, {"code": "IN-SK", "name": "Sikkim"}, {"code": "IN-TN", "name": "Tamil Nadu"}, {"code": "IN-TR", "name": "Tripura"}, {"code": "IN-UP", "name": "Uttar Pradesh"}, {"code": "IN-WB", "name": "West Bengal"}, {"code": "IN-AN", "name": "Andaman and Nicobar Islands"}, {"code": "IN-CH", "name": "Chandigarh"}, {"code": "IN-DN", "name": "Dadra and Nagar Haveli"}, {"code": "IN-DD", "name": "Daman and Diu"}, {"code": "IN-DL", "name": "Delhi"}, {"code": "IN-LD", "name": "Lakshadweep"}, {"code": "IN-PY", "name": "Pondicherry"}, {"code": "ID-IJU", "name": "Irian Jaya (Indonesia)"}, {"code": "ID-IJ", "name": "Irian Jaya (Indonesia)"}, {"code": "ID-JWU", "name": "Jawa"}, {"code": "ID-JB", "name": "Jawa Barat"}, {"code": "ID-JT", "name": "Jawa Tengah"}, {"code": "ID-JI", "name": "Jawa Timur"}, {"code": "ID-JK", "name": "Jakarta Raya"}, {"code": "ID-YO", "name": "Yogyakarta"}, {"code": "ID-KAU", "name": "Kalimantan"}, {"code": "ID-KB", "name": "Kalimantan Barat"}, {"code": "ID-KS", "name": "Kalimantan Selatan"}, {"code": "ID-KT", "name": "Kalimantan Tengah"}, {"code": "ID-KI", "name": "Kalimantan Timur"}, {"code": "ID-MAU", "name": "Maluku (Indonesia)"}, {"code": "ID-MA", "name": "Maluku (Indonesia)"}, {"code": "ID-NUU", "name": "Nusa Tenggara"}, {"code": "ID-BA", "name": "Bali"}, {"code": "ID-NB", "name": "Nusa Tenggara Barat"}, {"code": "ID-NT", "name": "Nusa Tenggara Timur"}, {"code": "ID-TT", "name": "Timor Timur"}, {"code": "ID-SLU", "name": "Sulawesi"}, {"code": "ID-SN", "name": "Sulawesi Selatan"}, {"code": "ID-ST", "name": "Sulawesi Tengah"}, {"code": "ID-SG", "name": "Sulawesi Tenggara"}, {"code": "ID-SA", "name": "Sulawesi Utara"}, {"code": "ID-SMU", "name": "Sumatera"}, {"code": "ID-BE", "name": "Bengkulu"}, {"code": "ID-JA", "name": "Jambi"}, {"code": "ID-LA", "name": "Lampung"}, {"code": "ID-RI", "name": "Riau"}, {"code": "ID-SB", "name": "Sumatera Barat"}, {"code": "ID-SS", "name": "Sumatera Selatan"}, {"code": "ID-SU", "name": "Sumatera Utara"}, {"code": "ID-AC", "name": "Aceh"}, {"code": "IR-03", "name": "Ardabīl"}, {"code": "IR-02", "name": "Āzarbāyjān-e-Gharbī"}, {"code": "IR-01", "name": "Āzarbāyjān-e-Sharqī"}, {"code": "IR-06", "name": "Būshehr"}, {"code": "IR-08", "name": "Chahār Maḩāll vā Bakhtīārī"}, {"code": "IR-04", "name": "Eşfahān"}, {"code": "IR-14", "name": "Fārs"}, {"code": "IR-19", "name": "Gīlān"}, {"code": "IR-24", "name": "Hamadān"}, {"code": "IR-23", "name": "Hormozgān"}, {"code": "IR-05", "name": "Īlām"}, {"code": "IR-15", "name": "Kermān"}, {"code": "IR-17", "name": "Kermānshāhān"}, {"code": "IR-09", "name": "Khorāsān"}, {"code": "IR-10", "name": "Khūzestān"}, {"code": "IR-18", "name": "Kohkīlūyeh va Būyer Aḩmadī"}, {"code": "IR-16", "name": "Kordestān"}, {"code": "IR-20", "name": "Lorestān"}, {"code": "IR-22", "name": "Markazī"}, {"code": "IR-21", "name": "Māzandarān"}, {"code": "IR-26", "name": "Qom"}, {"code": "IR-12", "name": "Semnān"}, {"code": "IR-13", "name": "Sīstān va Balūchestān"}, {"code": "IR-07", "name": "Tehrān"}, {"code": "IR-25", "name": "Yazd"}, {"code": "IR-11", "name": "Zanjān"}, {"code": "IQ-AN", "name": "Al Anbār"}, {"code": "IQ-BA", "name": "Al Başrah"}, {"code": "IQ-MU", "name": "Al Muthanná"}, {"code": "IQ-QA", "name": "Al Qādisīyah"}, {"code": "IQ-NA", "name": "An Najaf"}, {"code": "IQ-AR", "name": "Arbīl"}, {"code": "IQ-SU", "name": "As Sulaymānīyah"}, {"code": "IQ-TS", "name": "At Ta'mīm"}, {"code": "IQ-BB", "name": "Bābil"}, {"code": "IQ-BG", "name": "Baghdād"}, {"code": "IQ-DA", "name": "Dahūk"}, {"code": "IQ-DQ", "name": "Dhī Qār"}, {"code": "IQ-DI", "name": "Diyālá"}, {"code": "IQ-KA", "name": "Karbalā'"}, {"code": "IQ-MA", "name": "Maysān"}, {"code": "IQ-NI", "name": "Nīnawá"}, {"code": "IQ-SD", "name": "Şalāḩ ad Dīn"}, {"code": "IQ-WA", "name": "Wāsiţ"}, {"code": "IE-CP", "name": "Connaught (Connacht)"}, {"code": "IE-G", "name": "Galway (Gaillimh)"}, {"code": "IE-LM", "name": "Leitrim (Liatroim)"}, {"code": "IE-MO", "name": "Mayo (Maigh Eo)"}, {"code": "IE-RN", "name": "Roscommon (Ros Comáin)"}, {"code": "IE-SO", "name": "Sligo (Sligeach)"}, {"code": "IE-LP", "name": "Leinster (Laighin)"}, {"code": "IE-CW", "name": "Carlow (Ceatharlach)"}, {"code": "IE-D", "name": "Dublin (Baile Átha Cliath)"}, {"code": "IE-KE", "name": "Kildare (Cill Dara)"}, {"code": "IE-KK", "name": "Kilkenny (Cill Chainnigh)"}, {"code": "IE-LS", "name": "Laois (Laois)"}, {"code": "IE-LD", "name": "Longford (An Longfort)"}, {"code": "IE-LH", "name": "Louth (Lú)"}, {"code": "IE-MH", "name": "Meath (An Mhí)"}, {"code": "IE-OY", "name": "Offaly (Uíbh Fhailí)"}, {"code": "IE-WH", "name": "Westmeath (An Iarmhí)"}, {"code": "IE-WX", "name": "Wexford (Loch Garman)"}, {"code": "IE-WW", "name": "Wicklow (Cill Mhantáin)"}, {"code": "IE-M", "name": "Munster (An Mhumhain)"}, {"code": "IE-UP", "name": "Ulster (Ulaidh)"}, {"code": "IE-CN", "name": "Cavan (An Cabhán)"}, {"code": "IE-DL", "name": "Donegal (Dún na nGall)"}, {"code": "IE-MN", "name": "Monaghan (Muineachán)"}, {"code": "IL-D", "name": "HaDarom (El Janūbī)"}, {"code": "IL-M", "name": "HaMerkaz (El Awsat)"}, {"code": "IL-2", "name": "HaZafon (Esh Shamālī)"}, {"code": "IL-HA", "name": "Hefa (Heifā)"}, {"code": "IL-TA", "name": "Tel-Aviv (Tell Abīb)"}, {"code": "IL-JM", "name": "Yerushalayim (Al Quds)"}, {"code": "IT-65", "name": "Abruzzo"}, {"code": "IT-CH", "name": "Chieti"}, {"code": "IT-AQ", "name": "L'Aquila"}, {"code": "IT-PE", "name": "Pescara"}, {"code": "IT-TE", "name": "Teramo"}, {"code": "IT-77", "name": "Basilicata"}, {"code": "IT-MT", "name": "Matera"}, {"code": "IT-PZ", "name": "Potenza"}, {"code": "IT-78", "name": "Calabria"}, {"code": "IT-CZ", "name": "Catanzaro"}, {"code": "IT-CS", "name": "Cosenza"}, {"code": "IT-KR", "name": "Crotone"}, {"code": "IT-RC", "name": "Reggio Calabria"}, {"code": "IT-W", "name": "Vibo Valentia"}, {"code": "IT-72", "name": "Campania"}, {"code": "IT-AV", "name": "Avellino"}, {"code": "IT-BN", "name": "Benevento"}, {"code": "IT-CE", "name": "Caserta"}, {"code": "IT-NA", "name": "Napoli"}, {"code": "IT-SA", "name": "Salerno"}, {"code": "IT-45", "name": "Emilia-Romagna"}, {"code": "IT-BO", "name": "Bologna"}, {"code": "IT-FE", "name": "Ferrara"}, {"code": "IT-FO", "name": "Forlì"}, {"code": "IT-MO", "name": "Modena"}, {"code": "IT-PR", "name": "Parma"}, {"code": "IT-PC", "name": "Piacenza"}, {"code": "IT-RA", "name": "Ravenna"}, {"code": "IT-RE", "name": "Reggio Emilia"}, {"code": "IT-RN", "name": "Rimini"}, {"code": "IT-36", "name": "Friuli-Venezia Giulia"}, {"code": "IT-GO", "name": "Gorizia"}, {"code": "IT-PN", "name": "Pordenone"}, {"code": "IT-TS", "name": "Trieste"}, {"code": "IT-UD", "name": "Udine"}, {"code": "IT-62", "name": "Lazio"}, {"code": "IT-FR", "name": "Frosinone"}, {"code": "IT-LT", "name": "Latina"}, {"code": "IT-RI", "name": "Rieti"}, {"code": "IT-RM", "name": "Roma"}, {"code": "IT-VT", "name": "Viterbo"}, {"code": "IT-42", "name": "Liguria"}, {"code": "IT-GE", "name": "Genova"}, {"code": "IT-IM", "name": "Imperia"}, {"code": "IT-SP", "name": "La Spezia"}, {"code": "IT-SV", "name": "Savona"}, {"code": "IT-25", "name": "Lombardia"}, {"code": "IT-BG", "name": "Bergamo"}, {"code": "IT-BS", "name": "Brescia"}, {"code": "IT-CO", "name": "Como"}, {"code": "IT-CR", "name": "Cremona"}, {"code": "IT-LC", "name": "Lecco"}, {"code": "IT-LO", "name": "Lodi"}, {"code": "IT-MN", "name": "Mantova"}, {"code": "IT-MI", "name": "Milano"}, {"code": "IT-PV", "name": "Pavia"}, {"code": "IT-SO", "name": "Sondrio"}, {"code": "IT-VA", "name": "Varese"}, {"code": "IT-57", "name": "Marche"}, {"code": "IT-AN", "name": "Ancona"}, {"code": "IT-AP", "name": "Ascoli Piceno"}, {"code": "IT-MC", "name": "Macerata"}, {"code": "IT-PS", "name": "Pesaro"}, {"code": "IT-67", "name": "Molise"}, {"code": "IT-CB", "name": "Campobasso"}, {"code": "IT-IS", "name": "Isernia"}, {"code": "IT-21", "name": "Piemonte"}, {"code": "IT-AL", "name": "Alessandria"}, {"code": "IT-AT", "name": "Asti"}, {"code": "IT-BI", "name": "Biella"}, {"code": "IT-CN", "name": "Cuneo"}, {"code": "IT-NO", "name": "Novara"}, {"code": "IT-TO", "name": "Torino"}, {"code": "IT-VB", "name": "Verbano-Cusio-Ossola"}, {"code": "IT-VC", "name": "Vercelli"}, {"code": "IT-75", "name": "Puglia"}, {"code": "IT-BA", "name": "Bari (Italy)"}, {"code": "IT-BR", "name": "Brindisi"}, {"code": "IT-FG", "name": "Foggia"}, {"code": "IT-LE", "name": "Lecce"}, {"code": "IT-TA", "name": "Taranto"}, {"code": "IT-88", "name": "Sardegna"}, {"code": "IT-CA", "name": "Cagliari"}, {"code": "IT-NU", "name": "Nuoro"}, {"code": "IT-OR", "name": "Oristano"}, {"code": "IT-SS", "name": "Sassari"}, {"code": "IT-82", "name": "Sicilia"}, {"code": "IT-AG", "name": "Agrigento"}, {"code": "IT-CL", "name": "Caltanissetta"}, {"code": "IT-CT", "name": "Catania"}, {"code": "IT-EN", "name": "Enna"}, {"code": "IT-ME", "name": "Mesaina"}, {"code": "IT-PA", "name": "Palermo"}, {"code": "IT-RG", "name": "Ragusa"}, {"code": "IT-SR", "name": "Siracusa"}, {"code": "IT-TP", "name": "Trapani"}, {"code": "IT-52", "name": "Toscana"}, {"code": "IT-AR", "name": "Arezzo"}, {"code": "IT-FI", "name": "Firenze"}, {"code": "IT-GR", "name": "Grosseto"}, {"code": "IT-LI", "name": "Livorno"}, {"code": "IT-LU", "name": "Lucca"}, {"code": "IT-MS", "name": "Massa"}, {"code": "IT-PI", "name": "Pisa"}, {"code": "IT-PT", "name": "Pistoia"}, {"code": "IT-PO", "name": "Prato"}, {"code": "IT-SI", "name": "Siena"}, {"code": "IT-32", "name": "Trentino-Alte Adige (Trentino-Südtirol)"}, {"code": "IT-BZ", "name": "Bolzano (Bozen)"}, {"code": "IT-TN", "name": "Trento"}, {"code": "IT-55", "name": "Umbria"}, {"code": "IT-PG", "name": "Perugia"}, {"code": "IT-TR", "name": "Terni"}, {"code": "IT-23", "name": "Valle d'Aosta (Vallée d'Aoste)"}, {"code": "IT-AO", "name": "Aosta (Aoste)"}, {"code": "IT-34", "name": "Veneto"}, {"code": "IT-BL", "name": "Belluno"}, {"code": "IT-PD", "name": "Padova"}, {"code": "IT-RO", "name": "Rovigo"}, {"code": "IT-TV", "name": "Treviso"}, {"code": "IT-VE", "name": "Venezia"}, {"code": "IT-VR", "name": "Verona"}, {"code": "IT-VI", "name": "Vicenza"}, {"code": "JM-13", "name": "Clarendon"}, {"code": "JM-09", "name": "Hanover"}, {"code": "JM-01", "name": "Kingston"}, {"code": "JM-12", "name": "Manchester"}, {"code": "JM-04", "name": "Portland"}, {"code": "JM-02", "name": "Saint Andrew"}, {"code": "JM-06", "name": "Saint Ann"}, {"code": "JM-14", "name": "Saint Catherine"}, {"code": "JM-11", "name": "Saint Elizabeth"}, {"code": "JM-08", "name": "Saint James"}, {"code": "JM-05", "name": "Saint Mary"}, {"code": "JM-03", "name": "Saint Thomas"}, {"code": "JM-07", "name": "Trelawny"}, {"code": "JM-10", "name": "Westmoreland"}, {"code": "JP-23", "name": "Aiti [Aichi]"}, {"code": "JP-05", "name": "Akita"}, {"code": "JP-02", "name": "Aomori"}, {"code": "JP-38", "name": "Ehime"}, {"code": "JP-21", "name": "Gihu [Gifu]"}, {"code": "JP-10", "name": "Gunma"}, {"code": "JP-34", "name": "Hirosima [Hiroshima]"}, {"code": "JP-01", "name": "Hokkaidô [Hokkaido]"}, {"code": "JP-18", "name": "Hukui [Fukui]"}, {"code": "JP-40", "name": "Hukuoka [Fukuoka]"}, {"code": "JP-07", "name": "Hukusima [Fukushima]"}, {"code": "JP-28", "name": "Hyôgo [Hyogo]"}, {"code": "JP-08", "name": "Ibaraki"}, {"code": "JP-17", "name": "Isikawa [Ishikawa]"}, {"code": "JP-03", "name": "Iwate"}, {"code": "JP-37", "name": "Kagawa"}, {"code": "JP-46", "name": "Kagosima [Kagoshima]"}, {"code": "JP-14", "name": "Kanagawa"}, {"code": "JP-39", "name": "Kôti [Kochi]"}, {"code": "JP-43", "name": "Kumamoto"}, {"code": "JP-26", "name": "Kyôto [Kyoto]"}, {"code": "JP-24", "name": "Mie"}, {"code": "JP-04", "name": "Miyagi"}, {"code": "JP-45", "name": "Miyazaki"}, {"code": "JP-20", "name": "Nagano"}, {"code": "JP-42", "name": "Nagasaki"}, {"code": "JP-29", "name": "Nara"}, {"code": "JP-15", "name": "Niigata"}, {"code": "JP-44", "name": "Ôita [Oita]"}, {"code": "JP-33", "name": "Okayama"}, {"code": "JP-47", "name": "Okinawa"}, {"code": "JP-27", "name": "Ôsaka [Osaka]"}, {"code": "JP-41", "name": "Saga"}, {"code": "JP-11", "name": "Saitama"}, {"code": "JP-25", "name": "Siga [Shiga]"}, {"code": "JP-22", "name": "Sizuoka [Shizuoka]"}, {"code": "JP-12", "name": "Tiba [Chiba]"}, {"code": "JP-09", "name": "Totigi [Tochigi]"}, {"code": "JP-36", "name": "Tokusima [Tokushima]"}, {"code": "JP-13", "name": "Tôkyô [Tokyo]"}, {"code": "JP-31", "name": "Tottori"}, {"code": "JP-16", "name": "Toyama"}, {"code": "JP-30", "name": "Wakayama"}, {"code": "JP-06", "name": "Yamagata"}, {"code": "JP-35", "name": "Yamaguti [Yamaguchi]"}, {"code": "JP-19", "name": "Yamanasi [Yamanashi]"}, {"code": "JO-AJ", "name": "‘Ajlūn"}, {"code": "JO-AQ", "name": "Al 'Aqaba"}, {"code": "JO-BA", "name": "Al Balqā'"}, {"code": "JO-KA", "name": "Al Karak"}, {"code": "JO-MA", "name": "Al Mafraq"}, {"code": "JO-AM", "name": "‘Ammān"}, {"code": "JO-AT", "name": "Aţ Ţafīlah"}, {"code": "JO-AZ", "name": "Az Zarqā'"}, {"code": "JO-IR", "name": "Irbid"}, {"code": "JO-JA", "name": "Jarash"}, {"code": "JO-MN", "name": "Ma‘ān"}, {"code": "JO-MD", "name": "Mādaba"}, {"code": "KZ-ALA", "name": "Almaty"}, {"code": "KZ-BAY", "name": "Bayqonyr (Baykonyr)"}, {"code": "KZ-ALM", "name": "Almaty oblysy (Almatinskaya oblast')"}, {"code": "KZ-AKM", "name": "Aqmola oblysy (Akmolinskaya oblast')"}, {"code": "KZ-AKT", "name": "Aqtöbe oblysy (Aktyubinskaya oblast')"}, {"code": "KZ-ATY", "name": "Atyraü oblysy (Atyrauskaya oblast')"}, {"code": "KZ-ZAP", "name": "Batys Kazakstan oblysy (Zapadno-Kazakhstanskaya oblast')"}, {"code": "KZ-MAN", "name": "Mangghystaū oblysy (Mangystauskaya oblast')"}, {"code": "KZ-YUZ", "name": "Ongtüstik Kazakstan oblysy (Yuzhno-Kazakhstanskaya oblast')"}, {"code": "KZ-PAV", "name": "Pavlodar oblysy (Pavlodarskaya oblast')"}, {"code": "KZ-KAR", "name": "Qaraghandy oblysy (Karagandinskaya oblast')"}, {"code": "KZ-KUS", "name": "Qostanay oblysy (Kustanayskaya oblast')"}, {"code": "KZ-KZY", "name": "Qyzylorda oblysy (Kzylordinskaya oblast')"}, {"code": "KZ-VOS", "name": "Shyghys Kazakstan oblysy (Vostochno-Kazakhstanskaya oblast')"}, {"code": "KZ-SEV", "name": "Soltüstik Kazakstan oblysy (Severo-Kazakhstanskaya oblast')"}, {"code": "KZ-ZHA", "name": "Zhambyl oblysy (Zhambylskaya Oblast')"}, {"code": "KE-110", "name": "Nairobi Municipality"}, {"code": "KE-200", "name": "Central (Kati)"}, {"code": "KE-300", "name": "Coast (Pwani)"}, {"code": "KE-400", "name": "Eastern (Mashariki)"}, {"code": "KE-500", "name": "North-Eastern (Kaskazini Mashariki)"}, {"code": "KE-600", "name": "Nyanza"}, {"code": "KE-700", "name": "Rift Valley"}, {"code": "KE-900", "name": "Western (Magharibi)"}, {"code": "KI-G", "name": "Gilbert Islands"}, {"code": "KI-L", "name": "Line Islands"}, {"code": "KI-P", "name": "Phoenix Islands"}, {"code": "KP-KAE", "name": "Kaesong-si"}, {"code": "KP-NAM", "name": "Nampo-si"}, {"code": "KP-PYO", "name": "Pyongyang-si"}, {"code": "KP-CHA", "name": "Chagang-do"}, {"code": "KP-HAB", "name": "Hamgyongbuk-do"}, {"code": "KP-HAN", "name": "Hamgyongnam-do"}, {"code": "KP-HWB", "name": "Hwanghaebuk-do"}, {"code": "KP-HWN", "name": "Hwanghaenam-do"}, {"code": "KP-KAN", "name": "Kangwon-do"}, {"code": "KP-PYB", "name": "Pyonganbuk-do"}, {"code": "KP-PYN", "name": "Pyongannam-do"}, {"code": "KP-YAN", "name": "Yanggang-do"}, {"code": "KR-11", "name": "Seoul Teugbyeolsi [ Seoul-T’ŭkpyŏlshi]"}, {"code": "KR-26", "name": "Busan Gwang'yeogsi [Pusan-Kwangyŏkshi]"}, {"code": "KR-27", "name": "Daegu Gwang'yeogsi [Taegu-Kwangyŏkshi)"}, {"code": "KR-30", "name": "Daejeon Gwang'yeogsi [Taejŏn-Kwangyŏkshi]"}, {"code": "KR-29", "name": "Gwangju Gwang'yeogsi [Kwangju-Kwangyŏkshi]"}, {"code": "KR-28", "name": "Incheon Gwang'yeogsi [Inchŏn-Kwangyŏkshi]"}, {"code": "KR-31", "name": "Ulsan Gwang'yeogsi [Ulsan-Kwangyŏkshi]"}, {"code": "KR-43", "name": "Chungcheongbugdo [Ch'ungch'ŏngbuk-do]"}, {"code": "KR-44", "name": "Chungcheongnamdo [Ch'ungch'ŏngnam-do]"}, {"code": "KR-42", "name": "Gang'weondo [Kang-won-do]"}, {"code": "KR-41", "name": "Gyeonggido [Kyŏnggi-do]"}, {"code": "KR-47", "name": "Gyeongsangbugdo [Kyŏngsangbuk-do]"}, {"code": "KR-48", "name": "Gyeongsangnamdo [Kyŏngsangnam-do]"}, {"code": "KR-49", "name": "Jejudo [Cheju-do]"}, {"code": "KR-45", "name": "Jeonrabugdo [Chŏllabuk-do)"}, {"code": "KR-46", "name": "Jeonranamdo [Chŏllanam-do]"}, {"code": "KW-AH", "name": "Al Aḩmadi"}, {"code": "KW-FA", "name": "Al Farwānīyah"}, {"code": "KW-JA", "name": "Al Jahrah"}, {"code": "KW-KU", "name": "Al Kuwayt"}, {"code": "KW-HA", "name": "Ḩawallī"}, {"code": "KG-C", "name": "Chu (Chuyskaya oblast')"}, {"code": "KG-J", "name": "Jalal-Abad (Dzhalal-Abadskaya oblast')"}, {"code": "KG-N", "name": "Naryn (Narynskaya Oblast’)"}, {"code": "KG-O", "name": "Osh (Oshskaya oblast')"}, {"code": "KG-T", "name": "Talas (Talasskaya oblast')"}, {"code": "KG-Y", "name": "Ysyk-Köl (Issyk-Kul'skaya oblast')"}, {"code": "LA-VT", "name": "Vientiane (Laos)"}, {"code": "LA-AT", "name": "Attapu [Attopeu]"}, {"code": "LA-BK", "name": "Bokèo"}, {"code": "LA-BL", "name": "Bolikhamxai [Borikhane]"}, {"code": "LA-CH", "name": "Champasak [Champassak]"}, {"code": "LA-HO", "name": "Houaphan"}, {"code": "LA-KH", "name": "Khammouan"}, {"code": "LA-LM", "name": "Louang Namtha"}, {"code": "LA-LP", "name": "Louangphabang [Louang Prabang]"}, {"code": "LA-OU", "name": "Oudômxai [Oudomsai]"}, {"code": "LA-PH", "name": "Phôngsali [Phong Saly]"}, {"code": "LA-SL", "name": "Salavan [Saravane]"}, {"code": "LA-SV", "name": "Savannakhét"}, {"code": "LA-VI", "name": "Vientiane (Laos)"}, {"code": "LA-XA", "name": "Xaignabouli [Sayaboury]"}, {"code": "LA-XE", "name": "Xékong [Sékong]"}, {"code": "LA-XI", "name": "Xiangkhoang [Xieng Khouang]"}, {"code": "LV-AI", "name": "Aizkraukles Aprinkis"}, {"code": "LV-AL", "name": "Alūksnes Aprinkis"}, {"code": "LV-BL", "name": "Balvu Aprinkis"}, {"code": "LV-BU", "name": "Bauskas Aprinkis"}, {"code": "LV-CE", "name": "Cēsu Aprinkis"}, {"code": "LV-DA", "name": "Daugavpils Aprinkis"}, {"code": "LV-DO", "name": "Dobeles Aprinkis"}, {"code": "LV-GU", "name": "Gulbenes Aprinkis"}, {"code": "LV-JL", "name": "Jelgavas Aprinkis"}, {"code": "LV-JK", "name": "Jēkabpils Aprinkis"}, {"code": "LV-KR", "name": "Krāslavas Aprinkis"}, {"code": "LV-KU", "name": "Kuldīgas Aprinkis"}, {"code": "LV-LM", "name": "Limbažu Aprinkis"}, {"code": "LV-LE", "name": "Liepājas Aprinkis"}, {"code": "LV-LU", "name": "Ludzas Aprinkis"}, {"code": "LV-MA", "name": "Madonas Aprinkis"}, {"code": "LV-OG", "name": "Ogres Aprinkis"}, {"code": "LV-PR", "name": "Preilu Aprinkis"}, {"code": "LV-RE", "name": "Rēzeknes Aprinkis"}, {"code": "LV-RI", "name": "Rīgas Aprinkis"}, {"code": "LV-SA", "name": "Saldus Aprinkis"}, {"code": "LV-TA", "name": "Talsu Aprinkis"}, {"code": "LV-TU", "name": "Tukuma Aprinkis"}, {"code": "LV-VK", "name": "Valkas Aprinkis"}, {"code": "LV-VM", "name": "Valmieras Aprinkis"}, {"code": "LV-VE", "name": "Ventspils Aprinkis"}, {"code": "LV-DGV", "name": "Daugavpils"}, {"code": "LV-JEL", "name": "Jelgava"}, {"code": "LV-JUR", "name": "Jūrmala"}, {"code": "LV-LPX", "name": "Liepāja"}, {"code": "LV-REZ", "name": "Rēzekne"}, {"code": "LV-RIX", "name": "Rīga"}, {"code": "LV-VEN", "name": "Ventspils"}, {"code": "LB-BA", "name": "Beiroût (Bayrūt)"}, {"code": "LB-BI", "name": "El Béqaa (Al Biqā')"}, {"code": "LB-JL", "name": "Jabal Loubnâne (Jabal Lubnān)"}, {"code": "LB-AS", "name": "Loubnâne ech Chemâli (Ash Shamāl)"}, {"code": "LB-JA", "name": "Loubnâne ej Jnoûbi (Al Janūb)"}, {"code": "LB-NA", "name": "Nabatîyé (An Nabaţīyah"}, {"code": "LS-D", "name": "Berea"}, {"code": "LS-B", "name": "Butha-Buthe"}, {"code": "LS-C", "name": "Leribe"}, {"code": "LS-E", "name": "Mafeteng"}, {"code": "LS-A", "name": "Maseru"}, {"code": "LS-F", "name": "Mohale's Hoek"}, {"code": "LS-J", "name": "Mokhotlong"}, {"code": "LS-H", "name": "Qacha's Nek"}, {"code": "LS-G", "name": "Quthing"}, {"code": "LS-K", "name": "Thaba-Tseka"}, {"code": "LR-BM", "name": "Bomi"}, {"code": "LR-BG", "name": "Bong"}, {"code": "LR-GB", "name": "Grand Bassa"}, {"code": "LR-CM", "name": "Grand Cape Mount"}, {"code": "LR-GG", "name": "Grand Gedeh"}, {"code": "LR-GK", "name": "Grand Kru"}, {"code": "LR-LO", "name": "Lofa"}, {"code": "LR-MG", "name": "Margibi"}, {"code": "LR-MY", "name": "Maryland (Liberia)"}, {"code": "LR-MO", "name": "Montserrado"}, {"code": "LR-NI", "name": "Nimba"}, {"code": "LR-RI", "name": "Rivercess"}, {"code": "LR-SI", "name": "Sinoe"}, {"code": "LY-BU", "name": "Al Buţnān"}, {"code": "LY-JA", "name": "Al Jabal al Akhḑar"}, {"code": "LY-JG", "name": "Al Jabal al Gharbī"}, {"code": "LY-Ju", "name": "Al Jufrah"}, {"code": "LY-WA", "name": "Al Wāḩah"}, {"code": "LY-Wu", "name": "Al Wusţá"}, {"code": "LY-ZA", "name": "Az Zāwiyah"}, {"code": "LY-BA", "name": "Banghāzī"}, {"code": "LY-FA", "name": "Fazzān"}, {"code": "LY-MI", "name": "Mişrātah"}, {"code": "LY-NA", "name": "Naggaza"}, {"code": "LY-SF", "name": "Sawfajjin"}, {"code": "LY-TB", "name": "Ţarābulus"}, {"code": "LI-LI", "name": "Liechtenstein"}, {"code": "LT-AL", "name": "Alytaus Apskritis"}, {"code": "LT-KU", "name": "Kauno Apskritis"}, {"code": "LT-KL", "name": "Klaipėdos Apskritis"}, {"code": "LT-MR", "name": "Marijampolės Apskritis"}, {"code": "LT-PN", "name": "Panevėžio Apskritis"}, {"code": "LT-SA", "name": "Šiauliu Apskritis"}, {"code": "LT-TA", "name": "Tauragės Apskritis"}, {"code": "LT-TE", "name": "Telšiu Apskritis"}, {"code": "LT-UT", "name": "Utenos Apskritis"}, {"code": "LT-VL", "name": "Vilniaus Apskritis"}, {"code": "LU-D", "name": "Diekirch"}, {"code": "LU-G", "name": "Grevenmacher"}, {"code": "LU-L", "name": "Luxembourg (Luxemburg)"}, {"code": "MO-MO", "name": "Macau"}, {"code": "MK-MK", "name": "Macedonia"}, {"code": "MG-T", "name": "Antananarivo"}, {"code": "MG-D", "name": "Antsiranana"}, {"code": "MG-F", "name": "Fianarantsoa"}, {"code": "MG-M", "name": "Mahajanga"}, {"code": "MG-A", "name": "Toamasina"}, {"code": "MG-U", "name": "Toliara"}, {"code": "MW-C", "name": "Central (Malawi)"}, {"code": "MW-DE", "name": "Dedza"}, {"code": "MW-DO", "name": "Dowa"}, {"code": "MW-KS", "name": "Kasungu"}, {"code": "MW-LI", "name": "Lilongwe"}, {"code": "MW-MC", "name": "Mchinji"}, {"code": "MW-NK", "name": "Nkhotakota"}, {"code": "MW-NU", "name": "Ntcheu"}, {"code": "MW-NI", "name": "Ntchisi"}, {"code": "MW-SA", "name": "Salima"}, {"code": "MW-N", "name": "Northern (Malawi)"}, {"code": "MW-CT", "name": "Chitipa"}, {"code": "MW-KR", "name": "Karonga"}, {"code": "MW-MZ", "name": "Mzimba"}, {"code": "MW-NB", "name": "Nkhata Bay"}, {"code": "MW-RU", "name": "Rumphi"}, {"code": "MW-S", "name": "Southern (Malawi)"}, {"code": "MW-BL", "name": "Blantyre"}, {"code": "MW-CK", "name": "Chikwawa"}, {"code": "MW-CR", "name": "Chiradzulu"}, {"code": "MW-MH", "name": "Machinga"}, {"code": "MW-MG", "name": "Mangochi"}, {"code": "MW-MU", "name": "Mulanje"}, {"code": "MW-MW", "name": "Mwanza (Malawi)"}, {"code": "MW-NS", "name": "Nsanje"}, {"code": "MW-TH", "name": "Thyolo"}, {"code": "MW-ZO", "name": "Zomba"}, {"code": "MY-W", "name": "Wilayah Persekutuan Kuala Lumpur"}, {"code": "MY-L", "name": "Wilayah Persekutuan Labuan"}, {"code": "MY-J", "name": "Johor"}, {"code": "MY-K", "name": "Kedah"}, {"code": "MY-D", "name": "Kelantan"}, {"code": "MY-M", "name": "Melaka"}, {"code": "MY-N", "name": "Negeri Sembilan"}, {"code": "MY-C", "name": "Pahang"}, {"code": "MY-A", "name": "Perak"}, {"code": "MY-R", "name": "Perlis"}, {"code": "MY-P", "name": "Pulau Pinang"}, {"code": "MY-SA", "name": "Sabah"}, {"code": "MY-SK", "name": "Sarawak"}, {"code": "MY-B", "name": "Selangor"}, {"code": "MY-T", "name": "Terengganu"}, {"code": "MV-MLE", "name": "Male"}, {"code": "MV-02", "name": "Alif"}, {"code": "MV-20", "name": "Baa"}, {"code": "MV-17", "name": "Dhaalu"}, {"code": "MV-14", "name": "Faafu"}, {"code": "MV-27", "name": "Gaaf Alif"}, {"code": "MV-28", "name": "Gaafu Dhaalu"}, {"code": "MV-29", "name": "Gnaviyani"}, {"code": "MV-07", "name": "Haa Alif"}, {"code": "MV-23", "name": "Haa Dhaalu"}, {"code": "MV-26", "name": "Kaafu"}, {"code": "MV-05", "name": "Laamu"}, {"code": "MV-03", "name": "Lhaviyani"}, {"code": "MV-12", "name": "Meemu"}, {"code": "MV-25", "name": "Noonu"}, {"code": "MV-13", "name": "Raa"}, {"code": "MV-01", "name": "Seenu"}, {"code": "MV-24", "name": "Shaviyani"}, {"code": "MV-08", "name": "Thaa"}, {"code": "MV-04", "name": "Vaavu"}, {"code": "ML-BKO", "name": "Bamako"}, {"code": "ML-7", "name": "Gao"}, {"code": "ML-1", "name": "Kayes"}, {"code": "ML-8", "name": "Kidal"}, {"code": "ML-2", "name": "Koulikoro"}, {"code": "ML-5", "name": "Mopti"}, {"code": "ML-4", "name": "Ségou"}, {"code": "ML-3", "name": "Sikasso"}, {"code": "ML-6", "name": "Tombouctou"}, {"code": "MT-MT", "name": "Malta"}, {"code": "MH-L", "name": "Ralik chain"}, {"code": "MH-ALL", "name": "Ailinglapalap"}, {"code": "MH-EBO", "name": "Ebon"}, {"code": "MH-ENI", "name": "Eniwetok"}, {"code": "MH-JAL", "name": "Jaluit"}, {"code": "MH-KIL", "name": "Kili"}, {"code": "MH-KWA", "name": "Kwajalein"}, {"code": "MH-LAE", "name": "Lae"}, {"code": "MH-LIB", "name": "Lib"}, {"code": "MH-NMK", "name": "Namorik"}, {"code": "MH-NMU", "name": "Namu"}, {"code": "MH-RON", "name": "Rongelap"}, {"code": "MH-UJA", "name": "Ujae"}, {"code": "MH-UJL", "name": "Ujelang"}, {"code": "MH-WTH", "name": "Wotho"}, {"code": "MH-T", "name": "Ratak chain"}, {"code": "MH-ALK", "name": "Ailuk"}, {"code": "MH-ARN", "name": "Arno"}, {"code": "MH-AUR", "name": "Aur"}, {"code": "MH-LIK", "name": "Likiep"}, {"code": "MH-MAJ", "name": "Majuro"}, {"code": "MH-MAL", "name": "Maloelap"}, {"code": "MH-MEJ", "name": "Mejit"}, {"code": "MH-MIL", "name": "Mili"}, {"code": "MH-UTI", "name": "Utirik"}, {"code": "MH-WTJ", "name": "Wotje"}, {"code": "MQ-MQ", "name": "Martinique (Martinique)"}, {"code": "MR-NKC", "name": "Nouakchott"}, {"code": "MR-07", "name": "Adrar (Mauritania)"}, {"code": "MR-03", "name": "Assaba"}, {"code": "MR-05", "name": "Brakna"}, {"code": "MR-08", "name": "Dakhlet Nouādhibou"}, {"code": "MR-04", "name": "Gorgol"}, {"code": "MR-10", "name": "Guidimaka"}, {"code": "MR-01", "name": "Hodh ech Chargui"}, {"code": "MR-02", "name": "Hodh el Gharbi"}, {"code": "MR-12", "name": "Inchiri"}, {"code": "MR-09", "name": "Tagant"}, {"code": "MR-11", "name": "Tiris Zemmour"}, {"code": "MR-06", "name": "Trarza"}, {"code": "MU-BR", "name": "Beau Bassin-Rose Hill"}, {"code": "MU-CU", "name": "Curepipe"}, {"code": "MU-PL", "name": "Port Louis"}, {"code": "MU-QB", "name": "Quatre Bornes"}, {"code": "MU-VP", "name": "Vacoas-Phoenix"}, {"code": "MU-BL", "name": "Black River"}, {"code": "MU-FL", "name": "Flacq"}, {"code": "MU-GP", "name": "Grand Port"}, {"code": "MU-MO", "name": "Moka"}, {"code": "MU-PA", "name": "Pamplemousses"}, {"code": "MU-PW", "name": "Plaines Wilhems"}, {"code": "MU-RR", "name": "Rivière du Rempart"}, {"code": "MU-SA", "name": "Savanne"}, {"code": "MU-AG", "name": "Agalega Islands"}, {"code": "MU-CC", "name": "Cargados Carajos Shoals [Saint Brandon Islands]"}, {"code": "MU-RO", "name": "Rodrigues Island"}, {"code": "YT-YT", "name": "Mayotte (Mayotte)"}, {"code": "MX-DIF", "name": "Distrito Federal (Mexico)"}, {"code": "MX-AGU", "name": "Aguascalientes"}, {"code": "MX-BCN", "name": "Baja California"}, {"code": "MX-BCS", "name": "Baja California Sur"}, {"code": "MX-CAM", "name": "Campeche"}, {"code": "MX-COA", "name": "Coahuila"}, {"code": "MX-COL", "name": "Colima"}, {"code": "MX-CHP", "name": "Chiapas"}, {"code": "MX-CHH", "name": "Chihuahua"}, {"code": "MX-DUR", "name": "Durango"}, {"code": "MX-GRO", "name": "Guerrero"}, {"code": "MX-GUA", "name": "Guanajuato"}, {"code": "MX-HID", "name": "Hidalgo"}, {"code": "MX-JAL", "name": "Jalisco"}, {"code": "MX-MEX", "name": "México"}, {"code": "MX-MIC", "name": "Michoacán"}, {"code": "MX-MOR", "name": "Morelos"}, {"code": "MX-NAY", "name": "Nayarit"}, {"code": "MX-NLE", "name": "Nuevo León"}, {"code": "MX-OAX", "name": "Oaxaca"}, {"code": "MX-PUE", "name": "Puebla"}, {"code": "MX-QUE", "name": "Queretaro"}, {"code": "MX-ROO", "name": "Quintana Roo"}, {"code": "MX-SLP", "name": "San Luis Potosí"}, {"code": "MX-SIN", "name": "Sinaloa"}, {"code": "MX-SON", "name": "Sonora"}, {"code": "MX-TAB", "name": "Tabasco"}, {"code": "MX-TAM", "name": "Tamaulipas"}, {"code": "MX-TLA", "name": "Tlaxcala"}, {"code": "MX-VER", "name": "Veracruz"}, {"code": "MX-YUC", "name": "Yucatán"}, {"code": "MX-ZAC", "name": "Zacatecas"}, {"code": "FM-TRK", "name": "chuuk"}, {"code": "FM-KSA", "name": "Kosrae"}, {"code": "FM-PNI", "name": "Pohnpei"}, {"code": "FM-YAP", "name": "Yap"}, {"code": "MD-BAL", "name": "Bălţi"}, {"code": "MD-CAH", "name": "Cahul (Moldova)"}, {"code": "MD-CHI", "name": "Chişinău"}, {"code": "MD-DUB", "name": "Dubăsari (Moldova)"}, {"code": "MD-ORH", "name": "Orhei (Moldova)"}, {"code": "MD-RIB", "name": "Rîbniţa (Moldova)"}, {"code": "MD-SOC", "name": "Soroca (Moldova)"}, {"code": "MD-TIG", "name": "Tighina"}, {"code": "MD-TIR", "name": "Tiraspol"}, {"code": "MD-UNG", "name": "Ungheni (Moldova)"}, {"code": "MD-ANE", "name": "Anenii Noi"}, {"code": "MD-BAS", "name": "Basarabeasca"}, {"code": "MD-BRI", "name": "Brinceni"}, {"code": "MD-CHL", "name": "Cahul (Moldova)"}, {"code": "MD-CAM", "name": "Camenca"}, {"code": "MD-CAN", "name": "Cantemir"}, {"code": "MD-CAI", "name": "Căinari"}, {"code": "MD-CAL", "name": "Călăraşi (Moldova)"}, {"code": "MD-CAS", "name": "Căuşeni"}, {"code": "MD-CIA", "name": "Ciadîr-Lunga"}, {"code": "MD-CIM", "name": "Cimişlia"}, {"code": "MD-COM", "name": "Comrat"}, {"code": "MD-CRI", "name": "Criuleni"}, {"code": "MD-DON", "name": "Donduşeni"}, {"code": "MD-DRO", "name": "Drochia"}, {"code": "MD-DBI", "name": "Dubăsari (Moldova)"}, {"code": "MD-EDI", "name": "Edineţ"}, {"code": "MD-FAL", "name": "Făleşti"}, {"code": "MD-FLO", "name": "Floreşti"}, {"code": "MD-GLO", "name": "Glodeni"}, {"code": "MD-GRI", "name": "Grigoriopol"}, {"code": "MD-HIN", "name": "Hînceşti"}, {"code": "MD-IAL", "name": "Ialoveni"}, {"code": "MD-LEO", "name": "Leova"}, {"code": "MD-NIS", "name": "Nisporeni"}, {"code": "MD-OCN", "name": "Ocniţa"}, {"code": "MD-OHI", "name": "Orhei (Moldova)"}, {"code": "MD-REZ", "name": "Rezina"}, {"code": "MD-RIT", "name": "Rîbniţa (Moldova)"}, {"code": "MD-RIS", "name": "Rîşcani"}, {"code": "MD-SIN", "name": "Sîngerei"}, {"code": "MD-SLO", "name": "Slobozia"}, {"code": "MD-SOA", "name": "Soroca (Moldova)"}, {"code": "MD-STR", "name": "Străşeni"}, {"code": "MD-SOL", "name": "Şoldăneşti"}, {"code": "MD-STE", "name": "Ştefan Vodă"}, {"code": "MD-TAR", "name": "Taraclia"}, {"code": "MD-TEL", "name": "Teleneşti"}, {"code": "MD-UGI", "name": "Ungheni (Moldova)"}, {"code": "MD-VUL", "name": "Vulcăneşti"}, {"code": "MC-MC", "name": "Monaco"}, {"code": "MN-1", "name": "Ulaanbaatar"}, {"code": "MN-073", "name": "Arhangay"}, {"code": "MN-069", "name": "Bayanhongor"}, {"code": "MN-071", "name": "Bayan-Ölgiy"}, {"code": "MN-067", "name": "Bulgan"}, {"code": "MN-037", "name": "Darhan uul"}, {"code": "MN-061", "name": "Dornod"}, {"code": "MN-063", "name": "Dornogovĭ"}, {"code": "MN-059", "name": "Dundgovĭ"}, {"code": "MN-057", "name": "Dzavhan"}, {"code": "MN-065", "name": "Govĭ-Altay"}, {"code": "MN-064", "name": "Govĭ-Sümber"}, {"code": "MN-039", "name": "Hentiy"}, {"code": "MN-043", "name": "Hovd"}, {"code": "MN-041", "name": "Hövsgöl"}, {"code": "MN-053", "name": "Ömnögovĭ"}, {"code": "MN-035", "name": "Orhon"}, {"code": "MN-055", "name": "Övörhangay"}, {"code": "MN-049", "name": "Selenge"}, {"code": "MN-051", "name": "Sühbaatar"}, {"code": "MN-047", "name": "Töv"}, {"code": "MN-046", "name": "Uvs"}, {"code": "MS-MS", "name": "Montserrat"}, {"code": "MA-CE", "name": "Centre (Morocco)"}, {"code": "MA-AZI", "name": "Azilal"}, {"code": "MA-BEM", "name": "Beni Mellal"}, {"code": "MA-BES", "name": "Ben Slimane"}, {"code": "MA-BOM", "name": "Boulemane"}, {"code": "MA-CAS", "name": "Casablanca [Dar el Beïda]"}, {"code": "MA-JDI", "name": "El Jadida"}, {"code": "MA-KHO", "name": "Khouribga"}, {"code": "MA-SET", "name": "Settat"}, {"code": "MA-CN", "name": "Centre-Nord"}, {"code": "MA-HOC", "name": "Al Hoceïma"}, {"code": "MA-FES", "name": "Fès"}, {"code": "MA-SEF", "name": "Sefrou"}, {"code": "MA-TAO", "name": "Taounate"}, {"code": "MA-TAZ", "name": "Taza"}, {"code": "MA-CS", "name": "Centre-Sud"}, {"code": "MA-HAJ", "name": "El Hajeb"}, {"code": "MA-ERR", "name": "Errachidia"}, {"code": "MA-IFR", "name": "Ifrane"}, {"code": "MA-KHN", "name": "Khenifra"}, {"code": "MA-MEK", "name": "Meknès"}, {"code": "MA-ES", "name": "Est (Morocco)"}, {"code": "MA-BER", "name": "Berkane"}, {"code": "MA-FIG", "name": "Figuig"}, {"code": "MA-IRA", "name": "Jrada"}, {"code": "MA-NAD", "name": "Nador"}, {"code": "MA-OUJ", "name": "Oujda"}, {"code": "MA-NO", "name": "Nord-Ouest (Morocco)"}, {"code": "MA-CHE", "name": "Chefchaouene"}, {"code": "MA-KEN", "name": "Kénitra"}, {"code": "MA-KHE", "name": "Khemisset"}, {"code": "MA-LAR", "name": "Larache"}, {"code": "MA-RBA", "name": "Rabat-Salé"}, {"code": "MA-SIK", "name": "Sidi Kacem"}, {"code": "MA-TNG", "name": "Tanger"}, {"code": "MA-TET", "name": "Tétouan"}, {"code": "MA-SU", "name": "Sud (Morocco)"}, {"code": "MA-AGD", "name": "Agadir"}, {"code": "MA-BAH", "name": "Aït Baha"}, {"code": "MA-MEL", "name": "Aït Melloul"}, {"code": "MA-ASZ", "name": "Assa-Zag"}, {"code": "MA-BOD", "name": "Boujdour (EH)"}, {"code": "MA-ESM", "name": "Es Semara (EH)"}, {"code": "MA-GUE", "name": "Guelmim"}, {"code": "MA-LAA", "name": "Laayoune (EH)"}, {"code": "MA-OUA", "name": "Ouarzazate"}, {"code": "MA-OUD", "name": "Oued ed Dahab (EH)"}, {"code": "MA-TNT", "name": "Tan-Tan"}, {"code": "MA-TAR", "name": "Taroudannt"}, {"code": "MA-TAT", "name": "Tata"}, {"code": "MA-TIZ", "name": "Tiznit"}, {"code": "MA-TS", "name": "Tensift"}, {"code": "MA-HAO", "name": "Al Haouz"}, {"code": "MA-CHI", "name": "Chichaoua"}, {"code": "MA-ESI", "name": "Essaouira"}, {"code": "MA-KES", "name": "Kelaat Sraghna"}, {"code": "MA-MAR", "name": "Marrakech"}, {"code": "MA-SAF", "name": "Safi"}, {"code": "MZ-MPM", "name": "Maputo (Mozambique)"}, {"code": "MZ-P", "name": "Cabo Delgado"}, {"code": "MZ-G", "name": "Gaza"}, {"code": "MZ-I", "name": "Inhambane"}, {"code": "MZ-B", "name": "Manica"}, {"code": "MZ-L", "name": "Maputo (Mozambique)"}, {"code": "MZ-N", "name": "Nampula"}, {"code": "MZ-A", "name": "Niassa"}, {"code": "MZ-S", "name": "Sofala"}, {"code": "MZ-T", "name": "Tete"}, {"code": "MZ-Q", "name": "Zambézia"}, {"code": "MM-07", "name": "Ayeyarwady"}, {"code": "MM-02", "name": "Bago"}, {"code": "MM-03", "name": "Magway"}, {"code": "MM-04", "name": "Mandalay"}, {"code": "MM-01", "name": "Sagaing"}, {"code": "MM-05", "name": "Tanintharyi"}, {"code": "MM-06", "name": "Yangon"}, {"code": "MM-14", "name": "Chin"}, {"code": "MM-11", "name": "Kachin"}, {"code": "MM-12", "name": "Kayah"}, {"code": "MM-13", "name": "Kayin"}, {"code": "MM-15", "name": "Mon"}, {"code": "MM-16", "name": "Rakhine"}, {"code": "MM-17", "name": "Shan"}, {"code": "NA-CA", "name": "Caprivi"}, {"code": "NA-ER", "name": "Erongo"}, {"code": "NA-HA", "name": "Hardap"}, {"code": "NA-KA", "name": "Karas"}, {"code": "NA-KH", "name": "Khomas"}, {"code": "NA-KU", "name": "Kunene"}, {"code": "NA-OW", "name": "Ohangwena"}, {"code": "NA-OK", "name": "Okavango"}, {"code": "NA-OH", "name": "Omaheke"}, {"code": "NA-OS", "name": "Omusati"}, {"code": "NA-ON", "name": "Oshana"}, {"code": "NA-OT", "name": "Oshikoto"}, {"code": "NA-OD", "name": "Otjozondjupa"}, {"code": "NR-NR", "name": "Nauru"}, {"code": "NP-1", "name": "Madhyamanchal"}, {"code": "NP-BA", "name": "Bagmati"}, {"code": "NP-JA", "name": "Janakpur"}, {"code": "NP-NA", "name": "Narayani"}, {"code": "NP-2", "name": "Madhya Pashchimanchal"}, {"code": "NP-BH", "name": "Bheri"}, {"code": "NP-KA", "name": "Karnali"}, {"code": "NP-RA", "name": "Rapti"}, {"code": "NP-3", "name": "Pashchimanchal"}, {"code": "NP-DH", "name": "Dhawalagiri"}, {"code": "NP-GA", "name": "Gandaki"}, {"code": "NP-LU", "name": "Lumbini"}, {"code": "NP-4", "name": "Purwanchal"}, {"code": "NP-KO", "name": "Kosi [Koshi]"}, {"code": "NP-ME", "name": "Mechi"}, {"code": "NP-SA", "name": "Sagarmatha"}, {"code": "NP-5", "name": "Sudur Pashchimanchal"}, {"code": "NP-MA", "name": "Mahakali"}, {"code": "NP-SE", "name": "Seti"}, {"code": "NL-DR", "name": "Drenthe"}, {"code": "NL-FL", "name": "Flevoland"}, {"code": "NL-FR", "name": "Friesland"}, {"code": "NL-GE", "name": "Gelderland"}, {"code": "NL-GR", "name": "Groningen"}, {"code": "NL-LI", "name": "Limburg"}, {"code": "NL-NB", "name": "Noord-Brabant"}, {"code": "NL-NH", "name": "Noord-Holland"}, {"code": "NL-OV", "name": "Overijssel"}, {"code": "NL-UT", "name": "Utrecht"}, {"code": "NL-ZE", "name": "Zeeland"}, {"code": "NL-ZH", "name": "Zuid-Holland"}, {"code": "AN-AN", "name": "Netherlands Antilles"}, {"code": "NC-NC", "name": "New Caledonia"}, {"code": "NZ-N", "name": "North Island"}, {"code": "NZ-AUK", "name": "Auckland"}, {"code": "NZ-BOP", "name": "Bay of Plenty"}, {"code": "NZ-GIS", "name": "Gisborne"}, {"code": "NZ-HKB", "name": "Hawkes's Bay"}, {"code": "NZ-MWT", "name": "Manawatu-Wanganui"}, {"code": "NZ-NTL", "name": "Northland"}, {"code": "NZ-TKI", "name": "Taranaki"}, {"code": "NZ-WKO", "name": "Waikato"}, {"code": "NZ-WGN", "name": "Wellington"}, {"code": "NZ-S", "name": "South Island"}, {"code": "NZ-CAN", "name": "Canterbury"}, {"code": "NZ-MBH", "name": "Marlborough"}, {"code": "NZ-NSN", "name": "Nelson"}, {"code": "NZ-OTA", "name": "Otago"}, {"code": "NZ-STL", "name": "Southland"}, {"code": "NZ-TAS", "name": "Tasman"}, {"code": "NZ-WTC", "name": "West Coast"}, {"code": "NI-BO", "name": "Boaco"}, {"code": "NI-CA", "name": "Carazo"}, {"code": "NI-CI", "name": "Chinandega"}, {"code": "NI-CO", "name": "Chontales"}, {"code": "NI-ES", "name": "Estelí"}, {"code": "NI-GR", "name": "Granada (Nicaragua)"}, {"code": "NI-JI", "name": "Jinotega"}, {"code": "NI-LE", "name": "León (Nicaragua)"}, {"code": "NI-MD", "name": "Madriz"}, {"code": "NI-MN", "name": "Manaqua"}, {"code": "NI-MS", "name": "Masaya"}, {"code": "NI-MT", "name": "Matagalpa"}, {"code": "NI-NS", "name": "Nueva Segovia"}, {"code": "NI-SJ", "name": "Río San Juan"}, {"code": "NI-RI", "name": "Rivas"}, {"code": "NI-ZE", "name": "Zelaya"}, {"code": "NE-8", "name": "Niamey"}, {"code": "NE-1", "name": "Agadez"}, {"code": "NE-2", "name": "Diffa"}, {"code": "NE-3", "name": "Dosso"}, {"code": "NE-4", "name": "Maradi"}, {"code": "NE-5", "name": "Tahoua"}, {"code": "NE-6", "name": "Tillaberi"}, {"code": "NE-7", "name": "Zinder"}, {"code": "NG-FC", "name": "Abuja Capital Territory"}, {"code": "NG-AB", "name": "Abia"}, {"code": "NG-AD", "name": "Adamawa"}, {"code": "NG-AK", "name": "Akwa Ibom"}, {"code": "NG-AN", "name": "Anambra"}, {"code": "NG-BA", "name": "Bauchi"}, {"code": "NG-BE", "name": "Benue"}, {"code": "NG-BO", "name": "Borno"}, {"code": "NG-CR", "name": "Cross River"}, {"code": "NG-DE", "name": "Delta"}, {"code": "NG-ED", "name": "Edo"}, {"code": "NG-EN", "name": "Enugu"}, {"code": "NG-IM", "name": "Imo"}, {"code": "NG-JI", "name": "Jigawa"}, {"code": "NG-KD", "name": "Kaduna"}, {"code": "NG-KN", "name": "Kano"}, {"code": "NG-KT", "name": "Katsina"}, {"code": "NG-KE", "name": "Kebbi"}, {"code": "NG-KO", "name": "Kogi"}, {"code": "NG-KW", "name": "Kwara"}, {"code": "NG-LA", "name": "Lagos"}, {"code": "NG-NI", "name": "Niger"}, {"code": "NG-OG", "name": "Ogun"}, {"code": "NG-ON", "name": "Ondo"}, {"code": "NG-OS", "name": "Osun"}, {"code": "NG-OY", "name": "Oyo"}, {"code": "NG-PL", "name": "Plateau"}, {"code": "NG-RI", "name": "Rivers"}, {"code": "NG-SO", "name": "Sokoto"}, {"code": "NG-TA", "name": "Taraba"}, {"code": "NG-YO", "name": "Yobe"}, {"code": "NU-NU", "name": "Niue"}, {"code": "NF-NF", "name": "Norfolk Island"}, {"code": "MP-MP", "name": "Northern Mariana Islands (Northern Mariana Islands)"}, {"code": "NO-02", "name": "Akershus"}, {"code": "NO-09", "name": "Aust-Agder"}, {"code": "NO-06", "name": "Buskerud"}, {"code": "NO-20", "name": "Finnmark"}, {"code": "NO-04", "name": "Hedmark"}, {"code": "NO-12", "name": "Hordaland"}, {"code": "NO-15", "name": "Møre og Romsdal"}, {"code": "NO-18", "name": "Nordland"}, {"code": "NO-17", "name": "Nord-Trøndelag"}, {"code": "NO-05", "name": "Oppland"}, {"code": "NO-03", "name": "Oslo"}, {"code": "NO-11", "name": "Rogaland"}, {"code": "NO-14", "name": "Sogn og Fjordane"}, {"code": "NO-16", "name": "Sør-Trøndelag"}, {"code": "NO-08", "name": "Telemark"}, {"code": "NO-19", "name": "Troms"}, {"code": "NO-10", "name": "Vest-Agder"}, {"code": "NO-07", "name": "Vestfold"}, {"code": "NO-01", "name": "Østfold"}, {"code": "NO-22", "name": "Jan Mayen (Arctic Region)"}, {"code": "NO-21", "name": "Svalbard (Arctic Region)"}, {"code": "OM-DA", "name": "Ad Dākhilīyah"}, {"code": "OM-BA", "name": "Al Bāţinah"}, {"code": "OM-JA", "name": "Al Janūbīyah [Zufār]"}, {"code": "OM-WU", "name": "Al Wusţā"}, {"code": "OM-SH", "name": "Ash Sharqīyah (Oman)"}, {"code": "OM-ZA", "name": "Az Zāhirah"}, {"code": "OM-MA", "name": "Masqaţ"}, {"code": "OM-MU", "name": "Musandam"}, {"code": "PK-IS", "name": "Islamabad"}, {"code": "PK-BA", "name": "Baluchistan (Balochistān)"}, {"code": "PK-NW", "name": "North-West Frontier"}, {"code": "PK-PB", "name": "Punjab (Pakistan)"}, {"code": "PK-SD", "name": "Sind (Sindh)"}, {"code": "PK-TA", "name": "Federally Administered Tribal Areas"}, {"code": "PK-JK", "name": "Azad Kashmir"}, {"code": "PK-NA", "name": "Northern Areas"}, {"code": "PW-PW", "name": "Palau (Palau)"}, {"code": "PA-1", "name": "Botas del Toro"}, {"code": "PA-2", "name": "Coclé"}, {"code": "PA-3", "name": "Colón (Panama)"}, {"code": "PA-4", "name": "Chiriquī"}, {"code": "PA-5", "name": "Darién"}, {"code": "PA-6", "name": "Herrera"}, {"code": "PA-7", "name": "Los Santos"}, {"code": "PA-8", "name": "Panamá"}, {"code": "PA-9", "name": "Veraguas"}, {"code": "PA-0", "name": "Comarca de San Blas"}, {"code": "PG-NCD", "name": "National Capital District (Port Moresby)"}, {"code": "PG-CPM", "name": "Central (Papua New Guinea)"}, {"code": "PG-CPK", "name": "Chimbu"}, {"code": "PG-EHG", "name": "Eastern Highlands"}, {"code": "PG-EBR", "name": "East New Britain"}, {"code": "PG-ESW", "name": "East Sepik"}, {"code": "PG-EPW", "name": "Enga"}, {"code": "PG-GPK", "name": "Gulf"}, {"code": "PG-MPM", "name": "Madang"}, {"code": "PG-MRL", "name": "Manus"}, {"code": "PG-MBA", "name": "Milne Bay"}, {"code": "PG-MPL", "name": "Morobe"}, {"code": "PG-NIK", "name": "New Ireland"}, {"code": "PG-NPP", "name": "Northern (Papua New Guinea)"}, {"code": "PG-NSA", "name": "North Solomons"}, {"code": "PG-SAN", "name": "Sandaun [West Sepik]"}, {"code": "PG-SHM", "name": "Southern Highlands"}, {"code": "PG-WPD", "name": "Western (Papua New Guinea)"}, {"code": "PG-WHM", "name": "Western Highlands"}, {"code": "PG-WBK", "name": "West New Britain"}, {"code": "PY-ASU", "name": "Asunción"}, {"code": "PY-16", "name": "Alto Paraguay"}, {"code": "PY-10", "name": "Alto Parang"}, {"code": "PY-13", "name": "Amambay"}, {"code": "PY-19", "name": "Boquerón"}, {"code": "PY-5", "name": "Caaguazú"}, {"code": "PY-6", "name": "Caazapá"}, {"code": "PY-14", "name": "Canindeyú"}, {"code": "PY-11", "name": "Central (Paraguay)"}, {"code": "PY-1", "name": "Concepción"}, {"code": "PY-3", "name": "Cordillera"}, {"code": "PY-4", "name": "Guairá"}, {"code": "PY-7", "name": "Itapúa"}, {"code": "PY-8", "name": "Misiones (Paraguay)"}, {"code": "PY-12", "name": "Neembucú"}, {"code": "PY-9", "name": "Paraguarī"}, {"code": "PY-15", "name": "Presidente Hayes"}, {"code": "PY-2", "name": "San Pedro"}, {"code": "PE-CAL", "name": "El Callao"}, {"code": "PE-AMA", "name": "Amazonas (Peru)"}, {"code": "PE-ANC", "name": "Ancash"}, {"code": "PE-APU", "name": "Apurímac"}, {"code": "PE-ARE", "name": "Arequipa"}, {"code": "PE-AYA", "name": "Ayacucho"}, {"code": "PE-CAJ", "name": "Cajamarca"}, {"code": "PE-CUS", "name": "Cuzco [Cusco]"}, {"code": "PE-HUV", "name": "Huancavelica"}, {"code": "PE-HUC", "name": "Huánuco"}, {"code": "PE-ICA", "name": "Ica"}, {"code": "PE-JUN", "name": "Junín"}, {"code": "PE-LAL", "name": "La Libertad (Peru)"}, {"code": "PE-LAM", "name": "Lambayeque"}, {"code": "PE-LIM", "name": "Lima"}, {"code": "PE-LOR", "name": "Loreto"}, {"code": "PE-MDD", "name": "Madre de Dios"}, {"code": "PE-MOQ", "name": "Moquegua"}, {"code": "PE-PAS", "name": "Pasco"}, {"code": "PE-PIU", "name": "Piura"}, {"code": "PE-PUN", "name": "Puno"}, {"code": "PE-SAM", "name": "San Martín"}, {"code": "PE-TAC", "name": "Tacna"}, {"code": "PE-TUM", "name": "Tumbes"}, {"code": "PE-UCA", "name": "Ucayali"}, {"code": "PH-PH", "name": "Philippines"}, {"code": "PN-PN", "name": "Pitcairn"}, {"code": "PL-BP", "name": "Biała Podlaska"}, {"code": "PL-BK", "name": "Białystok"}, {"code": "PL-BB", "name": "Bielsko"}, {"code": "PL-BY", "name": "Bydgoszcz"}, {"code": "PL-CH", "name": "Chełm"}, {"code": "PL-CI", "name": "Ciechanów"}, {"code": "PL-CZ", "name": "Czestochowa"}, {"code": "PL-EL", "name": "Elblag"}, {"code": "PL-GD", "name": "Gdańsk"}, {"code": "PL-GO", "name": "Gorzów"}, {"code": "PL-JG", "name": "Jelenia Gera"}, {"code": "PL-KL", "name": "Kalisz"}, {"code": "PL-KA", "name": "Katowice"}, {"code": "PL-KI", "name": "Kielce"}, {"code": "PL-KN", "name": "Konin"}, {"code": "PL-KO", "name": "Koszalin"}, {"code": "PL-KR", "name": "Kraków"}, {"code": "PL-KS", "name": "Krosno"}, {"code": "PL-LG", "name": "Legnica"}, {"code": "PL-LE", "name": "Leszno"}, {"code": "PL-LU", "name": "Lublin"}, {"code": "PL-LO", "name": "Łomia"}, {"code": "PL-LD", "name": "Łódź"}, {"code": "PL-NS", "name": "Nowy Sacz"}, {"code": "PL-OL", "name": "Olsztyn"}, {"code": "PL-OP", "name": "Opole"}, {"code": "PL-OS", "name": "Ostrołeka"}, {"code": "PL-PI", "name": "Piła"}, {"code": "PL-PT", "name": "Piotrków"}, {"code": "PL-PL", "name": "Płock"}, {"code": "PL-PO", "name": "Poznań"}, {"code": "PL-PR", "name": "Przemyśl"}, {"code": "PL-RA", "name": "Radom"}, {"code": "PL-RZ", "name": "Rzeszów"}, {"code": "PL-SE", "name": "Siedlce"}, {"code": "PL-SI", "name": "Sieradz"}, {"code": "PL-SK", "name": "Skierniewice"}, {"code": "PL-SL", "name": "Słupsk"}, {"code": "PL-SU", "name": "Suwałki"}, {"code": "PL-SZ", "name": "Szczecin"}, {"code": "PL-TG", "name": "Tarnobrzeg"}, {"code": "PL-TA", "name": "Tarnów"}, {"code": "PL-TO", "name": "Toruń"}, {"code": "PL-WB", "name": "Wałbrzych"}, {"code": "PL-WA", "name": "Warszawa"}, {"code": "PL-WL", "name": "Włocławek"}, {"code": "PL-WR", "name": "Wrocław"}, {"code": "PL-ZA", "name": "Zamość"}, {"code": "PL-ZG", "name": "Zielona Góra"}, {"code": "PT-01", "name": "Aveiro"}, {"code": "PT-02", "name": "Beja"}, {"code": "PT-03", "name": "Braga"}, {"code": "PT-04", "name": "Bragança"}, {"code": "PT-05", "name": "Castelo Branco"}, {"code": "PT-06", "name": "Coimbra"}, {"code": "PT-07", "name": "Évora"}, {"code": "PT-08", "name": "Faro"}, {"code": "PT-09", "name": "Guarda"}, {"code": "PT-10", "name": "Leiria"}, {"code": "PT-11", "name": "Lisboa"}, {"code": "PT-12", "name": "Portalegre"}, {"code": "PT-13", "name": "Porto"}, {"code": "PT-14", "name": "Santarém"}, {"code": "PT-15", "name": "Setúbal"}, {"code": "PT-16", "name": "Viana do Castelo"}, {"code": "PT-17", "name": "Vila Real"}, {"code": "PT-18", "name": "Viseu"}, {"code": "PT-20", "name": "Regiāo Autónoma dos Açores"}, {"code": "PT-30", "name": "Regiāo Autónoma da Madeira"}, {"code": "PR-PR", "name": "Puerto Rico (Puerto Rico)"}, {"code": "QA-DA", "name": "Ad Dawḩah"}, {"code": "QA-GH", "name": "Al Ghuwayrīyah"}, {"code": "QA-JU", "name": "Al Jumaylīyah"}, {"code": "QA-KH", "name": "Al Khawr"}, {"code": "QA-WA", "name": "Al Wakrah"}, {"code": "QA-RA", "name": "Ar Rayyān"}, {"code": "QA-JB", "name": "Jarīyān al Bāţnah"}, {"code": "QA-MS", "name": "Madīnat ash Shamāl"}, {"code": "QA-US", "name": "Umm Şalāl"}, {"code": "RE-RE", "name": "Reunion"}, {"code": "RO-B", "name": "Bucureşti"}, {"code": "RO-AB", "name": "Alba"}, {"code": "RO-AR", "name": "Arad"}, {"code": "RO-AG", "name": "Argeş"}, {"code": "RO-BC", "name": "Bacău"}, {"code": "RO-BH", "name": "Bihor"}, {"code": "RO-BN", "name": "Bistriţa-Năsăud"}, {"code": "RO-BT", "name": "Botoşani"}, {"code": "RO-BV", "name": "Braşov"}, {"code": "RO-BR", "name": "Brăila"}, {"code": "RO-BZ", "name": "Buzău"}, {"code": "RO-CS", "name": "Caraş-Severin"}, {"code": "RO-CL", "name": "Călăraşi (Romania)"}, {"code": "RO-CJ", "name": "Cluj"}, {"code": "RO-CT", "name": "Constanţa"}, {"code": "RO-CV", "name": "Covasna"}, {"code": "RO-DB", "name": "Dâmboviţa"}, {"code": "RO-DJ", "name": "Dolj"}, {"code": "RO-GL", "name": "Galaţi"}, {"code": "RO-GR", "name": "Giurgiu"}, {"code": "RO-GJ", "name": "Gorj"}, {"code": "RO-HR", "name": "Harghita"}, {"code": "RO-HD", "name": "Hunedoara"}, {"code": "RO-IL", "name": "Ialomiţa"}, {"code": "RO-IS", "name": "Iaşi"}, {"code": "RO-MM", "name": "Maramureş"}, {"code": "RO-MH", "name": "Mehedinţi"}, {"code": "RO-MS", "name": "Mureş"}, {"code": "RO-NT", "name": "Neamţ"}, {"code": "RO-OT", "name": "Olt"}, {"code": "RO-PH", "name": "Prahova"}, {"code": "RO-SM", "name": "Satu Mare"}, {"code": "RO-SJ", "name": "Sălaj"}, {"code": "RO-SB", "name": "Sibiu"}, {"code": "RO-SV", "name": "Suceava"}, {"code": "RO-TR", "name": "Teleorman"}, {"code": "RO-TM", "name": "Timiş"}, {"code": "RO-TL", "name": "Tulcea"}, {"code": "RO-VS", "name": "Vaslui"}, {"code": "RO-VL", "name": "Vâlcea"}, {"code": "RO-VN", "name": "Vrancea"}, {"code": "RU-AD", "name": "Adygeya, Respublika"}, {"code": "RU-AL", "name": "Altay, Respublika"}, {"code": "RU-BA", "name": "Bashkortostan, Respublika"}, {"code": "RU-BU", "name": "Buryatiya, Respublika"}, {"code": "RU-CE", "name": "Chechenskaya Respublika"}, {"code": "RU-CU", "name": "Chuvashskaya Respublika"}, {"code": "RU-DA", "name": "Dagestan, Respublika"}, {"code": "RU-IN", "name": "Ingushskaya Respublika"}, {"code": "RU-KB", "name": "Kabardino-Balkarskaya Respublika"}, {"code": "RU-KL", "name": "Kalmykiya, Respublika"}, {"code": "RU-KC", "name": "Karachayevo-Cherkesskaya Respublika"}, {"code": "RU-KR", "name": "Kareliya, Respublika"}, {"code": "RU-KK", "name": "Khakasiya, Respublika"}, {"code": "RU-KO", "name": "Komi, Respublika"}, {"code": "RU-ME", "name": "Mariy El, Respublika"}, {"code": "RU-MO", "name": "Mordoviya, Respublika"}, {"code": "RU-SA", "name": "Sakha, Respublika [Yakutiya]"}, {"code": "RU-SE", "name": "Severnaya Osetiya, Respublika [Alaniya]"}, {"code": "RU-TA", "name": "Tatarstan, Respublika"}, {"code": "RU-TY", "name": "Tyva, Respublika [Tuva]"}, {"code": "RU-UD", "name": "Udmurtskaya Respublika"}, {"code": "RU-ALT", "name": "Altayskiy kray"}, {"code": "RU-KHA", "name": "Khabarovskiy kray"}, {"code": "RU-KDA", "name": "Krasnodarskiy kray"}, {"code": "RU-KYA", "name": "Krasnoyarskiy kray"}, {"code": "RU-PRI", "name": "Primorskiy kray"}, {"code": "RU-STA", "name": "Stavropol 'skiy kray"}, {"code": "RU-AMU", "name": "Amurskaya Oblast'"}, {"code": "RU-ARK", "name": "Arkhangel'skaya Oblast'"}, {"code": "RU-AST", "name": "Astrakhanskaya Oblast'"}, {"code": "RU-BEL", "name": "Belgorodskaya Oblast'"}, {"code": "RU-BRY", "name": "Bryanskaya Oblast'"}, {"code": "RU-CHE", "name": "Chelyabinskaya Oblast'"}, {"code": "RU-CHI", "name": "Chitinskaya Oblast'"}, {"code": "RU-IRK", "name": "Irkutskaya Oblast'"}, {"code": "RU-IVA", "name": "Ivanovskaya Oblast'"}, {"code": "RU-KGD", "name": "Kaliningradskaya Oblast'"}, {"code": "RU-KLU", "name": "Kaluzhskaya Oblast'"}, {"code": "RU-KAM", "name": "Kamchatskaya Oblast'"}, {"code": "RU-KEM", "name": "Kemerovskaya Oblast'"}, {"code": "RU-KIR", "name": "Kirovskaya Oblast'"}, {"code": "RU-KOS", "name": "Kostromskaya Oblast'"}, {"code": "RU-KGN", "name": "Kurganskaya Oblast'"}, {"code": "RU-KRS", "name": "Kurskaya Oblast'"}, {"code": "RU-LEN", "name": "Leningradskaya Oblast'"}, {"code": "RU-LIP", "name": "Lipetskaya Oblast'"}, {"code": "RU-MAG", "name": "Magadanskaya Oblast'"}, {"code": "RU-MOS", "name": "Moskovskaya Oblast'"}, {"code": "RU-MUR", "name": "Murmanskaya Oblast'"}, {"code": "RU-NIZ", "name": "Nizhegorodskaya Oblast'"}, {"code": "RU-NGR", "name": "Novgorodskaya Oblast'"}, {"code": "RU-NVS", "name": "Novosibirskaya Oblast'"}, {"code": "RU-OMS", "name": "Omskaya Oblast'"}, {"code": "RU-ORE", "name": "Orenburgskaya Oblast'"}, {"code": "RU-ORL", "name": "Orlovskaya Oblast'"}, {"code": "RU-PNZ", "name": "Penzenskaya Oblast'"}, {"code": "RU-PER", "name": "Permskaya Oblast'"}, {"code": "RU-PSK", "name": "Pskovskaya Oblast'"}, {"code": "RU-ROS", "name": "Rostovskaya Oblast'"}, {"code": "RU-RYA", "name": "Ryazanskaya Oblast'"}, {"code": "RU-SAK", "name": "Sakhalinskaya Oblast'"}, {"code": "RU-SAM", "name": "Samarskaya Oblast’"}, {"code": "RU-SAR", "name": "Saratovskaya Oblast'"}, {"code": "RU-SMO", "name": "Smolenskaya Oblast'"}, {"code": "RU-SVE", "name": "Sverdlovskaya Oblast'"}, {"code": "RU-TAM", "name": "Tambovskaya Oblast'"}, {"code": "RU-TOM", "name": "Tomskaya Oblast’"}, {"code": "RU-TUL", "name": "Tul'skaya Oblast'"}, {"code": "RU-TVE", "name": "Tverskaya Oblast'"}, {"code": "RU-TYU", "name": "Tyumenskaya Oblast'"}, {"code": "RU-ULY", "name": "Ul'yanovskaya Oblast'"}, {"code": "RU-VLA", "name": "Vladimirskaya Oblast'"}, {"code": "RU-VGG", "name": "Volgogradskaya Oblast'"}, {"code": "RU-VLG", "name": "Vologodskaya Oblast'"}, {"code": "RU-VOR", "name": "Voronezhskaya Oblast'"}, {"code": "RU-YAR", "name": "Yaroslavskaya Oblast'"}, {"code": "RU-MOW", "name": "Moskva"}, {"code": "RU-SPE", "name": "Sankt-Peterburg"}, {"code": "RU-YEV", "name": "Yevreyskaya avtonomnaya oblast'"}, {"code": "RU-AGB", "name": "Aginskiy Buryatskiy avtonomnyy okrug"}, {"code": "RU-CHU", "name": "Chukotskiy avtonomnyy okrug"}, {"code": "RU-EVE", "name": "Evenkiyskiy avtonomnyy okrug"}, {"code": "RU-KHM", "name": "Khanty-Mansiyskiy avtonomnyy okrug"}, {"code": "RU-KOP", "name": "Komi-Permyatskiy avtonomnyy okrug"}, {"code": "RU-KOR", "name": "Koryakskiy avtonomnyy okrug"}, {"code": "RU-NEN", "name": "Nenetskiy avtonomnyy okrug"}, {"code": "RU-TAY", "name": "Taymyrskiy (Dolgano-Nenetskiy) avtonomnyy okrug"}, {"code": "RU-UOB", "name": "Ust’-Ordynskiy Buryatskiy avtonomnyy okrug"}, {"code": "RU-YAN", "name": "Yamalo-Nenetskiy avtonomnyy okrug"}, {"code": "RW-C", "name": "Butare"}, {"code": "RW-I", "name": "Byumba"}, {"code": "RW-E", "name": "Cyangugu"}, {"code": "RW-D", "name": "Gikongoro"}, {"code": "RW-G", "name": "Gisenyi"}, {"code": "RW-B", "name": "Gitarama"}, {"code": "RW-J", "name": "Kibungo"}, {"code": "RW-F", "name": "Kibuye"}, {"code": "RW-K", "name": "Kigali-Rural (Kigali y’ Icyaro)"}, {"code": "RW-L", "name": "Kigali-Ville (Kilgali Ngari)"}, {"code": "RW-M", "name": "Mutara"}, {"code": "RW-H", "name": "Ruhengeri"}, {"code": "SH-SH", "name": "Saint Helena"}, {"code": "SH-AC", "name": "Ascension"}, {"code": "SH-TA", "name": "Tristan da Cunha"}, {"code": "KN-KN", "name": "Saint Kitts & Nevis"}, {"code": "LC-LC", "name": "Saint Lucia"}, {"code": "PM-PM", "name": "St. Pierre & Miquelon"}, {"code": "VC-VC", "name": "St. Vincent & the Grenadines"}, {"code": "WS-AA", "name": "A'ana"}, {"code": "WS-AL", "name": "Aiga-i-le-Tai"}, {"code": "WS-AT", "name": "Atua"}, {"code": "WS-FA", "name": "Fa'asaleleaga"}, {"code": "WS-GE", "name": "Gaga'emauga"}, {"code": "WS-GI", "name": "Gagaifomauga"}, {"code": "WS-PA", "name": "Palauli"}, {"code": "WS-SA", "name": "Satupa'itea"}, {"code": "WS-TU", "name": "Tuamasaga"}, {"code": "WS-VF", "name": "Va'a-o-Fonoti"}, {"code": "WS-VS", "name": "Vaisigano"}, {"code": "SM-SM", "name": "San Marino"}, {"code": "ST-P", "name": "Príncipe"}, {"code": "ST-S", "name": "Sāo Tomé"}, {"code": "SA-11", "name": "Al Bāḩah"}, {"code": "SA-08", "name": "Al Ḩudūd ash Shamālīyah"}, {"code": "SA-12", "name": "Al Jawf (Saudi Arabia)"}, {"code": "SA-03", "name": "Al Madīnah"}, {"code": "SA-05", "name": "Al Qaşim"}, {"code": "SA-O1", "name": "Ar Riyāḑ"}, {"code": "SA-04", "name": "Ash Sharqīyah (Saudi Arabia)"}, {"code": "SA-14", "name": "‘Asīr"}, {"code": "SA-06", "name": "Ḩā'il"}, {"code": "SA-09", "name": "Jīzān"}, {"code": "SA-02", "name": "Makkah"}, {"code": "SA-10", "name": "Najrān"}, {"code": "SA-07", "name": "Tabūk"}, {"code": "SN-DK", "name": "Dakar"}, {"code": "SN-DB", "name": "Diourbel"}, {"code": "SN-FK", "name": "Fatick"}, {"code": "SN-KL", "name": "Kaolack"}, {"code": "SN-KD", "name": "Kolda"}, {"code": "SN-LG", "name": "Louga"}, {"code": "SN-SL", "name": "Saint-Louis"}, {"code": "SN-TC", "name": "Tambacounda"}, {"code": "SN-TH", "name": "Thiès"}, {"code": "SN-ZG", "name": "Ziguinchor"}, {"code": "SC-SC", "name": "Seychelles"}, {"code": "SL-W", "name": "Western Area (Freetown)"}, {"code": "SL-E", "name": "Eastern (Sierra Leone)"}, {"code": "SL-N", "name": "Northern (Sierra Leone)"}, {"code": "SL-S", "name": "Southern (Sierra Leone)"}, {"code": "SG-SG", "name": "Singapore"}, {"code": "SK-BC", "name": "Banskobystrický kraj"}, {"code": "SK-BL", "name": "Bratislavský kraj"}, {"code": "SK-KI", "name": "Košický kraj"}, {"code": "SK-NI", "name": "Nitriansky kraj"}, {"code": "SK-PV", "name": "Prešovský kraj"}, {"code": "SK-TC", "name": "Trenčiansky kraj"}, {"code": "SK-TA", "name": "Trnavský kraj"}, {"code": "SK-ZI", "name": "Žilinský kraj"}, {"code": "SI-07", "name": "Dolenjska"}, {"code": "SI-09", "name": "Gorenjska"}, {"code": "SI-11", "name": "Goriška"}, {"code": "SI-03", "name": "Koroška"}, {"code": "SI-10", "name": "Notranjsko-kraška"}, {"code": "SI-12", "name": "Obalno-kraška"}, {"code": "SI-08", "name": "Osrednjeslovenska"}, {"code": "SI-02", "name": "Podravska"}, {"code": "SI-01", "name": "Pomurska"}, {"code": "SI-04", "name": "Savinjska"}, {"code": "SI-06", "name": "Spodnjeposavska"}, {"code": "SI-05", "name": "Zasavska"}, {"code": "SB-CT", "name": "Capital Territory (Honiara)"}, {"code": "SB-CE", "name": "Central (Solomon Islands)"}, {"code": "SB-GU", "name": "Guadalcanal"}, {"code": "SB-IS", "name": "Isabel"}, {"code": "SB-MK", "name": "Makira"}, {"code": "SB-ML", "name": "Malaita"}, {"code": "SB-TE", "name": "Temotu"}, {"code": "SB-WE", "name": "Western (Solomon Islands)"}, {"code": "SO-AW", "name": "Awdal"}, {"code": "SO-BK", "name": "Bakool"}, {"code": "SO-BN", "name": "Banaadir"}, {"code": "SO-BR", "name": "Bari (Somalia)"}, {"code": "SO-BY", "name": "BaY"}, {"code": "SO-GA", "name": "Galguduud"}, {"code": "SO-GE", "name": "Gedo"}, {"code": "SO-HI", "name": "Hiiraan"}, {"code": "SO-JD", "name": "Jubbada Dhexe"}, {"code": "SO-JH", "name": "Jubbada Hoose"}, {"code": "SO-MU", "name": "Mudug"}, {"code": "SO-NU", "name": "Nugaal"}, {"code": "SO-SA", "name": "Sanaag"}, {"code": "SO-SD", "name": "Shabeellaha Dhexe"}, {"code": "SO-SH", "name": "Shabeellaha Hoose"}, {"code": "SO-SO", "name": "Sool"}, {"code": "SO-TO", "name": "Togdheer"}, {"code": "SO-WO", "name": "Woqooyi Galbeed"}, {"code": "ZA-EC", "name": "Eastern Cape (Oos-Kaap)"}, {"code": "ZA-FS", "name": "Free State (Vrystaat)"}, {"code": "ZA-GT", "name": "Gauteng"}, {"code": "ZA-NL", "name": "Kwazulu-Natal"}, {"code": "ZA-MP", "name": "Mpumalanga"}, {"code": "ZA-NC", "name": "Northern Cape (Noord-Kaap)"}, {"code": "ZA-NP", "name": "Northern Province (Noordelike Provinsie)"}, {"code": "ZA-NW", "name": "North-West (Noord-Wes)"}, {"code": "ZA-WC", "name": "Western Cape (Wes-Kaap)"}, {"code": "GS-GS", "name": "S.Georgia & S.Sandwich Islands"}, {"code": "ES-AN", "name": "Andalucía"}, {"code": "ES-AL", "name": "Almería"}, {"code": "ES-CA", "name": "Cádiz"}, {"code": "ES-CO", "name": "Córdoba (Spain)"}, {"code": "ES-GR", "name": "Granada (Spain)"}, {"code": "ES-H", "name": "Huelva"}, {"code": "ES-J", "name": "Jaén"}, {"code": "ES-MA", "name": "Málaga"}, {"code": "ES-SE", "name": "Sevilla"}, {"code": "ES-AR", "name": "Aragón"}, {"code": "ES-HU", "name": "Huesca"}, {"code": "ES-TE", "name": "Teruel"}, {"code": "ES-Z", "name": "Zaragoza"}, {"code": "ES-O", "name": "Asturias"}, {"code": "ES-CN", "name": "Canarias"}, {"code": "ES-GC", "name": "Las Palmas"}, {"code": "ES-TF", "name": "Santa Cruz De Tenerife"}, {"code": "ES-S", "name": "Cantabria"}, {"code": "ES-CM", "name": "Castilla-La Mancha"}, {"code": "ES-AB", "name": "Albacete"}, {"code": "ES-CR", "name": "Ciudad Real"}, {"code": "ES-CU", "name": "Cuenca"}, {"code": "ES-GU", "name": "Guadalajara"}, {"code": "ES-TO", "name": "Toledo (Spain)"}, {"code": "ES-CL", "name": "Castilla y León"}, {"code": "ES-AV", "name": "Ávila"}, {"code": "ES-BU", "name": "Burgos"}, {"code": "ES-LE", "name": "León (Spain)"}, {"code": "ES-P", "name": "Palencia"}, {"code": "ES-SA", "name": "Salamanca"}, {"code": "ES-SG", "name": "Segovia"}, {"code": "ES-SO", "name": "Soria"}, {"code": "ES-VA", "name": "Valladolid"}, {"code": "ES-ZA", "name": "Zamora"}, {"code": "ES-CT", "name": "Cataluña"}, {"code": "ES-B", "name": "Barcelona"}, {"code": "ES-GE", "name": "Gerona"}, {"code": "ES-L", "name": "Lérida"}, {"code": "ES-T", "name": "Tarragona"}, {"code": "ES-EX", "name": "Extremadura"}, {"code": "ES-BA", "name": "Badajoz"}, {"code": "ES-CC", "name": "Cáceres"}, {"code": "ES-GA", "name": "Galicia"}, {"code": "ES-C", "name": "La Coruña"}, {"code": "ES-LU", "name": "Lugo"}, {"code": "ES-OR", "name": "Orense"}, {"code": "ES-PO", "name": "Pontevedra"}, {"code": "ES-PM", "name": "Baleares"}, {"code": "ES-LO", "name": "La Rioja (Spain)"}, {"code": "ES-M", "name": "Madrid"}, {"code": "ES-MU", "name": "Murcia"}, {"code": "ES-NA", "name": "Navarra"}, {"code": "ES-PV", "name": "País Vasco"}, {"code": "ES-VI", "name": "Álava"}, {"code": "ES-SS", "name": "Guipúzcoa"}, {"code": "ES-BI", "name": "Vizcaya"}, {"code": "ES-VC", "name": "Valenciana, Comunidad"}, {"code": "ES-A", "name": "Alicante"}, {"code": "ES-CS", "name": "Castellón"}, {"code": "ES-V", "name": "Valencia"}, {"code": "LK-1", "name": "Basnahira Palata (Western Province)"}, {"code": "LK-11", "name": "Colombo"}, {"code": "LK-12", "name": "Gampaha"}, {"code": "LK-13", "name": "Kalutara"}, {"code": "LK-3", "name": "Dakunu Palata (Southern Province)"}, {"code": "LK-31", "name": "Galle"}, {"code": "LK-33", "name": "Hambantota"}, {"code": "LK-32", "name": "Matara"}, {"code": "LK-2", "name": "Madhyama Palata (Central Province)"}, {"code": "LK-21", "name": "Kandy"}, {"code": "LK-22", "name": "Matale"}, {"code": "LK-23", "name": "Nuwara Eliya"}, {"code": "LK-5", "name": "Negenahira Palata (Eastern Province)"}, {"code": "LK-52", "name": "Arnpara"}, {"code": "LK-51", "name": "Batticaloa"}, {"code": "LK-53", "name": "Trincomalee"}, {"code": "LK-9", "name": "Sabaragamuwa Palata"}, {"code": "LK-92", "name": "Kegalla"}, {"code": "LK-91", "name": "Ratnapura"}, {"code": "LK-7", "name": "Uturumeda Palata (North Central Province)"}, {"code": "LK-71", "name": "Anuradhapura"}, {"code": "LK-72", "name": "Polonnaruwa"}, {"code": "LK-4", "name": "Uturu Palata (Northern Province)"}, {"code": "LK-41", "name": "Jaffna"}, {"code": "LK-42", "name": "Kilinochchi"}, {"code": "LK-43", "name": "Mannar"}, {"code": "LK-45", "name": "Mullaittivu"}, {"code": "LK-44", "name": "Vavuniya"}, {"code": "LK-8", "name": "Uva Palata"}, {"code": "LK-81", "name": "Badulla"}, {"code": "LK-82", "name": "Monaragala"}, {"code": "LK-6", "name": "Wayamba Palata (North Western Province)"}, {"code": "LK-61", "name": "Kurunegala"}, {"code": "LK-62", "name": "Puttalam"}, {"code": "SD-23", "name": "A‘ālī an Nīl"}, {"code": "SD-26", "name": "Al Baḩr al Aḩmar (Sudan)"}, {"code": "SD-18", "name": "Al Buḩayrāt"}, {"code": "SD-07", "name": "Al Jazīrah"}, {"code": "SD-03", "name": "Al Kharţūm"}, {"code": "SD-06", "name": "Al Qaḑārif"}, {"code": "SD-22", "name": "Al Waḩdah"}, {"code": "SD-04", "name": "An Nīl"}, {"code": "SD-08", "name": "An Nīl al Abyaḑ"}, {"code": "SD-24", "name": "An Nīl al Azraq"}, {"code": "SD-01", "name": "Ash Shamālīyah"}, {"code": "SD-17", "name": "Baḩr al Jabal"}, {"code": "SD-16", "name": "Gharb al Istiwā'īyah"}, {"code": "SD-14", "name": "Gharb Baḩr al Ghazāl"}, {"code": "SD-12", "name": "Gharb Dārfūr"}, {"code": "SD-10", "name": "Gharb Kurdufān"}, {"code": "SD-11", "name": "Janūb Dārfūr"}, {"code": "SD-13", "name": "Janūb Kurdufān"}, {"code": "SD-20", "name": "Jūnqalī"}, {"code": "SD-05", "name": "Kassalā"}, {"code": "SD-15", "name": "Shamāl Baḩr al Ghazāl"}, {"code": "SD-02", "name": "Shamāl Dārfūr"}, {"code": "SD-09", "name": "Shamāl Kurdufān"}, {"code": "SD-19", "name": "Sharq al Istiwā'iyah"}, {"code": "SD-25", "name": "Sinnār"}, {"code": "SD-21", "name": "Wārāb"}, {"code": "SR-BR", "name": "Brokopondo"}, {"code": "SR-CM", "name": "Commewijne"}, {"code": "SR-CR", "name": "Coronie"}, {"code": "SR-MA", "name": "Marowijne"}, {"code": "SR-NI", "name": "Nickerie"}, {"code": "SR-PR", "name": "Para"}, {"code": "SR-PM", "name": "Paramaribo"}, {"code": "SR-SA", "name": "Saramacca"}, {"code": "SR-SI", "name": "Sipaliwini"}, {"code": "SR-WA", "name": "Wanica"}, {"code": "SJ-SJ", "name": "Svalbard & Jan Mayen Islands"}, {"code": "SZ-HH", "name": "Hhohho"}, {"code": "SZ-LU", "name": "Lubombo"}, {"code": "SZ-MA", "name": "Manzini"}, {"code": "SZ-SH", "name": "Shiselweni"}, {"code": "SE-K", "name": "Blekinge län"}, {"code": "SE-W", "name": "Dalarnas län"}, {"code": "SE-I", "name": "Gotlands län"}, {"code": "SE-X", "name": "Gävleborgs län"}, {"code": "SE-N", "name": "Hallands län"}, {"code": "SE-Z", "name": "Jämtlands län"}, {"code": "SE-F", "name": "Jönköpings län"}, {"code": "SE-H", "name": "Kalmar län"}, {"code": "SE-G", "name": "Kronobergs län"}, {"code": "SE-BD", "name": "Norrbottens län"}, {"code": "SE-M", "name": "Skåne län"}, {"code": "SE-AB", "name": "Stockholms län"}, {"code": "SE-D", "name": "Södermanlands län"}, {"code": "SE-C", "name": "Uppsala län"}, {"code": "SE-S", "name": "Värmlands län"}, {"code": "SE-AC", "name": "Västerbottens län"}, {"code": "SE-Y", "name": "Västernorrlands län"}, {"code": "SE-U", "name": "Västmanlands län"}, {"code": "SE-O", "name": "Västra Götalands län"}, {"code": "SE-T", "name": "Örebro län"}, {"code": "SE-E", "name": "Östergötlands län"}, {"code": "CH-AG", "name": "Aargau"}, {"code": "CH-AR", "name": "Appenzell Ausser-Rhoden"}, {"code": "CH-AI", "name": "Appenzell Inner-Rhoden"}, {"code": "CH-BL", "name": "Basel-Landschaft"}, {"code": "CH-BS", "name": "Basel-Stadt"}, {"code": "CH-BE", "name": "Bern"}, {"code": "CH-FR", "name": "Freiburg"}, {"code": "CH-GE", "name": "Geneve"}, {"code": "CH-GL", "name": "Glarus"}, {"code": "CH-GR", "name": "Graubünden"}, {"code": "CH-JU", "name": "Jura (Switzerland)"}, {"code": "CH-LU", "name": "Luzern"}, {"code": "CH-NE", "name": "Neuchatel"}, {"code": "CH-NW", "name": "Nidwalden"}, {"code": "CH-OW", "name": "Obwalden"}, {"code": "CH-SG", "name": "Sankt Gallen"}, {"code": "CH-SH", "name": "Schaffhausen"}, {"code": "CH-SZ", "name": "Schwyz"}, {"code": "CH-SO", "name": "Solothurn"}, {"code": "CH-TG", "name": "Thurgau"}, {"code": "CH-TI", "name": "Ticino"}, {"code": "CH-UR", "name": "Uri"}, {"code": "CH-VS", "name": "Wallis"}, {"code": "CH-VD", "name": "Vaud"}, {"code": "CH-ZG", "name": "Zug"}, {"code": "CH-ZH", "name": "Zürich"}, {"code": "SY-HA", "name": "Al Ḩasakah"}, {"code": "SY-LA", "name": "Al Lādhiqīyah"}, {"code": "SY-QU", "name": "Al Qunayţirah"}, {"code": "SY-RA", "name": "Ar Raqqah"}, {"code": "SY-SU", "name": "As Suwaydā'"}, {"code": "SY-DR", "name": "Dar’ā"}, {"code": "SY-DY", "name": "Dayr az Zawr"}, {"code": "SY-DI", "name": "Dimashq"}, {"code": "SY-HL", "name": "Ḩalab"}, {"code": "SY-HM", "name": "Ḩamāh"}, {"code": "SY-HI", "name": "Ḩimş"}, {"code": "SY-ID", "name": "Idlib"}, {"code": "SY-RD", "name": "Rīf Dimashq"}, {"code": "SY-TA", "name": "Ţarţūs"}, {"code": "TW-KHH", "name": "Kaohsiung"}, {"code": "TW-TPE", "name": "Taipei"}, {"code": "TW-CYI", "name": "Chiayi"}, {"code": "TW-HSZ", "name": "Hsinchu"}, {"code": "TW-KEE", "name": "Keelung"}, {"code": "TW-TXG", "name": "Taichung"}, {"code": "TW-TNN", "name": "Tainan"}, {"code": "TW-CHA", "name": "Changhua"}, {"code": "TW-HUA", "name": "Hualien"}, {"code": "TW-ILA", "name": "Ilan"}, {"code": "TW-MIA", "name": "Miaoli"}, {"code": "TW-NAN", "name": "Nantou"}, {"code": "TW-PEN", "name": "Penghu"}, {"code": "TW-PIF", "name": "Pingtung"}, {"code": "TW-TTT", "name": "Taitung"}, {"code": "TW-TAO", "name": "Taoyuan"}, {"code": "TW-YUN", "name": "Yunlin"}, {"code": "TJ-KR", "name": "Karategin"}, {"code": "TJ-KT", "name": "Khatlon"}, {"code": "TJ-LN", "name": "Leninabad"}, {"code": "TJ-GB", "name": "Gorno-Badakhshan"}, {"code": "TZ-01", "name": "Arusha"}, {"code": "TZ-02", "name": "Dar-es-Salaam"}, {"code": "TZ-03", "name": "Dodoma"}, {"code": "TZ-04", "name": "Iringa"}, {"code": "TZ-05", "name": "Kagera"}, {"code": "TZ-06", "name": "Kaskazini Pemba (Pemba North)"}, {"code": "TZ-07", "name": "Kaskazini Unguja (Zanzibar North)"}, {"code": "TZ-08", "name": "Kigoma"}, {"code": "TZ-09", "name": "Kilimanjaro"}, {"code": "TZ-10", "name": "Kusini Pemba (Pemba South)"}, {"code": "TZ-11", "name": "Kusini Unguja (Zanzibar South)"}, {"code": "TZ-12", "name": "Lindi"}, {"code": "TZ-13", "name": "Mara"}, {"code": "TZ-14", "name": "Mbeya"}, {"code": "TZ-15", "name": "Mjini Magharibi (Zanzibar West)"}, {"code": "TZ-16", "name": "Morogoro"}, {"code": "TZ-17", "name": "Mtwara"}, {"code": "TZ-18", "name": "Mwanza (Tanzania)"}, {"code": "TZ-19", "name": "Pwani (Coast)"}, {"code": "TZ-20", "name": "Rukwa"}, {"code": "TZ-21", "name": "Ruvuma"}, {"code": "TZ-22", "name": "Shinyanga"}, {"code": "TZ-23", "name": "Singida"}, {"code": "TZ-24", "name": "Tabora"}, {"code": "TZ-25", "name": "Tanga"}, {"code": "TH-10", "name": "Krung Thep Maha Nakhon [Bangkok]"}, {"code": "TH-S", "name": "Phatthaya"}, {"code": "TH-37", "name": "Amnat Charoen"}, {"code": "TH-15", "name": "Ang Thong"}, {"code": "TH-31", "name": "Buri Ram"}, {"code": "TH-24", "name": "Chachoengsao"}, {"code": "TH-18", "name": "Chai Nat"}, {"code": "TH-36", "name": "Chaiyaphum"}, {"code": "TH-22", "name": "Chanthaburi"}, {"code": "TH-50", "name": "Chiang Mai"}, {"code": "TH-57", "name": "Chiang Rai"}, {"code": "TH-20", "name": "Chon Buri"}, {"code": "TH-86", "name": "Chumphon"}, {"code": "TH-46", "name": "Kalasin"}, {"code": "TH-62", "name": "Kamphaeng Phet"}, {"code": "TH-71", "name": "Kanchanaburi"}, {"code": "TH-40", "name": "Khon Kaen"}, {"code": "TH-81", "name": "Krabi"}, {"code": "TH-52", "name": "Lampang"}, {"code": "TH-51", "name": "Lamphun"}, {"code": "TH-42", "name": "Loei"}, {"code": "TH-16", "name": "Lop Buri"}, {"code": "TH-58", "name": "Mae Hong Son"}, {"code": "TH-44", "name": "Maha Sarakham"}, {"code": "TH-49", "name": "Mukdahan"}, {"code": "TH-26", "name": "Nakhon Nayok"}, {"code": "TH-73", "name": "Nakhon Pathom"}, {"code": "TH-48", "name": "Nakhon Phanom"}, {"code": "TH-30", "name": "Nakhon Ratchasima"}, {"code": "TH-60", "name": "Nakhon Sawan"}, {"code": "TH-80", "name": "Nakhon Si Thammarat"}, {"code": "TH-55", "name": "Nan"}, {"code": "TH-96", "name": "Narathiwat"}, {"code": "TH-39", "name": "Nong Bua Lam Phu"}, {"code": "TH-43", "name": "Nong Khai"}, {"code": "TH-12", "name": "Nonthaburi"}, {"code": "TH-13", "name": "Pathum Thani"}, {"code": "TH-94", "name": "Pattani"}, {"code": "TH-82", "name": "Phangnga"}, {"code": "TH-93", "name": "Phatthalung"}, {"code": "TH-56", "name": "Phayao"}, {"code": "TH-67", "name": "Phetchabun"}, {"code": "TH-76", "name": "Phetchaburi"}, {"code": "TH-66", "name": "Phichit"}, {"code": "TH-65", "name": "Phitsanulok"}, {"code": "TH-54", "name": "Phrae"}, {"code": "TH-14", "name": "Phra Nakhon Si Ayutthaya"}, {"code": "TH-83", "name": "Phuket"}, {"code": "TH-25", "name": "Prachin Buri"}, {"code": "TH-77", "name": "Prachuap Khiri Khan"}, {"code": "TH-85", "name": "Ranong"}, {"code": "TH-70", "name": "Ratchaburi"}, {"code": "TH-21", "name": "Rayong"}, {"code": "TH-45", "name": "Roi Et"}, {"code": "TH-27", "name": "Sa Kaeo"}, {"code": "TH-47", "name": "Sakon Nakhon"}, {"code": "TH-11", "name": "Samut Prakan"}, {"code": "TH-74", "name": "Samut Sakhon"}, {"code": "TH-75", "name": "Samut Songkhram"}, {"code": "TH-19", "name": "Saraburi"}, {"code": "TH-91", "name": "Satun"}, {"code": "TH-17", "name": "Sing Buri"}, {"code": "TH-33", "name": "Si Sa Ket"}, {"code": "TH-90", "name": "Songkhla"}, {"code": "TH-64", "name": "Sukhothai"}, {"code": "TH-72", "name": "Suphan Buri"}, {"code": "TH-84", "name": "Surat Thani"}, {"code": "TH-32", "name": "Surin"}, {"code": "TH-63", "name": "Tak"}, {"code": "TH-92", "name": "Trang"}, {"code": "TH-23", "name": "Trat"}, {"code": "TH-34", "name": "Ubon Ratchathani"}, {"code": "TH-41", "name": "Udon Thani"}, {"code": "TH-61", "name": "Uthai Thani"}, {"code": "TH-53", "name": "Uttaradit"}, {"code": "TH-95", "name": "Yala"}, {"code": "TH-35", "name": "Yasothon"}, {"code": "TG-C", "name": "Centre (Togo)"}, {"code": "TG-K", "name": "Kara"}, {"code": "TG-M", "name": "Maritime (Région)"}, {"code": "TG-P", "name": "Plateaux (Togo)"}, {"code": "TG-S", "name": "Savannes"}, {"code": "TK-TK", "name": "Tokelau"}, {"code": "TO-TO", "name": "Tonga"}, {"code": "TT-CTT", "name": "Couva-Tabaquite-Talparo"}, {"code": "TT-DMN", "name": "Diego Martin"}, {"code": "TT-ETO", "name": "Eastern Tobago"}, {"code": "TT-PED", "name": "Penal-Debe"}, {"code": "TT-PRT", "name": "Princes Town"}, {"code": "TT-RCM", "name": "Rio Claro-Mayaro"}, {"code": "TT-SGE", "name": "Sangre Grande"}, {"code": "TT-SJL", "name": "San Juan-Laventille"}, {"code": "TT-SIP", "name": "Siparia"}, {"code": "TT-TUP", "name": "Tunapuna-Piarco"}, {"code": "TT-WTO", "name": "Western Tobago"}, {"code": "TT-ARI", "name": "Arima"}, {"code": "TT-CHA", "name": "Chaguanas"}, {"code": "TT-PTF", "name": "Point Fortin"}, {"code": "TT-POS", "name": "Port of Spain"}, {"code": "TT-SFO", "name": "San Fernando"}, {"code": "TN-31", "name": "Béja"}, {"code": "TN-13", "name": "Ben Arous"}, {"code": "TN-23", "name": "Bizerte"}, {"code": "TN-81", "name": "Gabès"}, {"code": "TN-71", "name": "Gafsa"}, {"code": "TN-32", "name": "Jendouba"}, {"code": "TN-41", "name": "Kairouan"}, {"code": "TN-42", "name": "Kasserine"}, {"code": "TN-73", "name": "Kebili"}, {"code": "TN-12", "name": "L'Ariana"}, {"code": "TN-33", "name": "Le Kef"}, {"code": "TN-53", "name": "Mahdia"}, {"code": "TN-82", "name": "Medenine"}, {"code": "TN-52", "name": "Monastir"}, {"code": "TN-21", "name": "Nabeul"}, {"code": "TN-61", "name": "Sfax"}, {"code": "TN-43", "name": "Sidi Bouzid"}, {"code": "TN-34", "name": "Siliana"}, {"code": "TN-51", "name": "Sousse"}, {"code": "TN-83", "name": "Tataouine"}, {"code": "TN-72", "name": "Tozeur"}, {"code": "TN-11", "name": "Tunis"}, {"code": "TN-22", "name": "Zaghouan"}, {"code": "TR-01", "name": "Adana"}, {"code": "TR-02", "name": "Adiyaman"}, {"code": "TR-03", "name": "Afyon"}, {"code": "TR-04", "name": "Ağrı"}, {"code": "TR-68", "name": "Aksaray"}, {"code": "TR-05", "name": "Amasya"}, {"code": "TR-06", "name": "Ankara"}, {"code": "TR-07", "name": "Antalya"}, {"code": "TR-75", "name": "Ardahan"}, {"code": "TR-08", "name": "Artvin"}, {"code": "TR-09", "name": "Aydin"}, {"code": "TR-10", "name": "Balıkesir"}, {"code": "TR-74", "name": "Bartın"}, {"code": "TR-72", "name": "Batman"}, {"code": "TR-69", "name": "Bayburt"}, {"code": "TR-11", "name": "Bilecik"}, {"code": "TR-12", "name": "Bingöl"}, {"code": "TR-13", "name": "Bitlis"}, {"code": "TR-14", "name": "Bolu"}, {"code": "TR-15", "name": "Burdur"}, {"code": "TR-16", "name": "Bursa"}, {"code": "TR-17", "name": "Çanakkale"}, {"code": "TR-18", "name": "Çankırı"}, {"code": "TR-19", "name": "Çorum"}, {"code": "TR-20", "name": "Denizli"}, {"code": "TR-21", "name": "Diyarbakır"}, {"code": "TR-22", "name": "Edirne"}, {"code": "TR-23", "name": "Elaziğ"}, {"code": "TR-24", "name": "Erzincan"}, {"code": "TR-25", "name": "Erzurum"}, {"code": "TR-26", "name": "Eskişehir"}, {"code": "TR-27", "name": "Gaziantep"}, {"code": "TR-28", "name": "Giresun"}, {"code": "TR-29", "name": "Gümüşhane"}, {"code": "TR-30", "name": "Hakkari"}, {"code": "TR-31", "name": "Hatay"}, {"code": "TR-76", "name": "Iğdir"}, {"code": "TR-32", "name": "Isparta"}, {"code": "TR-33", "name": "İçel"}, {"code": "TR-34", "name": "İstanbul"}, {"code": "TR-35", "name": "İzmir"}, {"code": "TR-46", "name": "Kahramanmaraş"}, {"code": "TR-78", "name": "Karabük"}, {"code": "TR-70", "name": "Karaman"}, {"code": "TR-36", "name": "Kars"}, {"code": "TR-37", "name": "Kastamonu"}, {"code": "TR-38", "name": "Kayseri"}, {"code": "TR-71", "name": "Kırıkkale"}, {"code": "TR-39", "name": "Kırklareli"}, {"code": "TR-40", "name": "Kırşehir"}, {"code": "TR-79", "name": "Kilis"}, {"code": "TR-41", "name": "Kocaeli"}, {"code": "TR-42", "name": "Konya"}, {"code": "TR-43", "name": "Kütahya"}, {"code": "TR-44", "name": "Malatya"}, {"code": "TR-4S", "name": "Manisa"}, {"code": "TR-47", "name": "Mardin"}, {"code": "TR-48", "name": "Muğla"}, {"code": "TR-49", "name": "Muş"}, {"code": "TR-SO", "name": "Nevşehir"}, {"code": "TR-51", "name": "Niğde"}, {"code": "TR-52", "name": "Ordu"}, {"code": "TR-53", "name": "Rize"}, {"code": "TR-54", "name": "Sakarya"}, {"code": "TR-SS", "name": "Samsun"}, {"code": "TR-56", "name": "Siirt"}, {"code": "TR-57", "name": "Sinop"}, {"code": "TR-S8", "name": "Sivas"}, {"code": "TR-63", "name": "Şanlıurfa"}, {"code": "TR-73", "name": "Şirnak"}, {"code": "TR-59", "name": "Tekirdağ"}, {"code": "TR-60", "name": "Tokat"}, {"code": "TR-61", "name": "Trabzon"}, {"code": "TR-62", "name": "Tunceli"}, {"code": "TR-64", "name": "Uşak"}, {"code": "TR-65", "name": "Van"}, {"code": "TR-77", "name": "Yalova"}, {"code": "TR-66", "name": "Yozgat"}, {"code": "TR-67", "name": "Zonguldak"}, {"code": "TM-A", "name": "Ahal"}, {"code": "TM-B", "name": "Balkan"}, {"code": "TM-D", "name": "Daşhowuz"}, {"code": "TM-L", "name": "Lebap"}, {"code": "TM-M", "name": "Mary"}, {"code": "TC-TC", "name": "Turks & Caicos Islands"}, {"code": "TV-TV", "name": "Tuvalu"}, {"code": "UG-APA", "name": "Apac"}, {"code": "UG-ARU", "name": "Arua"}, {"code": "UG-BUN", "name": "Bundibugyo"}, {"code": "UG-BUS", "name": "Bushenyi"}, {"code": "UG-GUL", "name": "Gulu"}, {"code": "UG-HOI", "name": "Hoima"}, {"code": "UG-IGA", "name": "Iganga"}, {"code": "UG-JIN", "name": "Jinja"}, {"code": "UG-KBL", "name": "Kabale"}, {"code": "UG-KBR", "name": "Kabarole"}, {"code": "UG-KLG", "name": "Kalangala"}, {"code": "UG-KLA", "name": "Kampala"}, {"code": "UG-KLI", "name": "Kamuli"}, {"code": "UG-KAP", "name": "Kapchorwa"}, {"code": "UG-KAS", "name": "Kasese"}, {"code": "UG-KLE", "name": "Kibaale"}, {"code": "UG-KIB", "name": "Kiboga"}, {"code": "UG-KIS", "name": "Kisoro"}, {"code": "UG-KIT", "name": "Kitgum"}, {"code": "UG-KOT", "name": "Kotido"}, {"code": "UG-KUM", "name": "Kumi"}, {"code": "UG-LIR", "name": "Lira"}, {"code": "UG-LUW", "name": "Luwero"}, {"code": "UG-MSK", "name": "Masaka"}, {"code": "UG-MSI", "name": "Masindi"}, {"code": "UG-MBL", "name": "Mbale"}, {"code": "UG-MBR", "name": "Mbarara"}, {"code": "UG-MOR", "name": "Moroto"}, {"code": "UG-MOY", "name": "Moyo"}, {"code": "UG-MPI", "name": "Mpigi"}, {"code": "UG-MUB", "name": "Mubende"}, {"code": "UG-MUK", "name": "Mukono"}, {"code": "UG-NEB", "name": "Nebbi"}, {"code": "UG-NTU", "name": "Ntungamo"}, {"code": "UG-PAL", "name": "Pallisa"}, {"code": "UG-RAK", "name": "Rakai"}, {"code": "UG-RUK", "name": "Rukungiri"}, {"code": "UG-SOR", "name": "Soroti"}, {"code": "UG-TOR", "name": "Tororo"}, {"code": "UA-71", "name": "Cherkas'ka Oblast'"}, {"code": "UA-74", "name": "Chernihivs'ka Oblast'"}, {"code": "UA-77", "name": "Chernivets'ka Oblast'"}, {"code": "UA-12", "name": "Dnipropetrovs'ka Oblast'"}, {"code": "UA-14", "name": "Donets'ka Oblast'"}, {"code": "UA-26", "name": "Ivano-Frankivs'ka Oblast'"}, {"code": "UA-63", "name": "Kharkivs'ka Oblast'"}, {"code": "UA-65", "name": "Khersons'ka Oblast'"}, {"code": "UA-68", "name": "Khmel'nyts'ka Oblast'"}, {"code": "UA-35", "name": "Kirovohrads'ka Oblast'"}, {"code": "UA-32", "name": "Kyïvs'ka Oblast'"}, {"code": "UA-09", "name": "Luhans'ka Oblast'"}, {"code": "UA-46", "name": "L'vivs'ka Oblast'"}, {"code": "UA-48", "name": "Mykolaïvs'ka Oblast'"}, {"code": "UA-51", "name": "Odes'ka Oblast'"}, {"code": "UA-53", "name": "Poltavs'ka Oblast'"}, {"code": "UA-56", "name": "Rivnens'ka Oblast'"}, {"code": "UA-59", "name": "Sums'ka Oblast'"}, {"code": "UA-61", "name": "Ternopil's'ka Oblast'"}, {"code": "UA-05", "name": "Vinnyts'ka Oblast'"}, {"code": "UA-07", "name": "Volyns'ka Oblast'"}, {"code": "UA-21", "name": "Zakarpats'ka Oblast'"}, {"code": "UA-23", "name": "Zaporiz'ka Oblast'"}, {"code": "UA-18", "name": "Zhytomyrs'ka Oblast'"}, {"code": "UA-43", "name": "Respublika Krym"}, {"code": "UA-30", "name": "Kyïv"}, {"code": "UA-40", "name": "Sevastopol'"}, {"code": "AE-AZ", "name": "Abū Zaby (Abu Dhabi)"}, {"code": "AE-AJ", "name": "‘Ajmān"}, {"code": "AE-FU", "name": "Al Fujayrah"}, {"code": "AE-SH", "name": "Ash Shāriqah (Sharjah)"}, {"code": "AE-DU", "name": "Dubayy (Dubai)"}, {"code": "AE-RK", "name": "R'as al Khaymah"}, {"code": "AE-UQ", "name": "Umm al Qaywayn"}, {"code": "US-AL", "name": "Alabama"}, {"code": "US-AK", "name": "Alaska"}, {"code": "US-AZ", "name": "Arizona"}, {"code": "US-AR", "name": "Arkansas"}, {"code": "US-CA", "name": "California"}, {"code": "US-CO", "name": "Colorado"}, {"code": "US-CT", "name": "Connecticut"}, {"code": "US-DE", "name": "Delaware"}, {"code": "US-FL", "name": "Florida (United States)"}, {"code": "US-GA", "name": "Georgia"}, {"code": "US-HI", "name": "Hawaii"}, {"code": "US-ID", "name": "Idaho"}, {"code": "US-IL", "name": "Illinois"}, {"code": "US-IN", "name": "Indiana"}, {"code": "US-IA", "name": "Iowa"}, {"code": "US-KS", "name": "Kansas"}, {"code": "US-KY", "name": "Kentucky"}, {"code": "US-LA", "name": "Louisiana"}, {"code": "US-ME", "name": "Maine"}, {"code": "US-MD", "name": "Maryland (United States)"}, {"code": "US-MA", "name": "Massachusetts"}, {"code": "US-MI", "name": "Michigan"}, {"code": "US-MN", "name": "Minnesota"}, {"code": "US-MS", "name": "Mississippi"}, {"code": "US-MO", "name": "Missouri"}, {"code": "US-MT", "name": "Montana (United States)"}, {"code": "US-NE", "name": "Nebraska"}, {"code": "US-NV", "name": "Nevada"}, {"code": "US-NH", "name": "New Hampshire"}, {"code": "US-NJ", "name": "New Jersey"}, {"code": "US-NM", "name": "New Mexico"}, {"code": "US-NY", "name": "New York"}, {"code": "US-NC", "name": "North Carolina"}, {"code": "US-ND", "name": "North Dakota"}, {"code": "US-OH", "name": "Ohio"}, {"code": "US-OK", "name": "Oklahoma"}, {"code": "US-OR", "name": "Oregon"}, {"code": "US-PA", "name": "Pennsylvania"}, {"code": "US-RI", "name": "Rhode Island"}, {"code": "US-SC", "name": "South Carolina"}, {"code": "US-SD", "name": "South Dakota"}, {"code": "US-TN", "name": "Tennessee"}, {"code": "US-TX", "name": "Texas"}, {"code": "US-UT", "name": "Utah"}, {"code": "US-VT", "name": "Vermont"}, {"code": "US-VA", "name": "Virginia"}, {"code": "US-WA", "name": "Washington"}, {"code": "US-WV", "name": "West Virginia"}, {"code": "US-WI", "name": "Wisconsin"}, {"code": "US-WY", "name": "Wyoming"}, {"code": "US-DC", "name": "District of Columbia"}, {"code": "US-AS", "name": "American Samoa (United States)"}, {"code": "US-GU", "name": "Guam (United States)"}, {"code": "US-MP", "name": "Northern Mariana Islands (United States)"}, {"code": "US-PR", "name": "Puerto Rico (United States)"}, {"code": "US-UM", "name": "United States Minor Outlying Islands"}, {"code": "US-VI", "name": "Virgin Islands, U.S."}, {"code": "UY-AR", "name": "Artigas"}, {"code": "UY-CA", "name": "Canelones"}, {"code": "UY-CL", "name": "Cerro Largo"}, {"code": "UY-CO", "name": "Colonia"}, {"code": "UY-DU", "name": "Durazno"}, {"code": "UY-FS", "name": "Flores"}, {"code": "UY-FD", "name": "Florida (Uruguay)"}, {"code": "UY-LA", "name": "Lavalleja"}, {"code": "UY-MA", "name": "Maldonado"}, {"code": "UY-MO", "name": "Montevideo"}, {"code": "UY-PA", "name": "Paysandú"}, {"code": "UY-RN", "name": "Río Negro (Uruguay)"}, {"code": "UY-RV", "name": "Rivera"}, {"code": "UY-RO", "name": "Rocha"}, {"code": "UY-SA", "name": "Salto"}, {"code": "UY-SJ", "name": "San José (Uruguay)"}, {"code": "UY-SO", "name": "Soriano"}, {"code": "UY-TA", "name": "Tacuarembó"}, {"code": "UY-TT", "name": "Treinta y Tres"}, {"code": "UZ-QR", "name": "Qoraqalpoghiston Respublikasi (Karakalpakstan, Respublika)"}, {"code": "UZ-AN", "name": "Andijon (Andizhan)"}, {"code": "UZ-BU", "name": "Bukhoro (Bukhara)"}, {"code": "UZ-FA", "name": "Farghona (Fergana)"}, {"code": "UZ-JI", "name": "Jizzakh (Dzhizak)"}, {"code": "UZ-KH", "name": "Khorazm (Khorezm)"}, {"code": "UZ-NG", "name": "Namangan"}, {"code": "UZ-NW", "name": "Nawoiy (Navoi)"}, {"code": "UZ-QA", "name": "Qashqadaryo (Kashkadar'ya)"}, {"code": "UZ-SA", "name": "Samarqand (Samarkand)"}, {"code": "UZ-SI", "name": "Sirdaryo (Syrdar'ya)"}, {"code": "UZ-SU", "name": "Surkhondaryo (Surkhandar'ya)"}, {"code": "UZ-TO", "name": "Toshkent (Tashkent)"}, {"code": "VU-MAP", "name": "Malampa"}, {"code": "VU-PAM", "name": "Pénama"}, {"code": "VU-SAM", "name": "Sanma"}, {"code": "VU-SEE", "name": "Shéfa"}, {"code": "VU-TAE", "name": "Taféa"}, {"code": "VU-TOB", "name": "Torba"}, {"code": "VE-A", "name": "Distrito Federal (Venezuela)"}, {"code": "VE-B", "name": "Anzoátegui"}, {"code": "VE-C", "name": "Apure"}, {"code": "VE-D", "name": "Aragua"}, {"code": "VE-E", "name": "Barinas"}, {"code": "VE-F", "name": "Bolívar (Venezuela)"}, {"code": "VE-G", "name": "Carabobo"}, {"code": "VE-H", "name": "Cojedes"}, {"code": "VE-I", "name": "Falcón"}, {"code": "VE-J", "name": "Guárico"}, {"code": "VE-K", "name": "Lara"}, {"code": "VE-L", "name": "Mérida"}, {"code": "VE-M", "name": "Miranda"}, {"code": "VE-N", "name": "Monagas"}, {"code": "VE-O", "name": "Nueva Esparta"}, {"code": "VE-P", "name": "Portuguesa"}, {"code": "VE-R", "name": "Sucre (Venezuela)"}, {"code": "VE-S", "name": "Táchira"}, {"code": "VE-T", "name": "Trujillo"}, {"code": "VE-U", "name": "Yaracuy"}, {"code": "VE-V", "name": "Zulia"}, {"code": "VE-Z", "name": "Amazonas (Venezuela)"}, {"code": "VE-Y", "name": "Delta Amacuro"}, {"code": "VE-W", "name": "Dependencias Federales"}, {"code": "VN-44", "name": "An Giang"}, {"code": "VN-53", "name": "Bat Can"}, {"code": "VN-54", "name": "Bat Giang"}, {"code": "VN-55", "name": "Bat Lieu"}, {"code": "VN-56", "name": "Bat Ninh"}, {"code": "VN-43", "name": "Ba Ria - Vung Tau"}, {"code": "VN-50", "name": "Ben Tre"}, {"code": "VN-31", "name": "Binh Dinh"}, {"code": "VN-57", "name": "Binh Duong"}, {"code": "VN-58", "name": "Binh Phuoc"}, {"code": "VN-40", "name": "Binh Thuan"}, {"code": "VN-59", "name": "Ca Mau"}, {"code": "VN-48", "name": "Can Tho"}, {"code": "VN-04", "name": "Cao Bang"}, {"code": "VN-33", "name": "Dac Lac"}, {"code": "VN-60", "name": "Da Nang, thanh pho"}, {"code": "VN-39", "name": "Dong Nai"}, {"code": "VN-45", "name": "Dong Thap"}, {"code": "VN-30", "name": "Gia Lai"}, {"code": "VN-03", "name": "Ha Giang"}, {"code": "VN-61", "name": "Hai Duong"}, {"code": "VN-62", "name": "Hai Phong, thanh pho"}, {"code": "VN-63", "name": "Ha Nam"}, {"code": "VN-64", "name": "Ha Noi, thu do"}, {"code": "VN-15", "name": "Ha Tay"}, {"code": "VN-23", "name": "Ha Tinh"}, {"code": "VN-14", "name": "Hoa Binh"}, {"code": "VN-65", "name": "Ho Chi Minh, thanh po [Sai Gon]"}, {"code": "VN-66", "name": "Hung Yen"}, {"code": "VN-34", "name": "Khanh Hoa"}, {"code": "VN-47", "name": "Kien Giang"}, {"code": "VN-28", "name": "Kon Turn"}, {"code": "VN-01", "name": "Lai Chau"}, {"code": "VN-35", "name": "Lam Dong"}, {"code": "VN-09", "name": "Lang Son"}, {"code": "VN-02", "name": "Lao Cai"}, {"code": "VN-41", "name": "Long An"}, {"code": "VN-67", "name": "Nam Dinh"}, {"code": "VN-22", "name": "Nghe An"}, {"code": "VN-18", "name": "Ninh Binh"}, {"code": "VN-36", "name": "Ninh Thuan"}, {"code": "VN-68", "name": "Phu Tho"}, {"code": "VN-32", "name": "Phu Yen"}, {"code": "VN-24", "name": "Quang Ninh"}, {"code": "VN-27", "name": "Quang Nam"}, {"code": "VN-29", "name": "Quang Ngai"}, {"code": "VN-25", "name": "Quang Tri"}, {"code": "VN-52", "name": "Sec Trang"}, {"code": "VN-05", "name": "Son La"}, {"code": "VN-37", "name": "Tay Ninh"}, {"code": "VN-20", "name": "Thai Binh"}, {"code": "VN-69", "name": "Thai Nguyen"}, {"code": "VN-21", "name": "Thanh Hoa"}, {"code": "VN-26", "name": "Thua Thien-Hue"}, {"code": "VN-46", "name": "Tien Giang"}, {"code": "VN-51", "name": "Tra Vinh"}, {"code": "VN-07", "name": "Tuyen Quang"}, {"code": "VN-49", "name": "Vinh Long"}, {"code": "VN-70", "name": "Vinh Yen"}, {"code": "VN-06", "name": "Yen Bai"}, {"code": "VG-VG", "name": "Virgin Islands (British)"}, {"code": "VI-VI", "name": "Virgin Islands (U.S.)"}, {"code": "WF-WF", "name": "Wallis & Futuna Islands"}, {"code": "EH-EH", "name": "Western Sahara"}, {"code": "YE-AB", "name": "Abyān"}, {"code": "YE-AD", "name": "‘Adan"}, {"code": "YE-BA", "name": "Al Bayḑā'"}, {"code": "YE-HU", "name": "Al Ḩudaydah"}, {"code": "YE-JA", "name": "Al Jawf (Yemen)"}, {"code": "YE-MR", "name": "Al Mahrah"}, {"code": "YE-MW", "name": "Al Maḩwit"}, {"code": "YE-DH", "name": "Dhamār"}, {"code": "YE-HD", "name": "Ḩaḑramawt"}, {"code": "YE-HJ", "name": "Ḩajjah"}, {"code": "YE-IB", "name": "Ibb"}, {"code": "YE-LA", "name": "Laḩij"}, {"code": "YE-MA", "name": "Ma'rib"}, {"code": "YE-SD", "name": "Şa'dah"}, {"code": "YE-SN", "name": "Şan‘ā'"}, {"code": "YE-SH", "name": "Shabwah"}, {"code": "YE-TA", "name": "Ta‘izz"}, {"code": "YU-CG", "name": "Crna Gora"}, {"code": "YU-SR", "name": "Srbija"}, {"code": "YU-KM", "name": "Kosovo-Metohija"}, {"code": "YU-VO", "name": "Vojvodina"}, {"code": "ZM-02", "name": "Central (Zambia)"}, {"code": "ZM-08", "name": "Copperbelt"}, {"code": "ZM-03", "name": "Eastern (Zambia)"}, {"code": "ZM-04", "name": "Luapula"}, {"code": "ZM-09", "name": "Lusaka"}, {"code": "ZM-05", "name": "Northern (Zambia)"}, {"code": "ZM-06", "name": "North-Western"}, {"code": "ZM-07", "name": "Southern (Zambia)"}, {"code": "ZM-01", "name": "Western (Zambia)"}, {"code": "ZW-BU", "name": "Bulawayo"}, {"code": "ZW-HA", "name": "Harare"}, {"code": "ZW-MA", "name": "Manicaland"}, {"code": "ZW-MC", "name": "Mashonaland Central"}, {"code": "ZW-ME", "name": "Mashonaland East"}, {"code": "ZW-MW", "name": "Mashonaland West"}, {"code": "ZW-MV", "name": "Masvingo"}, {"code": "ZW-MN", "name": "Matabeleland North"}, {"code": "ZW-MS", "name": "Matabeleland South"}, {"code": "ZW-MI", "name": "Midlands"} ];
  const countries = [{"name": "Afghanistan", "code": "AF"}, {"name": "Albania", "code": "AL"}, {"name": "Algeria", "code": "DZ"}, {"name": "American Samoa", "code": "AS"}, {"name": "AndorrA", "code": "AD"}, {"name": "Angola", "code": "AO"}, {"name": "Anguilla", "code": "AI"}, {"name": "Antarctica", "code": "AQ"}, {"name": "Antigua and Barbuda", "code": "AG"}, {"name": "Argentina", "code": "AR"}, {"name": "Armenia", "code": "AM"}, {"name": "Aruba", "code": "AW"}, {"name": "Australia", "code": "AU"}, {"name": "Austria", "code": "AT"}, {"name": "Azerbaijan", "code": "AZ"}, {"name": "Bahamas", "code": "BS"}, {"name": "Bahrain", "code": "BH"}, {"name": "Bangladesh", "code": "BD"}, {"name": "Barbados", "code": "BB"}, {"name": "Belarus", "code": "BY"}, {"name": "Belgium", "code": "BE"}, {"name": "Belize", "code": "BZ"}, {"name": "Benin", "code": "BJ"}, {"name": "Bermuda", "code": "BM"}, {"name": "Bhutan", "code": "BT"}, {"name": "Bolivia", "code": "BO"}, {"name": "Bosnia and Herzegovina", "code": "BA"}, {"name": "Botswana", "code": "BW"}, {"name": "Bouvet Island", "code": "BV"}, {"name": "Brazil", "code": "BR"}, {"name": "British Indian Ocean Territory", "code": "IO"}, {"name": "Brunei Darussalam", "code": "BN"}, {"name": "Bulgaria", "code": "BG"}, {"name": "Burkina Faso", "code": "BF"}, {"name": "Burundi", "code": "BI"}, {"name": "Cambodia", "code": "KH"}, {"name": "Cameroon", "code": "CM"}, {"name": "Canada", "code": "CA"}, {"name": "Cape Verde", "code": "CV"}, {"name": "Cayman Islands", "code": "KY"}, {"name": "Central African Republic", "code": "CF"}, {"name": "Chad", "code": "TD"}, {"name": "Chile", "code": "CL"}, {"name": "China", "code": "CN"}, {"name": "Christmas Island", "code": "CX"}, {"name": "Cocos (Keeling) Islands", "code": "CC"}, {"name": "Colombia", "code": "CO"}, {"name": "Comoros", "code": "KM"}, {"name": "Congo", "code": "CG"}, {"name": "Congo, The Democratic Republic of the", "code": "CD"}, {"name": "Cook Islands", "code": "CK"}, {"name": "Costa Rica", "code": "CR"}, {"name": "Cote D^Ivoire", "code": "CI"}, {"name": "Croatia", "code": "HR"}, {"name": "Cuba", "code": "CU"}, {"name": "Cyprus", "code": "CY"}, {"name": "Czech Republic", "code": "CZ"},{"name": "Curacao", "code": "CW"}, {"name": "Denmark", "code": "DK"}, {"name": "Djibouti", "code": "DJ"}, {"name": "Dominica", "code": "DM"}, {"name": "Dominican Republic", "code": "DO"}, {"name": "Ecuador", "code": "EC"}, {"name": "Egypt", "code": "EG"}, {"name": "El Salvador", "code": "SV"}, {"name": "Equatorial Guinea", "code": "GQ"}, {"name": "Eritrea", "code": "ER"}, {"name": "Estonia", "code": "EE"}, {"name": "Ethiopia", "code": "ET"}, {"name": "Falkland Islands (Malvinas)", "code": "FK"}, {"name": "Faroe Islands", "code": "FO"}, {"name": "Fiji", "code": "FJ"}, {"name": "Finland", "code": "FI"}, {"name": "France", "code": "FR"}, {"name": "French Guiana", "code": "GF"}, {"name": "French Polynesia", "code": "PF"}, {"name": "French Southern Territories", "code": "TF"}, {"name": "Gabon", "code": "GA"}, {"name": "Gambia", "code": "GM"}, {"name": "Georgia", "code": "GE"}, {"name": "Germany", "code": "DE"}, {"name": "Ghana", "code": "GH"}, {"name": "Gibraltar", "code": "GI"}, {"name": "Greece", "code": "GR"}, {"name": "Greenland", "code": "GL"}, {"name": "Grenada", "code": "GD"}, {"name": "Guadeloupe", "code": "GP"}, {"name": "Guam", "code": "GU"}, {"name": "Guatemala", "code": "GT"}, {"name": "Guernsey", "code": "GG"}, {"name": "Guinea", "code": "GN"}, {"name": "Guinea-Bissau", "code": "GW"}, {"name": "Guyana", "code": "GY"}, {"name": "Haiti", "code": "HT"}, {"name": "Heard Island and Mcdonald Islands", "code": "HM"}, {"name": "Holy See (Vatican City State)", "code": "VA"}, {"name": "Honduras", "code": "HN"}, {"name": "Hong Kong", "code": "HK"}, {"name": "Hungary", "code": "HU"}, {"name": "Iceland", "code": "IS"}, {"name": "India", "code": "IN"}, {"name": "Indonesia", "code": "ID"}, {"name": "Iran, Islamic Republic Of", "code": "IR"}, {"name": "Iraq", "code": "IQ"}, {"name": "Ireland", "code": "IE"}, {"name": "Isle of Man", "code": "IM"}, {"name": "Israel", "code": "IL"}, {"name": "Italy", "code": "IT"}, {"name": "Jamaica", "code": "JM"}, {"name": "Japan", "code": "JP"}, {"name": "Jersey", "code": "JE"}, {"name": "Jordan", "code": "JO"}, {"name": "Kazakhstan", "code": "KZ"}, {"name": "Kenya", "code": "KE"}, {"name": "Kiribati", "code": "KI"}, {"name": "Korea, Democratic People^s Republic of", "code": "KP"}, {"name": "Korea, Republic of", "code": "KR"}, {"name": "Kuwait", "code": "KW"}, {"name": "Kyrgyzstan", "code": "KG"}, {"name": "Lao People^s Democratic Republic", "code": "LA"}, {"name": "Latvia", "code": "LV"}, {"name": "Lebanon", "code": "LB"}, {"name": "Lesotho", "code": "LS"}, {"name": "Liberia", "code": "LR"}, {"name": "Libyan Arab Jamahiriya", "code": "LY"}, {"name": "Liechtenstein", "code": "LI"}, {"name": "Lithuania", "code": "LT"}, {"name": "Luxembourg", "code": "LU"}, {"name": "Macao", "code": "MO"}, {"name": "Macedonia, The Former Yugoslav Republic of", "code": "MK"}, {"name": "Madagascar", "code": "MG"}, {"name": "Malawi", "code": "MW"}, {"name": "Malaysia", "code": "MY"}, {"name": "Maldives", "code": "MV"}, {"name": "Mali", "code": "ML"}, {"name": "Malta", "code": "MT"}, {"name": "Marshall Islands", "code": "MH"}, {"name": "Martinique", "code": "MQ"}, {"name": "Mauritania", "code": "MR"}, {"name": "Mauritius", "code": "MU"}, {"name": "Mayotte", "code": "YT"}, {"name": "Mexico", "code": "MX"}, {"name": "Micronesia, Federated States of", "code": "FM"}, {"name": "Moldova, Republic of", "code": "MD"}, {"name": "Monaco", "code": "MC"}, {"name": "Mongolia", "code": "MN"}, {"name": "Montserrat", "code": "MS"}, {"name": "Morocco", "code": "MA"}, {"name": "Mozambique", "code": "MZ"}, {"name": "Myanmar", "code": "MM"}, {"name": "Namibia", "code": "NA"}, {"name": "Nauru", "code": "NR"}, {"name": "Nepal", "code": "NP"}, {"name": "Netherlands", "code": "NL"}, {"name": "Netherlands Antilles", "code": "AN"}, {"name": "New Caledonia", "code": "NC"}, {"name": "New Zealand", "code": "NZ"}, {"name": "Nicaragua", "code": "NI"}, {"name": "Niger", "code": "NE"}, {"name": "Nigeria", "code": "NG"}, {"name": "Niue", "code": "NU"}, {"name": "Norfolk Island", "code": "NF"}, {"name": "Northern Mariana Islands", "code": "MP"}, {"name": "Norway", "code": "NO"}, {"name": "Oman", "code": "OM"}, {"name": "Pakistan", "code": "PK"}, {"name": "Palau", "code": "PW"}, {"name": "Palestinian Territory, Occupied", "code": "PS"}, {"name": "Panama", "code": "PA"}, {"name": "Papua New Guinea", "code": "PG"}, {"name": "Paraguay", "code": "PY"}, {"name": "Peru", "code": "PE"}, {"name": "Philippines", "code": "PH"}, {"name": "Pitcairn", "code": "PN"}, {"name": "Poland", "code": "PL"}, {"name": "Portugal", "code": "PT"}, {"name": "Puerto Rico", "code": "PR"}, {"name": "Qatar", "code": "QA"}, {"name": "Reunion", "code": "RE"}, {"name": "Romania", "code": "RO"}, {"name": "Russian Federation", "code": "RU"}, {"name": "RWANDA", "code": "RW"}, {"name": "Saint Helena", "code": "SH"}, {"name": "Saint Kitts and Nevis", "code": "KN"}, {"name": "Saint Lucia", "code": "LC"}, {"name": "Saint Pierre and Miquelon", "code": "PM"}, {"name": "Saint Vincent and the Grenadines", "code": "VC"}, {"name": "Samoa", "code": "WS"}, {"name": "San Marino", "code": "SM"}, {"name": "Sao Tome and Principe", "code": "ST"}, {"name": "Saudi Arabia", "code": "SA"}, {"name": "Senegal", "code": "SN"}, {"name": "Serbia", "code": "RS"},{"name": "Montenegro", "code": "ME"}, {"name": "Seychelles", "code": "SC"}, {"name": "Sierra Leone", "code": "SL"}, {"name": "Singapore", "code": "SG"}, {"name": "Slovakia", "code": "SK"}, {"name": "Slovenia", "code": "SI"}, {"name": "Solomon Islands", "code": "SB"}, {"name": "Somalia", "code": "SO"}, {"name": "South Africa", "code": "ZA"}, {"name": "South Georgia and the South Sandwich Islands", "code": "GS"}, {"name": "Spain", "code": "ES"}, {"name": "Sri Lanka", "code": "LK"}, {"name": "Sudan", "code": "SD"}, {"name": "Suri", "code": "SR"}, {"name": "Svalbard and Jan Mayen", "code": "SJ"}, {"name": "Swaziland", "code": "SZ"}, {"name": "Sweden", "code": "SE"}, {"name": "Switzerland", "code": "CH"}, {"name": "Syrian Arab Republic", "code": "SY"}, {"name": "Taiwan, Province of China", "code": "TW"}, {"name": "Tajikistan", "code": "TJ"}, {"name": "Tanzania, United Republic of", "code": "TZ"}, {"name": "Thailand", "code": "TH"}, {"name": "Timor-Leste", "code": "TL"}, {"name": "Togo", "code": "TG"}, {"name": "Tokelau", "code": "TK"}, {"name": "Tonga", "code": "TO"}, {"name": "Trinidad and Tobago", "code": "TT"}, {"name": "Tunisia", "code": "TN"}, {"name": "Turkey", "code": "TR"}, {"name": "Turkmenistan", "code": "TM"}, {"name": "Turks and Caicos Islands", "code": "TC"}, {"name": "Tuvalu", "code": "TV"}, {"name": "Uganda", "code": "UG"}, {"name": "Ukraine", "code": "UA"}, {"name": "United Arab Emirates", "code": "AE"}, {"name": "United Kingdom", "code": "GB"}, {"name": "United States", "code": "US"}, {"name": "United States Minor Outlying Islands", "code": "UM"}, {"name": "Uruguay", "code": "UY"}, {"name": "Uzbekistan", "code": "UZ"}, {"name": "Vanuatu", "code": "VU"}, {"name": "Venezuela", "code": "VE"}, {"name": "Viet Nam", "code": "VN"}, {"name": "Virgin Islands, British", "code": "VG"}, {"name": "Virgin Islands, U.S.", "code": "VI"}, {"name": "Wallis and Futuna", "code": "WF"}, {"name": "Western Sahara", "code": "EH"}, {"name": "Yemen", "code": "YE"}, {"name": "Zambia", "code": "ZM"}, {"name": "Zimbabwe", "code": "ZW"} ];

const COUNTRY_AUTOCOMPLETE_OPTIONS = {
      data: countries,
      getValue: "name",
      list: {
        match: {
          enabled: true
        },
        maxNumberOfElements: 10
      },
      template: {
        type: "custom",
        method: function(value, item) {
          return "<span class='flag flag-" + (item.code).toLowerCase() + "' ></span>" + value;
        }
      }
};

const CONTINENT_AUTOCOMPLETE_OPTIONS = {
      data: continents,
      getValue: "name",
      list: {
        match: {
          enabled: true
        },
        maxNumberOfElements: 10
      },
      template: {
        type: "custom",
        method: function(value, item) {
          return value;
        }
      }
};

const STATE_AUTOCOMPLETE_OPTIONS = {
      data: states,
      getValue: "name",
      list: {
        match: {
          enabled: true
        },
        maxNumberOfElements: 10
      },
      template: {
        type: "custom",
        method: function(value, item) {
          return value;
        }
      }
};

function createNewLocation(locationType, behindSceneLocationData, visualLocationData) {
  var data = [locationType, visualLocationData, behindSceneLocationData];
  return data.join(DATA_SEPARATOR);
}

function initAutocompleteForElem($elem, options) {
  $elem.easyAutocomplete(options);
}

function initEasyAutocompletes() {
  if (jQuery != undefined) {
    initAutocompleteForElem( jQuery(".countries-autocomplete"), COUNTRY_AUTOCOMPLETE_OPTIONS );
    initAutocompleteForElem( jQuery(".continents-autocomplete"), CONTINENT_AUTOCOMPLETE_OPTIONS );
    initAutocompleteForElem( jQuery(".states-autocomplete"), STATE_AUTOCOMPLETE_OPTIONS );

    jQuery('.select-manual-city-container, .select-manual-state-container').on("keydown", function(e) {   //Manual city selection stuff
      if (e.keyCode === 13) {
        e.preventDefault();
        var theWrap =  jQuery(this).closest('.ifso-autocomplete-selection-display')[0];
        var input = jQuery(this).find('input');
        var inputData = input.val().toLowerCase();
        var containerType = (typeof(input.attr('cond_type'))!=='undefined') ? input.attr('cond_type') : 'city';
        inputData = inputData.trim();
        inputData = titleCase(inputData);

        if (!inputData || inputData.length === 0)
          return false;

        var dataStr = containerType.toUpperCase() +'!!' + inputData + '!!' + inputData;
        newLocationSelected(theWrap,dataStr,inputData);
        input.val('');
      }
    });
  }
}

jQuery(document).ready(function(jQuery){
  if(!jQuery(".countries-autocomplete").length) return false;     //We're in the wrong page!
  // Enable EasyAutocomplete
  initEasyAutocompletes();

  jQuery("html").on("change", ".ifso-input-autocomplete", function() {
    var $elem = jQuery(this);
    var wholeGeolocationContainer = $elem.closest('.ifso-autocomplete-selection-display');
    var selectedCountry = $elem.getSelectedItemData();

    if (!selectedCountry || selectedCountry == -1) return;

    $elem.val(""); // Clear the input

    const selectedCountryName = selectedCountry.name;
    const selectedCountryCode = selectedCountry.code;
    const symbol = jQuery(this).data('symbol');

    var newLocationData = createNewLocation(symbol, selectedCountryCode, selectedCountryName);
    newLocationSelected(wholeGeolocationContainer[0], newLocationData, selectedCountryName);
  });

  jQuery("html").on("keypress focusout", ".page-visit-autocomplete", function(e) {
      if (e.keyCode === 13 || e.type === "focusout") {
          event.preventDefault();

          const $this = jQuery(this);
          const pageUrl = $this.val();
          if (pageUrl.length == 0)
            return;

          const operator = $this.closest('.selection-inputs-container').find('.ifso-page-visit-operator').val();
          const symbol = "PAGEURL";
          const wholeGeolocationContainer = $this.closest('.ifso-autocomplete-selection-display')[0];

          if(typeof(operator)!='undefined' && typeof(wholeGeolocationContainer)!= 'undefined'){
            // Add to the list
            const newLocationData = createNewLocation(symbol, operator, pageUrl);
            const position = createNewPositionForLocationSelection(wholeGeolocationContainer, newLocationData);

            // Add to the DOM
            const newFieldHTML = getAutocompletePageVisitFieldHTML(position, pageUrl, operator);
            const closestGeolocationFieldsContainer = wholeGeolocationContainer.querySelector('.ifso-autocomplete-fields-container');
            appendNewFieldToAutocompleteSection(closestGeolocationFieldsContainer, newFieldHTML);

            // Clear input
            $this.val("");
          }
          return false;
      }
  });

  jQuery("html").on("change", ".geo-timezone-selection", function() {
    if (this.selectedIndex > 0) {
      const timezoneName = this.value;
      const symbol = "TIMEZONE";
      const $elem = jQuery(this);
      const wholeGeolocationContainer = $elem.closest('.ifso-autocomplete-selection-display');
      const newLocationData = createNewLocation(symbol, timezoneName, timezoneName);
      newLocationSelected(wholeGeolocationContainer[0], newLocationData, timezoneName);

      this.selectedIndex = 0;
    }
  });

  // Deprecated
  jQuery("html").on("click", ".gelocation-add-btn", function(e) {
    e.stopPropagation();
    e.preventDefault();

    $elem = jQuery(this);
    $geoContainer = $elem.closest('.ifso-autocomplete-selection-display');
    $geoFieldsContainer = $geoContainer.find(".ifso-autocomplete-fields-container");
    $geoFieldsContainer.append(GEO_INPUT_TEMPLATE_CONTAINER);
    $lastAddedLocation = $geoFieldsContainer.find('span:last')[0];
    $lastAddedRemoveButton = $geoFieldsContainer.find('.locationField:last').find(".remove-autocomplete")[0];

    var data_pos = $geoFieldsContainer.find("input").length - 2;

    $lastAddedLocation.setAttribute('data-pos', data_pos);
    $lastAddedRemoveButton.setAttribute('data-pos', data_pos);
    // $lastAddedRemoveButton.style.display = 'none'; // Hide the remove button until text is typed down

    appendHiddenGeoVal($lastAddedLocation, ADDRESSES_SEPARATOR + "1");
    initCityAutocomplete($lastAddedInput);
  });

  jQuery("html").on("click", ".countries-autocomplete", function(e){
    e.stopPropagation();
    e.preventDefault();
  });

  jQuery("html").on("click", ".remove-autocomplete", function(e) {
    e.stopPropagation();
    e.preventDefault();

    $elem = jQuery(this);
    dataPos = $elem.data('pos');
    var $closestLocationField = $elem.closest('.locationField');
    var $geolocationFieldsContainer = $elem.closest('.ifso-autocomplete-fields-container');
    var $closestContainerParent = $elem.closest(".ifso-autocomplete-selection-display");
    var $locationsDescriptionElem = $closestContainerParent.find('.locations-description');
    var $nonSelectedTitle = $closestContainerParent.find('.none-selected');
    var $multipleSelectedTitle = $closestContainerParent.find('.multiple-selected');
    var $hiddenGeoField = $geolocationFieldsContainer.find('.ifso-autocomplete-data-field');
    var hiddenGeoVal = $hiddenGeoField.val();
    var normalizedAdrs = hiddenGeoVal.split(ADDRESSES_SEPARATOR);
    normalizedAdrs.splice(dataPos, 1); // Remove that autocomplete

    if (normalizedAdrs.length > 1)
      hiddenGeoVal = normalizedAdrs.join(ADDRESSES_SEPARATOR);
    else
      hiddenGeoVal = normalizedAdrs.join('')

    if (!hiddenGeoVal) {
      $geolocationFieldsContainer.removeClass("shown");
      $nonSelectedTitle.removeClass('hide-field');
      $multipleSelectedTitle.addClass('hide-field');
      $locationsDescriptionElem.addClass('hide-field');
    }

    // Update hidden field val's to current geolocations data
    $hiddenGeoField.val(hiddenGeoVal);

    // remove the selected item
    $closestLocationField.remove();

    // Update all elements data-poses
    $geolocationFieldsContainer.find(".locationField").each(function(indx, currLocationField) {
      var currSelectedLocation = currLocationField.querySelector('.specific-location');
      var currRemoveAutocompleteBtn = currLocationField.querySelector('.remove-autocomplete');
      currSelectedLocation.setAttribute('data-pos', indx);
      currRemoveAutocompleteBtn.setAttribute('data-pos', indx);
    });
  });

});


function initCityAutocomplete(elem,alt_cb=false) {
  // Create the autocomplete object, restricting the search to geographical location types.
  var autocomplete = new google.maps.places.Autocomplete(elem, autoCompleteSettings);

  google.maps.event.addDomListener(elem, 'keydown', function(event) {
    if (event.keyCode === 13) {
        event.preventDefault();
    }
  });
  var place_changed_cb = alt_cb!==false ? alt_cb : fillInAddress;
  // When the user selects an address from the dropdown, populate the address fields in the form.
  autocomplete.addListener('place_changed', function() {place_changed_cb(elem, this);});
}

function initAutocomplete() {
  var autocompletes = document.getElementsByClassName("autocomplete");

  for (var i = 0; i < autocompletes.length; i++) {
    var elem = autocompletes[i];
    // Create the autocomplete object, restricting the search to geographical location types.
    var autocomplete = new google.maps.places.Autocomplete(
      /** @type {!HTMLInputElement} */(elem),
      autoCompleteSettings);

    google.maps.event.addDomListener(elem, 'keydown', function(event) {
      if (event.keyCode === 13) {
          event.preventDefault();
      }
    });

    // When the user selects an address from the dropdown, populate the address fields in the form.
    autocomplete.ifsoElem = elem;
    autocomplete.addListener('place_changed', function() {fillInAddress(this.ifsoElem, this);});
  }
}


// Helper funcs encaplusates the updates to the hidden geo input field
function getHiddenGeoField(elem) {
  var closestContainerParent = getClosest(elem, '.ifso-autocomplete-fields-container');
  var hiddenField = closestContainerParent.querySelector('.ifso-autocomplete-data-field');

  return hiddenField;
}

function getHiddenGeoVal(elem) {
  var hiddenFieldVal = getHiddenGeoField(elem).value;
  return hiddenFieldVal;
}

function updateHiddenGeoVal(elem, newInputVals) {
  var hiddenField = getHiddenGeoField(elem);
  hiddenField.value = newInputVals;
}

function appendHiddenGeoVal(elem, appendText) {
  updateHiddenGeoVal(elem, getHiddenGeoVal(elem) + appendText);
}

function getRemoveButtonField(elem) {
  var closestContainerParent = getClosest(elem, '.locationField');
  var removeAutocompleteBtn = closestContainerParent.querySelector('.remove-autocomplete');

  return removeAutocompleteBtn;
}

function getAutocompleteGeoFieldHTML(position, location) {
  var newField = GEO_INPUT_TEMPLATE_CONTAINER;
  newField = newField.replace("{DATA_POS}", position);
  newField = newField.replace("{LOCATION}", location);

  return newField;
}

function getAutocompletePageVisitFieldHTML(position, location, operator) {
  var newField = PAGE_VISIT_INPUT_TEMPLATE_CONTAINER;
  newField = newField.replace("{DATA_POS}", position);
  newField = newField.replace("{LOCATION}", location);
  newField = newField.replace("{OPERATOR}", operator);

  return newField;
}

function appendNewFieldToAutocompleteSection(container, field) {
  container.insertAdjacentHTML( 'beforeend', field);
}

function createNewPositionForLocationSelection(wholeGeolocationContainer, newLocationData) { // refactor this method
  if(wholeGeolocationContainer && typeof(wholeGeolocationContainer)!='undefined'){
    var locationsDescriptionElem = wholeGeolocationContainer.querySelector('.locations-description');
    var closestGeolocationFieldsContainer = wholeGeolocationContainer.querySelector('.ifso-autocomplete-fields-container');
    var selectionTitleContainer = wholeGeolocationContainer.querySelector('.selection-title');
    var nonSelectedTitle = selectionTitleContainer.querySelector('.none-selected');
    var multipleSelectedTitle = selectionTitleContainer.querySelector('.multiple-selected');
    var hiddenField = closestGeolocationFieldsContainer.querySelector('.ifso-autocomplete-data-field');
    var hiddenFieldVal = hiddenField.value;
    var position = -1;

    if (hiddenFieldVal) {
      // Adding
      hiddenFieldVal += ADDRESSES_SEPARATOR + newLocationData;
      position = hiddenFieldVal.split(ADDRESSES_SEPARATOR).length - 1; // Minus this iteration addition

      // let newAutocompleteField = createNewAutocompleteFieldCallback(dataPos, newLocation);
      // appendNewFieldToAutocompleteSection(closestGeolocationFieldsContainer, dataPos, newLocationGUI);
    } else {
      // Creating
      hiddenFieldVal = newLocationData;
      position = 0;
      // appendNewFieldToAutocompleteSection(closestGeolocationFieldsContainer, dataPos, newLocationGUI);

      // Making all the relevant components visible with their appropriate classes
      closestGeolocationFieldsContainer.className = "ifso-autocomplete-fields-container shown"; // showing
      multipleSelectedTitle.className = "multiple-selected"; // showing (by removing 'hide-field')
      nonSelectedTitle.className = "none-selected hide-field"; // hiding
      locationsDescriptionElem.className = "locations-description"; // showing (by removing 'hide-field')
    }
    hiddenField.value = hiddenFieldVal;

    return position;
  }
}

function newLocationSelected(wholeGeolocationContainer, newLocationData, newLocationGUI) {
  const position = createNewPositionForLocationSelection(wholeGeolocationContainer, newLocationData);

  // Add to the DOM
  const newFieldHTML = getAutocompleteGeoFieldHTML(position, newLocationGUI);
  const closestGeolocationFieldsContainer = wholeGeolocationContainer.querySelector('.ifso-autocomplete-fields-container');
  appendNewFieldToAutocompleteSection(closestGeolocationFieldsContainer, newFieldHTML);
}

function fillInAddress(elem, autocomplete) {
  // Get the place details from the autocomplete object.
  // TODO: proper docs
  var place = autocomplete.getPlace();
  var closestContainerParent = getClosest(elem, '.ifso-autocomplete-selection-display');
  var vicinity = (place.vicinity) ? place.vicinity : "";
  var formattedAddress = place.formatted_address;
  elem.value = "";
  var newCityData = createNewLocation(CITY, vicinity, formattedAddress);
  newLocationSelected(closestContainerParent, newCityData, formattedAddress);
}

function titleCase(str) {
  var splitStr = str.toLowerCase().split(' ');
  for (var i = 0; i < splitStr.length; i++) {
    // You do not need to check if i is larger than splitStr length, as your for does that for you
    // Assign it back to the array
    splitStr[i] = splitStr[i].charAt(0).toUpperCase() + splitStr[i].substring(1);
  }
  // Directly return the joined string
  return splitStr.join(' ');
}